unit hydrol;
{$R-}    {Range checking off}
{$B+}    {Boolean complete evaluation on}
{$S+}    {Stack checking on}
{$I+}    {I/O checking on}
{$N-}    {No numeric coprocessor}


INTERFACE

  Uses
    Crt,Printer,Turbo3,dos,types,
    turbolib{,comm300,msdosdir};

  procedure hydrolin_heading;procedure help_hydrolin;
  procedure Help_UH; procedure Help_NASH;
  PROCEDURE File_Name_Num; PROCEDURE File_Renum;
  PROCEDURE File_Text; PROCEDURE Input_File;
  PROCEDURE Keyboard_Input;Procedure Input_Menu;
  PROCEDURE Hydr_Edit; Procedure Time_Step;
  Procedure Area_Define; Procedure Zero_Wiping;
  Procedure Initial_Loss; Procedure Phi_Index;
  Procedure Nett_Precip; Procedure Precip_Conversion;
  Procedure Accumul_Nett_Precip;Procedure Precip_loss;
  Procedure Precip_Menu; procedure Help_Okelly;

implementation


(**************************************************************
* Hydrolin_Heading; Help_Hydrolin; Help_UH;Help_NASH;Help_TANK*
* Help_Menu.                                                  *
**************************************************************)

(*===========================================================*)
PROCEDURE HYDROLIN_Heading;
(*===========================================================*)

BEGIN
FOR TEL:=1 TO 24 DO WriteLn;Delay(1000);
WriteLn('   H H H H H H H H H H H H H H H H H H H H H H H H H');
WriteLn('   H                                               H');
WriteLn('   H                                               H');
WriteLn('   H              //  //                           H');
WriteLn('                 //  //                             ');
WriteLn('                //--//                              ');
WriteLn('               //--//  Y D R O L I N  version 4.00  ');
WriteLn('   H          //  //                               H');
WriteLn('   H                                               H');
WriteLn('   H                                               H');
WriteLn('   H   INTERACTIVE HYDROLOGICAL COMPUTERPROGRAM    H');
WriteLn('   H                                               H');
WriteLn('   H        TU DELFT/Ct (C) 880226 M.J. Vos        H');
WriteLn('   H        TU DELFT/Ct (C) 880701 C.T. Chang      H');
WriteLn('   H                                               H');
WriteLn('   H                                               H');
WriteLn('   H             UNIVERSITY OF TECHNOLOGY  DELFT   H');
WriteLn('   H             DEPARTMENT OF CIVIL ENGINEERING   H');
WriteLn('   H                                               H');
WriteLn('   H                                               H');
WriteLn('   H                                               H');
WriteLn('   H H H H H H H H H H H H H H H H H H H H H H H H H');
LV;WriteLn;WriteLn('   WAIT !');HV;
Delay(5000);
Scroll;
END;


(*===========================================================*)
PROCEDURE Help_Hydrolin;   (* INTRODUCTION AND INFO HYDROLIN *)
(*===========================================================*)

BEGIN
ClrScr;
LV;WriteLn('HYDROLIN Help page');HV;
WriteLn;
WriteLn('HYDROLIN is een interactief hydrologisch analyse-,');
WriteLn('programma dat menugericht U ten dienste wil staan.');
WriteLn('Hierbij wordt U gevraagd om gegevens en een keuze ');
WriteLn('uit opties. Stapt u uit een menu dan komt u terug');
WriteLn('in het hoofd menu enkunt u opnieuw een traject kie-');
WriteLn('zen.Een manual is dientengevolge niet strikt nodig.');
WriteLn;
WriteLn('Voorlopig is geimplementeerd :                     ');
WriteLn;
WriteLn('DE METHODE VAN DE EENHEIDSAFVOERGOLF-UNIT HYDROGRAPH');
Delay(500);PressKey;
END; (*Help_Hydrolin *)

(*===========================================================*)
PROCEDURE Help_UH;                   (* INFO UNIT HYDROGRAPH *)
(*===========================================================*)

BEGIN
ClrScr;
LV;WriteLn('UNIT HYDROGRAPH Help page');HV;
WriteLn;
WriteLn('De METHODE VAN DE EENHEIDSAFVOERGOLF berust op empi-');
WriteLn('risch gevonden relaties -L.K. Sherman 1932- en dient');
WriteLn('ter bepaling van oppervlakteafvoercomponent( afvoer)');
WriteLn('die ontstaat ten gevolge van de gemiddelde netto ne-');
WriteLn('erslag; deze neerslag wordt gelijkmatig verdeeld ge-');
WriteLn('dacht over het stroomgebied. De grootte(A)van het');
WriteLn('stroomgebied heeft een bovengrens van ca. 10.000 km2');
WriteLn('Bij de METHODE VAN DE EENHEIDSAFVOERGOLF wordt uitg-');
WriteLn('egaan van een EENHEIDSDIEPTE-UNIT DEPTH -b.v. 1 inch');
WriteLn('of een EENHEIDSVOLUME A ,gelijkmatig verdeeld over ');
WriteLn('het stroomgebied.                             ');
WriteLn('De tijdsduur van een enkelvoudige bui wordt DT geno-');
WriteLn('emd Vanaf het einde van de bui tot het einde van de ');
WriteLn('eenheidsafvoerkromme is de tijdsduur TR - de AFLOOP-');
WriteLn('TIJD.Het afvoerdebiet wordt weergegeven als Q(q=Q/A)');
WriteLn('Een over een bepaalde tijd gemeten neerslagkromme kan');
WriteLn('worden opgedeeld in een aantal enkelvoudige buien van');
WriteLn('zo mogelijk zelfde tijdsduur DT.                 ');
WriteLn;
PressKey;
WriteLn('Allereerst zult u data moeten invoeren. Dit geschiedt');
WriteLn('via INPUT/KEYBOARD naar een bestand op schijf. Veran-');
WriteLn('deringen hieraan moeten worden gedaan met een EDITER.');
WriteLn('Allerlei manipulaties met bestanden kunnen worden ');
WriteLn('gedaan met COMMAND(=MSDOS commandos)of FILEHANDLING.');
WriteLn('Vervolgens kunt u Regenverliezen PRECIP en Afvoersch-');
WriteLn('eiding(en)DISCH invoeren, welke eveneens op schijf  ');
WriteLn('worden gezet onder een voor u kenmerkende naam.      ');
WriteLn('De bij elkaar behorende bruto en verlies-datafiles ');
WriteLn('leveren netto-datafiles op.Vergelijking van geaccumu-');
WriteLn('leerde netto regen met afvoer is dan mogelijk.Repeti-');
WriteLn('tie van elk procedee is mogelijk tot een aantal van  ');
WriteLn('gemodificeerde gelijksoortige bestanden op schijf.Het');
WriteLn('beheer geschiedt door twee geimplemenprocedures welke');
WriteLn('u vragen om characters t.b.v. identificatie specific-');
WriteLn('atie en volgnummer.Door filemanipulaties is het moge-');
WriteLn('lijk meer bestanden te bewaren b.v. onder een andere ');
WriteLn('naam,op een andere schijf, op een andere drive etc.De');
WriteLn('GRAPHICS-optie biedt de mogelijkheid tot graphische ');
WriteLn('weergave met HYDROGR en eventuele terugkeer in HYDRO-');
WriteLn('LIN.                ');
PressKey;
END;  (* HELP_UH *)

(*============================================================*)
PROCEDURE Help_NASH;            (* INFO NASH CASCADE *)
(*============================================================*)

BEGIN
ClrScr;
LV;WriteLn('NASH CASCADE Help page');HV;
WriteLn;
WriteLn('   In 1957, J.E. Nash derived the two parameters con-');
WriteLn('ceptual mathematical model using the linear reservoir');
WriteLn('concept:S=K*Q.Storage(S) is in proportion to the out-');
WriteLn('flow(Q).An instantaneous inflow,with volume V, put in');
WriteLn('the first reservoir,its flow will instantaneous rise');
WriteLn('from 0 to V/K, that is:I=0,S=V,O=V/K.Using the cont- ');
WriteLn('inuity equation,We get :Q=(V/K)*EXP(-T/K).The outflow');
WriteLn('of the first reservoir flow to the second reservoir,');
WriteLn('taking the same proces we get the outflow for the se-');
WriteLn('cond reservoir is: Q=(V/K)*EXP(-T/K)*(T/K). Likewise ');
WriteLn('the n-th reservoir :Q=(V/K)*(T/K)**(n-1)*EXP(-T/K)/  ');
WriteLn('Gamma(n). The peak flow and peak time can be derived ');
WriteLn('by taking the deviation of the above equation with t/k');
WriteLn('to be zero:Tm=(N-1)*K ,Um=(1/K*Gamma(N))*EXP(-(N-1))*');
WriteLn('(N-1)**(N-1).The instantaneous unit hydrograph of 1 cm');
WriteLn('ER is: U(0,t)=(2.78/K*Gamma(n))*EXP(-T/K)*(T/K)**(N-1)');
WriteLn('. In order to determin K and N for a watershed, we ');
WriteLn;
Delay(500);PressKey;
Scroll;ClrScr;
WriteLn('can use the effective rainfall histogram(ERH) and dir-');
WriteLn('ect runoff hydrograph(DRH), apply the moment method to');
WriteLn('derive it. From the moment method study we have the ');
WriteLn('following relations:  M1(IUH)=M1(DRH)-M1(ERH)=N*K    ');
WriteLn('   M2(IUH)=M2(DRH)-M2(ERH)-2*N*K*M1(ERH)=N*(N+1)*K*K ');
WriteLn('From the above two equations we can determine the two');
WriteLn('parameters N and K.  For the practical application, we');
WriteLn('need to derive the unithydrograph U(T,t)with effective');
WriteLn('rainfall duration T,from the instantaneous unit hydro-');
WriteLn('graph through the  summation hydrograph. That is:     ');
WriteLn('U(T,t)=1/T *[S(t)-S(t-T)]=1/T*[Ig((t/k)/N**(1/2)),N-1)');
WriteLn('-Ig((t/k)/N**(1/2))-T,N-1)].        ');
WriteLn('U(deltat,t)=(U(0,t)+U(0,t-deltat))/2  ');
WriteLn('Using matrix inversion we can get hydrograph: (P)*(U)');
WriteLn('=(Q)This model can also do the semisimulation approach');
WriteLn(':from the ERH and DRH using moment method to determind');
WriteLn('the initial value of K and N,then give deltak and del-');
WriteLn('tan using deterministic coefficient to do the best fit');
WriteLn('proces approach. After best fit K and N is decided, we');
WriteLn('can use it in forcasting any storm.It is also possible');
WriteLn('to HYDROGR in HYDROLIN for grafics picture.    ');
PressKey;
WriteLn(' NASH model  execute the following procedure: ');
WriteLn('1. see the helpful message                           ');
WriteLn('2. use the input menu to select the input data       ');
WriteLn('  - copy the exist file and edit the copied file     ');
WriteLn('  - using the existing file                          ');
WriteLn('  - modified the existing file and then to use it    ');
WriteLn('3. give catchment area in km square                  ');
WriteLn('  give unit depth of UH in mm (10mm or 20mm)         ');
WriteLn('4. get the first aproach k, n and R2 value           ');
WriteLn('  compare measured DRH and calculated DRH            ');
WriteLn('5. using autosimulation or semisimulation to improve');
WriteLn('  the k and n value                                  ');
WriteLn('6. deltak and deltan must smaller than 0.01          ');
WriteLn('7. store the best fit unit hydrograph for forcasting ');
WriteLn('8. using the graphics floppy to compare the measured ');
WriteLn(' and calculated DRH ( use HYDROGR command line )     ');
PressKey;

END;  (* HELP_NASH *)

(*============================================================*)
PROCEDURE Help_OKELLY;            (* INFO OKELLY MODEL *)
(*============================================================*)
BEGIN;
Clrscr;
WriteLn('OKELLY MODEL Help page');HV;
WriteLn;
WriteLn(' OKELLY Model was suggested by Okelly in 1949.  Its');
WriteLn('concept is considered the rainfall-runoff structure');
WriteLn('of watershed to be composed of an isosceles triangle');
WriteLn('lateral inflow routed through a linear reservoir.  ');
WriteLn(' Okelly model is a two parameters model (T an K). ');
WriteLn('The input data, that are used in the model are only');
WriteLn('effective rainfal & direct runoff,which are derived');
WriteLn('HYDROLIN input menu.Its file name can be PNn.dat and');
WriteLn('QNn.dat (n=0..n). With the help of moment method');
WriteLn('first approach of these two parameters can be derived');
WriteLn('.Using the coefficient of determination acting as');
WriteLn('assessment criteria, one can improve these two');
WriteLn('parameters by using the simulation technique');
PressKey;
WriteLn(' Okelly model  execute the following procedure: ');
WriteLn('1. see the helpful message                      ');
WriteLn('2. use the input menu to select the input data  ');
WriteLn('  - copy the exist file and edit the copied file');
WriteLn('  - using the existing file                     ');
WriteLn('  - modified the existing file and then to use it');
WriteLn('3. give catchment area in km square             ');
WriteLn('  give unit depth of UH in mm (10mm or 20mm)    ');
WriteLn('4. get the first aproach k, T and R2 value      ');
WriteLn('  compare measured DRH and calculated DRH       ');
WriteLn('5. using autosimulation or semisimulation to ');
WriteLn('   improve the k and T value        ');
WriteLn('6. deltak and deltaT may be any value           ');
WriteLn('7. store the best fit unit hydrograph for forcasting');
WriteLn('8. using the graphics floppy to compare the ');
WriteLn('  measured and calculated DRH ( HYDROG command) ');
PressKey;
END;  (* HELP_OKELLY *)

(***************************************************************
* HYDROL01.INC                                                 *
*                                                              *
* CONTENTS :                                                   *
*                                                              *
* MISCELLANEOUS HYDROLIN-PROCEDURES  TU DELFT / M.J.Vos / 1988 *
****************************************************************
* File_Name_Num; File_Renum; File_Text; Input_File; Keyboard_  *
* Input; Input_Menu; Hydr_Edit.                                *
***************************************************************)


(*============================================================*)
PROCEDURE File_Name_Num;
(*============================================================*)

BEGIN
 REPEAT
  Writeln;
  Write('             *** DATA-FILE : NAME / NUMBER ***');
  WriteLn;Delay(500);
  LV;Write('Default drive is');HV;Write(' "space"=main  ');
  WriteLn;Delay(500);
 {LV;WriteLn('Give your file-identification : ');WriteLn;
  Write('of exactly');HV;Write(' 5 ');LV;Write('characters ');
  WriteLn('without: drivenr, and filetype:',Chr(22));
  WriteLn;Write('XXXXX',Chr(13));HV;Readln(FNM);WriteLn;
  Delay(500);} Write('Give the drive name: (a: ,b: or c: ) ');
  Readln(fnm);
  LV;WriteLn('Give your file-specification : ');WriteLn;
  HV;Write('PB');LV;Write(' = bruto             precipitation;');
  WriteLn;
  HV;Write('PW');LV;Write(' = zeros wiped      precipitation ;');
  WriteLn;
  HV;Write('PI');LV;Write(' = initial losses    precipitation;');
  WriteLn;
  HV;Write('PF');LV;Write(' = phi-index loss    precipitation;');
  WriteLn;
  HV;Write('PU');LV;Write(' = user-def loss     precipitation;');
  WriteLn;
  HV;Write('PN');LV;Write(' = nett              precipitation;');
  WriteLn;
  HV;Write('PT');LV;Write(' = accumulated nett  precipitation;');
  WriteLn;WriteLn;Delay(500);
  HV;Write('QB');LV;Write(' = bruto             discharge;');
  WriteLn;
  HV;Write('QC');LV;Write(' = constant separ.  discharge ;');
  WriteLn;
  HV;Write('QL');LV;Write(' = linear separation discharge ;');
  WriteLn;
  HV;Write('QU');LV;Write(' = user-def separ.   discharge ;');
  WriteLn;
  HV;Write('QN');LV;Write(' = nett              discharge;');
  WriteLn;
  HV;Write('QW');LV;Write(' = zeros wiped       discharge');
  WriteLn;
  HV;Write('QT');LV;Write(' = accumulated nett  discharge;');
  WriteLn;WriteLn;
  HV;Write('UH');LV;Write(' = unit hydrograph            .');
  WriteLn;WriteLn;
  Write('XX',Chr(13));HV;Readln(FileSpec);WriteLn;
  LV;Write('Give your file-number : (');HV;Write('0,1,2');
  LV;Write(' or');HV;Write(' 3) :');WriteLn;WriteLn;
  Write('X',Chr(13));HV;Readln(FileNume);WriteLn;
  WriteLn(Chr(22));
  FileName:=Concat(FNM,FileSpec,FileNume,'.DAT');
  IF Exist(FileName) = True THEN
  BEGIN
   Bell;
   WriteLn(FileName,' already exists !');Delay(1000);
   WriteLn('You should assemble another name ');
   Write('or do you want to overwrite an existing file ?');LV;
   Write(' (Y/N)');HV;WriteLn;Read(Kbd,Ch);
  END;
 UNTIL (Exist(FileName) = False) OR (Ch IN ['y','Y']);
END; (* File_Name_Num *)


(*==========================================================*)
PROCEDURE File_Renum;
(*==========================================================*)

Label  DoIt;

BEGIN
 Write('                  *** DATA-FILE : RENUMBER ***');
 WriteLn;Delay(500);
 LV;Write('Default drive is ');HV;Write('"space"=main drive');
 LV;WriteLn; WriteLn; Delay(500); WriteLn
 ('If you desire substitutions in the source-program,consult');
 HV;WriteLn('                TU DELFT / HOLLAND.');WriteLn;
 WriteLn; Write('Do you want to use File_Handling ?  ');
 LV;Write('(Y/N)');HV; Read(Kbd,Ch);WriteLn;IF Ja THEN
 File_Handling; FNM:=Copy(FileName,1,2);
 FileSpec:=Copy(FileName,3,4); FileNumE:=Copy(FileName,5,5);
 IF FileNumE='0' THEN
 BEGIN FileNumR:='1';GOTO DoIt; END ELSE
 IF FileNumE='1' THEN
 BEGIN FileNumR:='2';GOTO DoIt; END ELSE
 IF FileNumE='2' THEN
 BEGIN FileNumR:='3';GOTO DoIt; END ELSE
 IF FileNumE='3' THEN
 BEGIN
  LV;Write('Overwrite an existing datafile ? ');HV;
  Write('(Y/N)');Read(Kbd,Ch);WriteLn;
  IF Ja THEN
  REPEAT
   LV;Write('Give datafile-');HV;Write('number : ');
   GotoXY(20,2);Readln(FileNumR);WriteLn;
  UNTIL Yes('... are you sure ?') ELSE
  BEGIN
   WriteLn('This edited version will be saved as number 4,');
   WriteLn('but will be operable after: Copy/Delete/Rename');
   WriteLn('with sequence-number 1,2 or 3 in FileHandling.');
   WriteLn; FileNumR:='4';
  END;
 END;
 DoIt:
 FileName:=Concat(FNM,FileSpec,FileNumR,'.DAT');
END; (* File_Renum *)


(*============================================================*)
PROCEDURE File_Text; {Implemented with six textlines}
(*============================================================*)

BEGIN
  Scroll;ClrScr;
  GotoXY(20,1);Write('*** DATA-FILE : TEXT ***');WriteLn;
  LV;Write('Project/version/Nr.                   : ');HV;
  Readln(Titel);
  Write('Date      (jjmmdd)                    : ');
  Readln(jjmmdd);
  Write('Dimension of ',StrPQ:20,'     : ');
  Readln(DimStrPQ);
  Write('Dimension of ',Strt:20,'     : ');
  Readln(DimStrt);
  Seq:='SEQ.NR';Spc:='      ';
  WriteLn(FV,'Project/Version/Nr.      : ',Titel);
  WriteLn(FV,'Date      (jjmmdd)       : ',jjmmdd);
  WriteLn(FV);
  WriteLn(FV,Seq:6,StrPQ:20,Strt:20);
  WriteLn(FV,Spc:6,DimStrPQ:20,DimStrt:20);
  WriteLn(FV);
  Scroll;ClrScr;
END; (* File_Text *)


(*============================================================*)
PROCEDURE Input_File;
(*============================================================*)
LABEL
    Start;
{VAR  bTEL,fTEL,TEL,MaxTEL,Bf : Integer;
                         Af  : Real   ;}
BEGIN
Writeln;
Start:
 Write('Give input-filename '); Write('(d:inputfile.dat) : ');
 WriteLn; Readln(FileName);WriteLn;
 IF Exist(FileName)=False THEN
 BEGIN
  Bell;
  WriteLn('File does not exist !');
  Delay(3000);
 END;
 IF Exist(FileName)=False THEN GOTO Start;

Assign(FV,FileName);
Reset(FV);
WriteLn;
FOR TEL:=0 TO Arr_Afm DO
BEGIN
 PQ[TEL]:=0.0E00;
 t[TEL]:=00;
END; (* Initialisation *)

BEGIN
FOR tTEL:=1 TO 3 DO
 BEGIN
  Readln(FV,Line);
   WriteLn(Line);
 END;
 ReadLn(FV,Seq,StrPQ,Strt);
 WriteLn(Seq:6,StrPQ:20,Strt:20);
 ReadLn(FV,Spc,DimStrPQ,DimStrt);
 WriteLn(Spc:6,DimStrPQ:20,DimStrt:20);
 Readln(FV,Line);
 WriteLn(Line);
 Delay(200);
END; (* Text *)
fTEL:=0;bTEL:=1;
 REPEAT
  fTEL:=fTEL+1;
  IF fTEL=bTEL*15 THEN
  BEGIN
   bTEL:=bTEL+1;
   WriteLn;PressKey;
   Scroll;ClrScr;
   WriteLn;
   WriteLn(Seq:6,StrPQ:20,Strt:20);
   WriteLn(Spc:6,DimStrPQ:20,DimStrt:20);
   WriteLn('-----------------------------------------------');
   WriteLn;
  END;
   Readln(FV,fTEL,Af,Bf);
  TEL:=fTEL;
  PQ[TEL]:=Af;
  t[TEL]:=Bf;
  WriteLn(TEL:6,PQ[TEL]:20:3,t[TEL]:20);
  Delay(200);
 UNTIL Eof(FV);
MaxTEL:=TEL;
Close(FV);

REPEAT
 WriteLn;
 Write('Repeated display of the file-contents ?  ');LV;
 Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;Scroll;ClrScr;
 IF JA THEN
 BEGIN
  WriteLn;
  WriteLn(Seq:6,StrPQ:20,Strt:20);
  WriteLn(Spc:6,DimStrPQ:20,DimStrt:20);
  WriteLn('-----------------------------------------------');
  WriteLn;
  BEGIN
   bTEL:=1;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF TEL=bTEL*15 THEN
    BEGIN
     bTEL:=bTEL+1;
     WriteLn;PressKey;
     Scroll;ClrScr;
     WriteLn;
     WriteLn(Seq:6,StrPQ:20,Strt:20);
     WriteLn(Spc:6,DimStrPQ:20,DimStrt:20);
     WriteLn('-----------------------------------------------');
     WriteLn;
    END;
    WriteLn(TEL:6,PQ[TEL]:20:3,t[TEL]:20);
    Delay(200);
   END;
  END;
 END;
UNTIL Nee;
END; (* Input_File *)


(*============================================================*)
PROCEDURE Keyboard_Input;
(*============================================================*)

LABEL Exit;

BEGIN
 ClrScr;

 FOR TEL:=0 TO Arr_Afm DO
 BEGIN
  PQ[TEL]:=0.0E00;
  t[TEL]:=00;
 END; (* Initialisering *)

 GotoXY(1,1);Write(Seq);
 GotoXY(15,1);Write(StrPQ);GotoXY(40,1);Write(Strt);LV;
 GotoXY(1,2);Write('----------------------------------------');
 HV;TEL:=0;
 REPEAT
  TEL:=TEL+1;
  GotoXY(1,TEL+3);Write(TEL:6);
  GotoXY(15,TEL+3);Readln(Apr);
  GotoXY(40,TEL+3);Readln(Bpr);
  PQ[TEL]:=Apr;
  t[TEL]:=Bpr;
  GotoXY(1,TEL+4);LV;
  Write('Continue with <RETURN> <<==>> Stop with  S ');
  Read(Kbd,Ch);  ClrLine(1,TEL+4);HV;
 UNTIL (Ch IN ['S','s']);
 MaxTEL:=TEL;
 Scroll;ClrScr;
 Write(Seq:6);Write(StrPQ:20);Write(Strt:20);WriteLn;
 LV;WriteLn('-----------------------------------------');HV;
 WriteLn;
 REPEAT
  BEGIN
   bTEL:=1;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF TEL=bTEL*15 THEN
    BEGIN
     bTEL:=bTEL+1;
     WriteLn;PressKey;
     Scroll;ClrScr;
     Write(Seq:6);Write(StrPQ:20);Write(Strt:20);WriteLn;
     LV;Write('----------------------------------------');HV;
     WriteLn;
    END;
    WriteLn(TEL:6,PQ[TEL]:20:3,t[TEL]:20);
    Delay(200);
   END;
  END;
  WriteLn;
  Write('Repeated display of the file-contents ?  ');LV;
  Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;Scroll;ClrScr;
 UNTIL Nee;
 Write('SAVE keyboard-input ?');LV;Write(' (Y/N)');
 HV;Read(Kbd,Ch);WriteLn;ClrScr;
 IF Nee THEN GOTO EXIT ;
 IF Ja THEN
 REPEAT
  File_Name_Num;
  IF Exist(FileName)=True THEN
  BEGIN
   Bell;
   WriteLn(FileName,' exists !');
   Delay(1000);
   Write('Overwrite ',FileName,' ?');LV;Write(' (Y/N)');HV;
   Read(Kbd,Ch);WriteLn;
  END;
 UNTIL ((Exist(FileName)=False) OR Ja);
 Assign(FV,FileName);
 ReWrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 BEGIN
  fTEL:=TEL;
  Af:=PQ[TEL];
  Bf:=t[TEL];
  WriteLn(FV,fTEL:6,Af:20:3,Bf:20);
 END;
 Close(FV);
 Exit:
 PressKey;
END; (* Keyboard_Input *)
(*============================================================*)
PROCEDURE Input_Menu;
(*============================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='INPUT MENU';
  CASE Menu('Keyboard Filehandling Inputfile Test Quit') OF

      'F' :  BEGIN
              File_Handling;
             END;
      'K' :  BEGIN
              WriteLn('Used for first input of data.');
              WriteLn('For modifications use the I option.');
              Write('Do you want to continue ? (Y/N)');
              HV;Read(Kbd,Ch);WriteLn;PressKey;
              IF Ja THEN Keyboard_Input ELSE
             END;
      'I' :  BEGIN
              WriteLn('Used for modifications. ');Delay(1000);
              WriteLn('Use for first input data the K option.');
              Write('Do you want to continue ? (Y/N)');
              HV;Read(Kbd,Ch);WriteLn;{PressKey;}
              IF Ja THEN Input_File ELSE
             END;
      'T' :  BEGIN
              LV;WriteLn('TestFiles :');
              Write('Precipitation : ');HV;Delay(1000);
              Write('b:PB0.DAT');WriteLn;LV;
              Write('Discharge     : ');HV;Delay(1000);
              Write('b:QB0.DAT');WriteLn;
              Write('Do you want to continue ? (Y/N) ');HV;
              WriteLn;Read(Kbd,Ch);
              IF Ja THEN Input_File ELSE
             END;
      'Q' :  BEGIN
              IF Yes('... are you sure ?') THEN Quit:=True;
             END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
 Scroll;ClrScr;
END; (* Input-Menu *)

(*============================================================*)
PROCEDURE Hydr_Edit;
(*============================================================*)

LABEL Exit;

{VAR   bTEL :Integer;}

BEGIN
 Scroll;GotoXY(20,12);
 Write('      /// HYDR');LV;Write('olin-');HV;Write('EDIT');
 LV;Write('er ');HV;Write('1.00 ///  ');
 Delay(3000);Scroll;ClrScr;
 WriteLn('You will see the contents of a chosen input-file.');
 WriteLn('Afterwards remember the line-numbers to be edit !');
 {PressKey;}Writeln;
 Input_File;
 Write('Do you want to continue with HYDREDIT ?  ');LV;
 Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;IF Nee THEN GOTO Exit;
 REPEAT
  PressKey;
  GotoXY(1,1);LV;WriteLn('HYDREDIT 1.00');HV;
  GotoXY(1,5);Write(Seq:6);
  GotoXY(15,5);Write(StrPQ:20);GotoXY(40,5);Write(Strt:20);LV;
  GotoXY(1,6);Write('----------------------------------------');
  HV;WriteLn;
  sTEL:=0;
  REPEAT
   GotoXY(1,7+sTEL);Write(Seq:6,' : ');GotoXY(20,1);Readln(TEL);
   GotoXY(1,7+sTEL);ClrEol;
   GotoXY(1,7+sTEL);Write(TEL:6);
   GotoXY(15,7+sTEL);Write(PQ[TEL]:20);LV;Write(' wordt ');
   HV;Af:=PQ[TEL];GotoXY(50,7+sTEL);Readln(Af);PQ[TEL]:=Af;
   GotoXY(15,7+sTEL);ClrEol;Write(PQ[TEL]:20);
   GotoXY(40,7+sTEL);Write(t[TEL]:20);LV;Write(' wordt ');
   HV;Bf:=t[TEL];GotoXY(70,7+sTEL);Readln(Bf);t[TEL]:=Bf;
   GotoXY(40,7+sTEL);ClrEol;
   Write(t[TEL]:20);WriteLn;WriteLn;
   GotoXY(1,23);LV;Write('More ?   (Y/N)');Read(Kbd,Ch);
   GotoXY(1,23);ClrEol;
   WriteLn;HV;
   sTEL:=sTEL+1;
  UNTIL Nee;
  REPEAT
   Scroll;ClrScr;
   GotoXY(1,1);LV;WriteLn('HYDREDIT 1.00');HV;
   GotoXY(1,5);Write(Seq:6);
   Write(StrPQ:20);Write(Strt:20);LV;
   GotoXY(1,6);Write('----------------------------------------');
   HV;WriteLn;
   TEL:=1;bTEL:=1;
   WHILE t[TEL]<>00 DO
   BEGIN
    WriteLn(TEL:6,PQ[TEL]:20:3,t[TEL]:20);
    Delay(200);
    TEL:=TEL+1;
    IF TEL=bTEL*15 THEN
    BEGIN
     bTEL:=bTEL+1;
     WriteLn;PressKey;
    END; (* Block *)
   END;
   WriteLn;WriteLn;WriteLn('End of data-file.');
   WriteLn;Write('Repeated display of file-contents ?  ');LV;
   Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;
  UNTIL Nee; ClrScr;
  WriteLn;WriteLn;GotoXY(1,12);
  Write('      ||| End of Edit-session ||| ?  ');LV;
  Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;
 UNTIL (Ja AND Yes('... o.k. ?'));
 Write('Save data ?  ');LV;Write(' (Y/N)');Read(Kbd,Ch);WriteLn;
 IF Ch in ['Y','y'] THEN {Save_Data}
 BEGIN
  LV;Write('Previous FileName                        : ');HV;
  Write(FileName);WriteLn;
  REPEAT
  File_Renum;
  LV;Write('Next FileName in sequence    : ');HV;
  Write(FileName);WriteLn;
  IF Exist(FileName)=True THEN
   BEGIN
    Bell;WriteLn(FileName,' exists !');
    Delay(1000);
    WriteLn('Overwrite ',FileName,' ?');LV;Write(' (Y/N)');HV;
    Read(Kbd,Ch);WriteLn;
   END;
  UNTIL ((Exist(FileName)=False) OR Ja);
  Assign(FV,FileName);
  Rewrite(FV);
  File_Text;
  TEL:=1;
  WHILE t[TEL]<>0 DO
  BEGIN
   fTEL:=TEL;
   Af:=PQ[TEL];
   Bf:=t[TEL];
   WriteLn(FV,fTEL:6,Af:20,Bf:20);
   TEL:=TEL+1;
  END;
  Close(FV);
  PressKey;
  Scroll;ClrScr;
 END;
 ClrScr;Exit:
END; (* Hydr_Edit *)

(*END =================== HYDROL01.INC ==================== *)

(***************************************************************
* HYDROL02.INC                                                 *
*                                                              *
* CONTENTS                                                     *
*                                                              *
* MISCELLANEOUS HYDROLIN-PROCEDURES  TU DELFT / M.J.Vos / 1988 *
****************************************************************
* Time_Step; Area_Define; Zero_Wiping; Initial_Loss; Phi_Index;*
* Nett_Precip;Precip_Conversion; Accumul_Nett_Precip; Precip_Mn*
***************************************************************)

(*============================================================*)
PROCEDURE Time_Step;
(*============================================================*)

{VAR  dt,ts,nTEL,nMaxTEL,
     timestep           : Integer;
     nPQ                : Arr;
     nt                 : ArrInt;
     iPQ                : Real;}

BEGIN
 ClrScr;
 Quit:=False;
 WriteLn('WARNING !');Delay(1000);WriteLn;LV; WriteLn
 ('The program will give runtime error if the declared bounds ');
 WriteLn('of a new timestep-array-initiated in constant:Arr_Afm');
 WriteLn('in the declaration at the beginning of the HYDROLIN');
 WriteLn('will be to small.');HV;PressKey;
 REPEAT
  Menu_Heading:='TIME-STEP MENU';
  CASE Menu('Precipitation Discharge Quit') OF

'P' :
   BEGIN
    WriteLn;Write('Give filename ...');LV;
    Write('  (d:XXXXXPXXX.DAT)');HV; WriteLn;Delay(3000);
    Input_File;
    Write('Give a new timestep            : ');
    GotoXY(30,10);Readln(timestep);WriteLn;

    ts:=timestep;
    dt:=t[2]-t[1];
    TEL:=0;nTEL:=0;
    PQ[0]:=0.0E00;nPQ[0]:=0.0E00;
    t[0]:=0;nt[0]:=0;

    IF ts<=dt THEN     (* Smaller timestep *)
    REPEAT
     TEL:=TEL+1;
     REPEAT
      nTEL:=nTEL+1;
      nt[nTEL]:=nt[nTEL-1]+ts;
      nPQ[nTEL]:=PQ[TEL];
     UNTIL nt[nTEL]>=t[TEL];
     nPQ[nTEL]:=
     PQ[TEL]*(t[TEL]-nt[nTEL-1])/dt+PQ[TEL+1]*(nt[nTEL]-t[TEL])/dt;
    UNTIL TEL=MaxTEL;

    IF ts>dt THEN     (* Bigger timestep *)
    REPEAT
     nTEL:=nTEL+1;
     nt[nTEL]:=nt[nTEL-1]+ts;
     REPEAT
      TEL:=TEL+1;
      nPQ[nTEL]:=nPQ[nTEL-1]+PQ[TEL];
     UNTIL t[TEL]>=nt[nTEL];
     iPQ:=((nt[nTEL]-t[TEL-1])/dt)*PQ[TEL];
     iPQ:=iPQ+((t[TEL]-nt[nTEL])/dt)*PQ[TEL+1];
     nPQ[nTEL]:=(nPQ[nTEL]-PQ[TEL]+iPQ)*dt/(nt[nTEL]-nt[nTEL-1]);
    UNTIL TEL=MaxTEL;
    nMaxTEL:=nTEL;

    FNM:=Copy(FileName,1,2);
    FileName:='PTS.DAT';
    WriteLn('Your timestep-filename will be :PTS.DAT');
    Write('Do you agree ? ');LV;Write(' (Y/N)');HV;Read(Kbd,Ch);
    IF Nee THEN
     BEGIN
      LV;Write('Give your name of the file : ');HV;Readln(FileName);
     END;
    Assign(FV,FileName);
    ReWrite(FV);
    File_Text;
    FOR nTEL:=1 TO nMaxTEL DO
    BEGIN
     Af:=nPQ[nTEL];
     Bf:=nt[nTEL];
     WriteLn(FV,nTEL:6,Af:20:3,Bf:20);
    END;
    Close(FV);
    WriteLn('Your filename has received a new number only !');
    WriteLn('If you want to rename:use the Filehandling');
    PressKey;
   END; (* Precipitation *)

'D' :

   BEGIN
    WriteLn;Write('Give filename ...');LV;
    Write('  (d:XXXXXQXX.DAT)');HV; WriteLn;Delay(3000);
    Input_File;
    Write('Give a new timestep   : ');
    GotoXY(30,10);Readln(timestep);WriteLn;

    ts:=timestep;
    dt:=t[2]-t[1];
    TEL:=0;nTEL:=0;
    PQ[0]:=0.0E00;nPQ[0]:=0.0E00;
    t[0]:=0;nt[0]:=0;

    IF ts<=dt THEN     (* Smaller timestep *)
    REPEAT
     TEL:=TEL+1;
     REPEAT
      nTEL:=nTEL+1;
      nt[nTEL]:=nt[nTEL-1]+ts;
      nPQ[nTEL]:=nPQ[nTEL-1]+(PQ[TEL]-PQ[TEL-1])*ts/dt;
     UNTIL nt[TEL]>=t[TEL];
     nPQ[nTEL]:=
     nPQ[nTEL-1]+(PQ[TEL]-PQ[TEL-1])*(t[TEL]-nt[nTEL-1])/dt;
     nPQ[nTEL]:=
     nPQ[nTEL]+(PQ[TEL+1]-PQ[TEL])*(nt[nTEL]-t[TEL])/dt;
    UNTIL TEL=MaxTEL;

    IF ts>dt THEN     (* Bigger timestep *)
    REPEAT
     nTEL:=nTEL+1;
     nt[nTEL]:=nt[nTEL-1]+ts;
     REPEAT
      TEL:=TEL+1;
      nPQ[nTEL]:=nPQ[nTEL-1]+PQ[TEL]-PQ[TEL-1];
     UNTIL t[TEL]>=nt[nTEL];
     iPQ:=((nt[nTEL]-t[TEL-1])/dt)*(PQ[TEL]-PQ[TEL-1]);
     nPQ[nTEL]:=nPQ[nTEL-1]+PQ[TEL-1]-PQ[TEL-2]+iPQ;
    UNTIL TEL=MaxTEL;
    nMaxTEL:=nTEL;

    FNM:=Copy(FileName,3,7);
    FileName:='QTS.DAT';
    WriteLn('Your timestep-filename will be QTS.DAT');
    Write('Do you agree ? ');LV;Write(' (Y/N)');HV;Read(Kbd,Ch);
    WriteLn; IF Nee THEN
     BEGIN
      LV;Write('Give your name of the file : ');HV;
      GotoXY(30,15);Readln(FileName);WriteLn;
     END;
    Assign(FV,FileName);
    ReWrite(FV);
    File_Text;
    FOR nTEL:=1 TO nMaxTEL DO
    BEGIN
     Af:=nPQ[nTEL];
     Bf:=nt[nTEL];
     WriteLn(FV,nTEL:6,Af:20:3,Bf:20);
    END;
    Close(FV);
    WriteLn('Your filename has received a new number only !');
    WriteLn('If you want to rename : use the Filehandling .');
    PressKey;
   END; (* Discharge *)

'Q' :
   BEGIN
    IF Yes('... are you sure ?') THEN Quit:=True;
    ClrScr;
   END;
  END;  (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Time_Step *)


(*============================================================*)
PROCEDURE Area_Define;
(*============================================================*)
(*                    Conversion to square m                  *)

{VAR  are,sqm,ha,sqkm  :  Real;}
BEGIN
 ClrScr;
 WriteLn('HYDROLIN/test/1.00 - Area       :  52510 ha ........');
 PressKey;
 Quit:=False;
 REPEAT
  Menu_Heading:='AREA DEFINE MENU';
  CASE Menu('Are Hectare M(sq) Km(sq)  Quit') OF

      'A' : BEGIN
             Write('Area               (are) : ');
             GotoXY(30,10);Readln(are);WriteLn;
             Area:=are*1E+2;{sq.m}
             WriteLn('Area              (sq.m) : ',AREA);
             Delay(5000);
             Quit:=True;
            END;
      'H' : BEGIN
             Write('Area                (ha) : ');
             GotoXY(30,10);Readln(ha);WriteLn;
             Area:=ha*1E+4;{sq.m}
             WriteLn('Area              (sq.m) : ',AREA);
             Delay(5000);
             Quit:=True;
            END;
      'M' : BEGIN
             Write('Area              (sq.m) : ');
             GotoXY(30,10);Readln(sqm);WriteLn;
             Area:=sqm;{sq.m}
             WriteLn('Area              (sq.m) : ',AREA);
             Delay(5000);
             Quit:=True;
            END;
      'K' : BEGIN
             Write('Area               (sq.km) : ');
             GotoXY(30,10);Readln(sqkm);WriteLn;
             Area:=sqkm*1E+06;{sq.m}
             WriteLn('Area              (sq.m) : ',AREA);
             Delay(5000);
             Quit:=True;
            END;
      'Q' : BEGIN
             IF Yes('... are you sure ?') THEN  Quit:=True;
             ClrScr;
            END;
  END;  (* Case *)
  HV;
  UNTIL Quit=True;
  WriteLn;
  WriteLn('Further characteristics  : not yet implemented.');
  Delay(3000);
 END; (* Area_define *)


(*============================================================*)
PROCEDURE Zero_Wiping;
(*============================================================*)

{VAR    WipeTEL : Integer;}

BEGIN
 WriteLn('DATAFILE to apply zero-wiping to ..................');
 WriteLn;{PressKey;;}
 Input_File;

 WriteLn('ZERO-WIPED DATAFILENAME .......................... ');
 WriteLn;PressKey;
 File_Name_Num;

 BEGIN
  TEL:=0;
  REPEAT
   TEL:=TEL+1;
  UNTIL PQ[TEL]<>0.0E00;
  WipeTEL:=TEL;
  REPEAT
   TEL:=TEL+1;
  UNTIL PQ[TEL]=0.0E00;
  MaxTEL:=TEL;
 END;
 Assign(FV,FileName);
 Rewrite(FV);
 File_Text;
 PressKey;
 FOR TEL:=WipeTEL TO MaxTEL DO
 BEGIN
  Af:=PQ[TEL];Bf:=t[TEL]-t[WipeTEL-1];
  WriteLn(FV,TEL-WipeTEL+1:6,Af:20:3,Bf:20);
 END;
 Close(FV);
END; (* Zero_Wiping *)


(*========================= PRECIPITATION ====================*)

(*============================================================*)
PROCEDURE Initial_Loss;
(*============================================================*)

BEGIN
 Write('ZERO-WIPED PRECIPITATION-DATAFILE to apply initial lose');
 LV;Write(' (d:XXXXXPWX.DAT)');HV;WriteLn;{PressKey;}
 Input_File;
 WriteLn('INITIAL-LOSS DATAFILE  :');Delay(3000);WriteLn;WriteLn;
 StrPQ:='INITIAL LOSS Iinit';Strt:='TIME tIinit';

 FOR TEL:=1 TO MaxTEL DO PQ[TEL]:=0.0E00;
 WriteLn('First an initialisation-datafile is written .......');
 WriteLn('give INITIAL_LOSS_DATAFILE name ...................');
 WriteLn('Use the PI-option of ..............................');
 {PressKey;}
 File_Name_Num;
 Assign(FV,FileName);
 ReWrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 WriteLn(FV,TEL:6,PQ[TEL]:20:3,t[TEL]:20);
 Close(FV);Delay(3000); (* Initialisation *)

 LV; WriteLn;WriteLn;
 WriteLn('.Continue to use Norten Editor to edit the PI file.');
 Exec('b:ne.com',FileName);
END; (* Initial_Loss *)


(*============================================================*)
PROCEDURE Phi_Index;
(*============================================================*)

{VAR       Pbrtot : Real;}

BEGIN
 Write('ZERO-WIPED PRECIPITATION-DATAFILE to apply phi-index');
 LV; Write(' (d:XXXXXPWX.DAT)');WriteLn;HV;{PressKey;}
 Input_File;

 WriteLn('HYDROLIN/test/1.00 - Phi-index  :  2.48 mm/hour ...');
 WriteLn;
 Write('Give estimated phi-index        : ');
 GotoXY(30,10);Readln(Apr);WriteLn;Delay(1000);
 WriteLn;
 WriteLn('PHI_INDEX-DATAFILE name .......................... ');
 WriteLn('Use the PF option of ............................. ');
 PressKey;
 File_Name_Num;
 StrPQ:='PHI-INDEX LOSS Iphi';Strt:='TIME tIphi';
 {
 Write('Phi-index                     : ');Readln(Phi);WriteLn;
 TEL:=0;Pbrtot:=0.0E00;t[0]:=0;
 BEGIN
  REPEAT
   TEL:=TEL+1;
   Pbrtot:=Pbrtot+PQ[TEL]*(t[TEL]-t[TEL-1]);
   MaxTEL:=TEL-1;
  UNTIL PQ[TEL]=0.0E00;
 END;
 Apr:=Phi*Pbrtot/t[MaxTEL];
 Write('Phi-index precipitation loss   : ',Apr);
 }
 Assign(FV,FileName);
 Rewrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 BEGIN
  Iphi[TEL]:=Apr;
  Af:=Iphi[TEL];Bf:=t[TEL];
  WriteLn(FV,TEL:6,Af:20:3,Bf:20);
 END;
 Close(FV);
 PressKey;
END; (* Phi_index *)

(*============================================================*)
PROCEDURE User_Def_Loss;
(*============================================================*)


BEGIN
 Write('ZERO-WIPED PRECIPITATION-DATAFILE to apply userdef.lose');
 LV;Write(' (d:XXXXXPWX.DAT)');HV;WriteLn;{PressKey;}
 Input_File;
 WriteLn('USERDEF-LOSS DATAFILE  :');Delay(3000);WriteLn;WriteLn;
 StrPQ:='USERDEF LOSS Iusr';Strt:='TIME tIusr';

 FOR TEL:=1 TO MaxTEL DO PQ[TEL]:=0.0E00;
 WriteLn('First an initialisation-datafile is written ........');
 WriteLn('USERDEF_LOSS_DATAFILE name .........................');
 WriteLn('Use the PU-option of ...............................');
 PressKey;
 File_Name_Num;
 Assign(FV,FileName);
 ReWrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 WriteLn(FV,TEL:6,PQ[TEL]:20:3,t[TEL]:20);
 Close(FV);Delay(3000); (* Initialisation *)

 LV;
 WriteLn;WriteLn;
 WriteLn('.Continue to use NORTEN EDITOR to edit the PU file.');
 Exec('b:ne.com',FileName);
END; (* User_Def_Loss *)

(*============================================================*)
PROCEDURE Precip_Loss;
(*============================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='PRECIP. LOSS MENU';
  CASE Menu('Initial Phi_index User_def Quit') OF

     'I' :  BEGIN
             StrPQ:='PRECIP_LOSS Iinit';Strt:='TIME tIinit';
             PQ:=Iinit;t:=tIinit;
             Initial_Loss;
            END;
     'P' :  BEGIN
             StrPQ:='PRECIP_LOSS Iphi';Strt:='TIME tIphi';
             PQ:=Iphi;t:=tIphi;
             Phi_Index;
            END;
     'U' :  BEGIN
             StrPQ:='PRECIP_LOSS Iusr';Strt:='TIME tIusr';
             PQ:=Iusr;t:=tIusr;
             User_Def_Loss;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
  UNTIL Quit=True;
END; (* Precip_Loss *)


(*============================================================*)
PROCEDURE Precip_Conversion;
(*============================================================*)

BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='PRECIP. CONVERSION';
  CASE Menu('0mm/hour 1mm/half_an_hour 2mm/day 3quit ') OF

(* Conversion Intensity to mm/hour counted ; time in hour.   *)
(* Not implemented l/s.ha= 8.64 mm/day , mm/year             *)

     '0' :  BEGIN
             MulP:=1.0;
             Quit:=True;
            END;
     '1' :  BEGIN
             MulP:=0.5;
             Quit:=True;
            END;
     '2' :  BEGIN
             Mulp:=1/24;
             Quit:=True;
            END;
     '3' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
UNTIL Quit=True; ClrScr;
END; (* Precip_Conversion *)

(*============================================================*)
PROCEDURE Nett_Write;
(*============================================================*)

BEGIN
 WriteLn('Give filename to the NETT PRECIPITATION file .......');
 WriteLn('Use now the PN-specification_option of .............');
 Delay(5000);
 File_Name_Num;
 Assign(FV,FileName);
 ReWrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 BEGIN
  Af:=Inett[TEL];
  Bf:=tInett[TEL];
  WriteLn(FV,TEL:6,Af:20:3,Bf:20);
 END;
 Close(FV);
END; (* Nett_Write *)

(*============================================================*)
PROCEDURE Nett_Precip;
(*============================================================*)

BEGIN
 Write('ZERO-WIPED PRECIPITATION-DATAFILE   ');LV;
 Write(' (d:XXXXXPWX.DAT)');WriteLn; HV;{PressKey;}
 Input_File;
 Ibr:=PQ;
 tIbr:=t;


 WriteLn('PRECIPITATION_LOSS_DATAFILE(S)  ');LV;
 WriteLn('d:XXPIX.DAT and/or d:XXPFX.DAT and/or d:XXPUX.DAT');
 WriteLn;HV;PressKey;
 Quit:=False;
 REPEAT
  Menu_Heading:='PRECIP_LOSS_DATAFILE';
  CASE Menu('Initial Phi_index User_def Quit') OF

'I' :
  BEGIN
   WriteLn('You should give a filename like d:XXXXXPIX.DAT ...');
   {PressKey;}
   Input_File;
   Iinit:=PQ;tIinit:=t;
   StrPQ:='NETT PRECIP Inett';Strt:='TIME tInett';
   Precip_Conversion;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF Ibr[TEL]-Iinit[TEL]<=0.0E00 THEN Inett[TEL]:=0.0E00 ELSE
    BEGIN
     Inett[TEL]:=Ibr[TEL]-Iinit[TEL];
     Inett[TEL]:=Inett[TEL]*MulP;
     tInett[TEL]:=t[TEL];
    END;
   END;
   Nett_Write;
  END;

'P' :
  BEGIN
   WriteLn('You should give a filename like d:XXXXXPFX.DAT ...');
   {PressKey;}
   Input_File;
   Iphi:=PQ;tIphi:=t;
   StrPQ:='NETT PRECIP Inett';Strt:='TIME tInett';
   Precip_Conversion;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF Ibr[TEL]-Iphi[TEL]<=0.0E00 THEN Inett[TEL]:=0.0E00 ELSE
    BEGIN
     Inett[TEL]:=Ibr[TEL]-Iphi[TEL];
     Inett[TEL]:=MulP*Inett[TEL];
     tInett[TEL]:=t[TEL];
    END;
   END;
   Nett_Write;
  END;

'U' :
  BEGIN
   WriteLn('You should give a filename like d:XXXXXPUX.DAT ..');
   {PressKey;}
   Input_File;
   Iusr:=PQ;tIusr:=t;
   StrPQ:='NETT PRECIP Inett';Strt:='TIME tInett';
   Precip_Conversion;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF Ibr[TEL]-Iinit[TEL]<=0.0E00 THEN Inett[TEL]:=0.0E00 ELSE
    BEGIN
     Inett[TEL]:=Ibr[TEL]-Iusr[TEL];
     Inett[TEL]:=Inett[TEL]*MulP;
     tInett[TEL]:=t[TEL];
    END;
   END;
   Nett_Write;
  END;

'Q' :
  BEGIN
   IF Yes('... are you sure ?') THEN Quit:=True;
    ClrScr;
  END;

 END; (* Case *)
 HV;
 UNTIL Quit=True;(* Precip_Loss_Menu *)
END; (* Nett_Precip *)

(*============================================================*)
PROCEDURE Accumul_Nett_Precip;
(*============================================================*)
(*        Accumulated nett precipitation in cubic m           *)

BEGIN
 Area_Define;
 WriteLn('WIPED NETT-PRECIPITATION-DATAFILE ................ ');
 {PressKey;}
 Line:=Line1;
 Input_File;
 Inett:=PQ;
 tInett:=t;
 Pntot:=0.0E00;
 FOR TEL:=1 TO MaxTEL DO
 Pntot:=
 Pntot+(Inett[TEL]+Inett[TEL-1])*0.5*(tInett[TEL]-tInett[TEL-1]);
 Pntot:=Pntot*1E-3*Area;
 WriteLn('Accumulated nett precipitation : ',Pntot,' cubic m.');
 Write('Do you want to save this in a datafile ? (Y/N) ');HV;
 Read(Kbd,Ch);WriteLn;
 IF Ja THEN
 BEGIN
  FNM:=Copy(FileName,1,2);
  FileSpec:='PT';
  FileNumE:=Copy(FileName,5,5);
  FileName:=Concat(FNM,'PT',FileNumE,'.DAT');
  Assign(FV,FileName);
  ReWrite(FV);
  FOR TEL:=1 TO 6 DO WriteLn(FV,Line1);
  WriteLn(FV,'Accumulated Nett Precipitation ',Pntot,'cubic m.');
  Close(FV);
 END;ClrScr;
END; (* Accumul_Nett_Precip *)

(*============================================================*)
PROCEDURE Precip_Menu;
(*============================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='PRECIPITATION MENU';
CASE Menu('Bruto Zero_wiping Losses Nett Accum_nett Quit') OF

     'B' :  BEGIN
             StrPQ:='PRECIPITATION Ibr';Strt:='TIME tIbr';
             Seq:=' SEQ.NR'; PQ:=Ibr;t:=tIbr;
             Keyboard_Input;
            END;
     'Z' :  BEGIN
             Zero_Wiping;
            END;
     'L' :  BEGIN
             Precip_Loss;
            END;
     'N' :  BEGIN
             StrPQ:='PRECIPITATION Inett';Strt:='TIME tInett';
             PQ:=Inett;t:=tInett;
             Nett_Precip;
            END;
     'A' :  BEGIN
             Accumul_Nett_Precip;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Precip_Menu *)

(*END ======================= HYDROL02.INC ================ *)

END.
(*END ======================== HYDROL.PAS ================= *)
