program hydrolin;
{$R-}    {Range checking off}
{$B+}    {Boolean complete evaluation on}
{$S+}    {Stack checking on}
{$I+}    {I/O checking on}
{$N-}    {No numeric coprocessor}
{$M $4000,0,0} {Turbo 3 default stack and heap}

Uses
  Crt,Printer,turbo3,
  dos,turbolib,types,
  hydrol,Nash,Okelly,hydrocal{,hydrogr
  ,msdoslib,msdosdir,comm300};


  LABEL
    Start,Exit;


(*============================================================*)
PROCEDURE Help_Menu;
(*============================================================*)

BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='HELP MENU';
  CASE Menu('Nash_cascade Hydrolin Okelly Unit_hydrograph Quit')
   OF
      'N' : BEGIN
             Help_NASH;
            END;
      'H' : BEGIN
             Help_Hydrolin;
            END;
      'O' : BEGIN
             Help_OKELLY;
            END;
      'U' : BEGIN
             Help_UH;
            END;
      'Q' : BEGIN
             IF Yes('... are you sure ?') THEN
             Quit:=True;
            END;
  END; (* Case *)
 HV;
 UNTIL Quit=True;
 ClrScr;
END;  (* Help_Menu *)

(*END====================  HYDROL00.INC   ====================*)

(*============================================================*)
PROCEDURE File_Name_Num;
(*============================================================*)

BEGIN
 REPEAT
  Writeln;
  Write('             *** DATA-FILE : NAME / NUMBER ***');
  WriteLn;Delay(500);
  LV;Write('Default drive is');HV;Write(' "space"=main  ');
  WriteLn;Delay(500);
 {LV;WriteLn('Give your file-identification : ');WriteLn;
  Write('of exactly');HV;Write(' 5 ');LV;Write('characters ');
  WriteLn('without: drivenr, and filetype:',Chr(22));
  WriteLn;Write('XXXXX',Chr(13));HV;Readln(FNM);WriteLn;
  Delay(500);} Write('Give the drive name: (a: ,b: or c: ) ');
  Readln(fnm);
  LV;WriteLn('Give your file-specification : ');WriteLn;
  HV;Write('PB');LV;Write(' = bruto             precipitation;');
  WriteLn;
  HV;Write('PW');LV;Write(' = zeros wiped      precipitation ;');
  WriteLn;
  HV;Write('PI');LV;Write(' = initial losses    precipitation;');
  WriteLn;
  HV;Write('PF');LV;Write(' = phi-index loss    precipitation;');
  WriteLn;
  HV;Write('PU');LV;Write(' = user-def loss     precipitation;');
  WriteLn;
  HV;Write('PN');LV;Write(' = nett              precipitation;');
  WriteLn;
  HV;Write('PT');LV;Write(' = accumulated nett  precipitation;');
  WriteLn;WriteLn;Delay(500);
  HV;Write('QB');LV;Write(' = bruto             discharge;');
  WriteLn;
  HV;Write('QC');LV;Write(' = constant separ.  discharge ;');
  WriteLn;
  HV;Write('QL');LV;Write(' = linear separation discharge ;');
  WriteLn;
  HV;Write('QU');LV;Write(' = user-def separ.   discharge ;');
  WriteLn;
  HV;Write('QN');LV;Write(' = nett              discharge;');
  WriteLn;
  HV;Write('QW');LV;Write(' = zeros wiped       discharge');
  WriteLn;
  HV;Write('QT');LV;Write(' = accumulated nett  discharge;');
  WriteLn;WriteLn;
  HV;Write('UH');LV;Write(' = unit hydrograph            .');
  WriteLn;WriteLn;
  Write('XX',Chr(13));HV;Readln(FileSpec);WriteLn;
  LV;Write('Give your file-number : (');HV;Write('0,1,2');
  LV;Write(' or');HV;Write(' 3) :');WriteLn;WriteLn;
  Write('X',Chr(13));HV;Readln(FileNume);WriteLn;
  WriteLn(Chr(22));
  FileName:=Concat(FNM,FileSpec,FileNume,'.DAT');
  IF Exist(FileName) = True THEN
  BEGIN
   Bell;
   WriteLn(FileName,' already exists !');Delay(1000);
   WriteLn('You should assemble another name ');
   Write('or do you want to overwrite an existing file ?');LV;
   Write(' (Y/N)');HV;WriteLn;Read(Kbd,Ch);
  END;
 UNTIL (Exist(FileName) = False) OR (Ch IN ['y','Y']);
END; (* File_Name_Num *)


(*==========================================================*)
PROCEDURE File_Renum;
(*==========================================================*)

Label  DoIt;

BEGIN
 Write('                  *** DATA-FILE : RENUMBER ***');
 WriteLn;Delay(500);
 LV;Write('Default drive is ');HV;Write('"space"=main drive');
 LV;WriteLn; WriteLn; Delay(500); WriteLn
 ('If you desire substitutions in the source-program,consult');
 HV;WriteLn('                TU DELFT / HOLLAND.');WriteLn;
 WriteLn; Write('Do you want to use File_Handling ?  ');
 LV;Write('(Y/N)');HV; Read(Kbd,Ch);WriteLn;IF Ja THEN
 File_Handling; FNM:=Copy(FileName,1,2);
 FileSpec:=Copy(FileName,3,4); FileNumE:=Copy(FileName,5,5);
 IF FileNumE='0' THEN
 BEGIN FileNumR:='1';GOTO DoIt; END ELSE
 IF FileNumE='1' THEN
 BEGIN FileNumR:='2';GOTO DoIt; END ELSE
 IF FileNumE='2' THEN
 BEGIN FileNumR:='3';GOTO DoIt; END ELSE
 IF FileNumE='3' THEN
 BEGIN
  LV;Write('Overwrite an existing datafile ? ');HV;
  Write('(Y/N)');Read(Kbd,Ch);WriteLn;
  IF Ja THEN
  REPEAT
   LV;Write('Give datafile-');HV;Write('number : ');
   GotoXY(20,2);Readln(FileNumR);WriteLn;
  UNTIL Yes('... are you sure ?') ELSE
  BEGIN
   WriteLn('This edited version will be saved as number 4,');
   WriteLn('but will be operable after: Copy/Delete/Rename');
   WriteLn('with sequence-number 1,2 or 3 in FileHandling.');
   WriteLn; FileNumR:='4';
  END;
 END;
 DoIt:
 FileName:=Concat(FNM,FileSpec,FileNumR,'.DAT');
END; (* File_Renum *)


(*============================================================*)
PROCEDURE File_Text; {Implemented with six textlines}
(*============================================================*)

BEGIN
  Scroll;ClrScr;
  GotoXY(20,1);Write('*** DATA-FILE : TEXT ***');WriteLn;
  LV;Write('Project/version/Nr.                   : ');HV;
  Readln(Titel);
  Write('Date      (jjmmdd)                    : ');
  Readln(jjmmdd);
  Write('Dimension of ',StrPQ:20,'     : ');
  Readln(DimStrPQ);
  Write('Dimension of ',Strt:20,'     : ');
  Readln(DimStrt);
  Seq:='SEQ.NR';Spc:='      ';
  WriteLn(FV,'Project/Version/Nr.      : ',Titel);
  WriteLn(FV,'Date      (jjmmdd)       : ',jjmmdd);
  WriteLn(FV);
  WriteLn(FV,Seq:6,StrPQ:20,Strt:20);
  WriteLn(FV,Spc:6,DimStrPQ:20,DimStrt:20);
  WriteLn(FV);
  Scroll;ClrScr;
END; (* File_Text *)


(*============================================================*)
PROCEDURE Input_File;
(*============================================================*)
LABEL
    Start;
{VAR  bTEL,fTEL,TEL,MaxTEL,Bf : Integer;
                         Af  : Real   ;}
BEGIN
Writeln;
Start:
 Write('Give input-filename '); Write('(d:inputfile.dat) : ');
 WriteLn; Readln(FileName);WriteLn;
 IF Exist(FileName)=False THEN
 BEGIN
  Bell;
  WriteLn('File does not exist !');
  Delay(3000);
 END;
 IF Exist(FileName)=False THEN GOTO Start;

Assign(FV,FileName);
Reset(FV);
WriteLn;
FOR TEL:=0 TO Arr_Afm DO
BEGIN
 PQ[TEL]:=0.0E00;
 t[TEL]:=00;
END; (* Initialisation *)

BEGIN
FOR tTEL:=1 TO 3 DO
 BEGIN
  Readln(FV,Line);
   WriteLn(Line);
 END;
 ReadLn(FV,Seq,StrPQ,Strt);
 WriteLn(Seq:6,StrPQ:20,Strt:20);
 ReadLn(FV,Spc,DimStrPQ,DimStrt);
 WriteLn(Spc:6,DimStrPQ:20,DimStrt:20);
 Readln(FV,Line);
 WriteLn(Line);
 Delay(200);
END; (* Text *)
fTEL:=0;bTEL:=1;
 REPEAT
  fTEL:=fTEL+1;
  IF fTEL=bTEL*15 THEN
  BEGIN
   bTEL:=bTEL+1;
   WriteLn;PressKey;
   Scroll;ClrScr;
   WriteLn;
   WriteLn(Seq:6,StrPQ:20,Strt:20);
   WriteLn(Spc:6,DimStrPQ:20,DimStrt:20);
   WriteLn('-----------------------------------------------');
   WriteLn;
  END;
   Readln(FV,fTEL,Af,Bf);
  TEL:=fTEL;
  PQ[TEL]:=Af;
  t[TEL]:=Bf;
  WriteLn(TEL:6,PQ[TEL]:20:3,t[TEL]:20);
  Delay(200);
 UNTIL Eof(FV);
MaxTEL:=TEL;
Close(FV);

REPEAT
 WriteLn;
 Write('Repeated display of the file-contents ?  ');LV;
 Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;Scroll;ClrScr;
 IF JA THEN
 BEGIN
  WriteLn;
  WriteLn(Seq:6,StrPQ:20,Strt:20);
  WriteLn(Spc:6,DimStrPQ:20,DimStrt:20);
  WriteLn('-----------------------------------------------');
  WriteLn;
  BEGIN
   bTEL:=1;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF TEL=bTEL*15 THEN
    BEGIN
     bTEL:=bTEL+1;
     WriteLn;PressKey;
     Scroll;ClrScr;
     WriteLn;
     WriteLn(Seq:6,StrPQ:20,Strt:20);
     WriteLn(Spc:6,DimStrPQ:20,DimStrt:20);
     WriteLn('-----------------------------------------------');
     WriteLn;
    END;
    WriteLn(TEL:6,PQ[TEL]:20:3,t[TEL]:20);
    Delay(200);
   END;
  END;
 END;
UNTIL Nee;
END; (* Input_File *)


(***************************************************************
* HYDROL03.INC                                                 *
*                                                              *
* CONTENTS :                                                   *
*                                                              *
* MISCELLANEOUS HYDROLIN-PROCEDURES  TU DELFT / M.J.Vos / 1988 *
****************************************************************
* Depletion; Separ_disch ;Nett_Disch; Disch_Conversion;        *
* Accumul_Nett_Disch; Disch_Menu; Precip_Disc_Menu.            *
***************************************************************)

(*============================================================*)
PROCEDURE Depletion;
(*============================================================*)

BEGIN
 Scroll;ClrScr;
 WriteLn('BRUTO_DISCHARGE DATAFILE ..........................');
 WriteLn('assumed to have one maximum discharge .............');
 WriteLn('to calculate end resp. start of depletion-curves ..');
 {PressKey;}
 Input_File;
 Qbr:=PQ;tQbr:=t;
 TEL:=1;
 BEGIN
  REPEAT
   TEL:=TEL+1;
   QT1:=PQ[TEL]/PQ[TEL-1];
   QT2:=PQ[TEL+1]/PQ[TEL];
   QT3:=QT1-QT2;
  UNTIL ((QT2>=0.0E00) OR (ABS(QT3)<=2E-2));
  Qs:=PQ[TEL+1];tQs:=t[TEL+1];
 END; (* Separation starting point *)

 TEL:=1;
 REPEAT
  TEL:=TEL+1;
 UNTIL (((PQ[TEL]-PQ[TEL-1])/(t[TEL]-t[TEL-1]))>=0.0E00) AND
       (((PQ[TEL+1]-PQ[TEL])/(t[TEL+1]-t[TEL]))< 0.0E00);
 LV;WriteLn('                 *** DISCHARGE SEPARATION  ***');HV;
 WriteLn;WriteLn;
 WriteLn('Maximum discharge                  : ',PQ[TEL]:20:3);
 WriteLn('             time                  : ',t[TEL]:20);
(* Maximum discharge *)
 WriteLn;
TEL:=TEL-1;
 BEGIN
  REPEAT
   TEL:=TEL+1;
   QT1:=PQ[TEL]/PQ[TEL-1];
   QT2:=PQ[TEL+1]/PQ[TEL];
   QT3:=QT1-QT2;
  UNTIL ABS(QT3)<=2E-2;
  Qd:=PQ[TEL-1];tQd:=t[TEL-1];
 END; (* Depletion starting point  *)

 WriteLn('Start separation curve at time     : ',tQs:20);
 WriteLn('                 and discharge     : ',Qs:20:3);
 WriteLn;Delay(3000);
 WriteLn('Start depletion  curve at time     : ',tQd:20);
 WriteLn('                 and discharge     : ',Qd:20:3);
 WriteLn; PressKey;
END; (* Depletion *)


(*============================================================*)
PROCEDURE Separ_Disch;
(*============================================================*)

BEGIN
 Depletion;
 Quit:=False;
 REPEAT
  Menu_Heading:='DISCH. SEPARATION';
  CASE Menu('Constant Linear User_def Quit') OF

'C' :
   BEGIN
    WriteLn('Separation assumed to be constant with time .....');
    WriteLn;
    WriteLn('Use now the QC-filenamespecification_option .....');
    StrPQ:='CONSTANT SEPAR. Qc';Strt:='TIME tQc';
    PressKey;
    File_Name_Num;
    Assign(FV,FileName);
    ReWrite(FV);
    File_Text;
    TEL:=0;
    REPEAT
     TEL:=TEL+1;
     Qsc[TEL]:=PQ[TEL];
    UNTIL PQ[TEL]=Qs;   (* First depletion curve   *)
    REPEAT
     IF PQ[TEL]>=Qs THEN
     Qsc[TEL]:=Qs;
     TEL:=TEL+1;
    UNTIL PQ[TEL]<=Qs; (* Constant separationline *)
    TEL:=TEL-1;
    REPEAT
     TEL:=TEL+1;
     Qsc[TEL]:=PQ[TEL];
    UNTIL TEL=MaxTEL;
    FOR TEL:=1 TO MaxTEL DO
    WriteLn(FV,TEL:6,Qsc[TEL]:20:3,t[TEL]:20);
    Close(FV);
    PressKey;
   END; (* Linear constant *)

'L' :
   BEGIN
    WriteLn('Separation assumed to be linear with time .......');
    WriteLn;
    WriteLn('Use now the QL-filenamespecification_option .....');
    StrPQ:='LINEAR SEPAR. Ql';Strt:='TIME tQl';
    PressKey;
    File_Name_Num;
    Assign(FV,FileName);
    ReWrite(FV);
    File_Text;
    TEL:=0;
    REPEAT
     TEL:=TEL+1;
     Qsl[TEL]:=PQ[TEL];
    UNTIL PQ[TEL]=Qs;   (* First depletion curve   *)
    TEL:=TEL-1;
    REPEAT
     TEL:=TEL+1;
     Qsl[TEL]:=Qs+((t[TEL]-tQs)*(Qd-Qs)/(tQd-tQs));
    UNTIL PQ[TEL]=Qd;   (* Linear separation line  *)
    IF TEL<MaxTEL THEN
    REPEAT
     TEL:=TEL+1;
     Qsl[TEL]:=PQ[TEL];
    UNTIL t[TEL]=MaxTEL; (* Last depletion curve    *)
    FOR TEL:=1 TO MaxTEL DO
    WriteLn(FV,TEL:6,Qsl[TEL]:20:3,t[TEL]:20);
    Close(FV);
    PressKey;
   END; (* Linear up or down *)

'U' :
   BEGIN
    WriteLn('Separation assumed to be user defined ...........');
    WriteLn;
    WriteLn('Use now the QU-filenamespecification_option .....');
    StrPQ:='USER DEF SEPAR. Qu';Strt:='TIME tQu';
    PressKey;
    File_Name_Num;
    Assign(FV,FileName);
    ReWrite(FV);
    File_Text;
    FOR TEL:=1 TO MaxTEL DO
    BEGIN
     IF t[TEL]<=tQs THEN Qsu[TEL]:=PQ[TEL];
     IF ((t[TEL]>tQs) AND (t[TEL]<tQd)) THEN Qsu[TEL]:=0.0E00;
     IF t[TEL]>=tQd THEN Qsu[TEL]:=PQ[TEL];
    END;
    FOR TEL:=1 TO MaxTEL DO
    WriteLn(FV,TEL:6,Qsu[TEL]:20:3,t[TEL]:20);
    Close(FV);
    Delay(3000);
    WriteLn;  WriteLn
    ('.Continue to use NORTEN EDITOR to edit the QU file .');
    Delay(1000);
    Exec('b:ne.com',FileName);
   END; (* User-def *)

'Q' :
   BEGIN
    IF Yes('... are you sure ?') THEN Quit:=True;
    ClrScr;
   END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Separ_disch *)


(*============================================================*)
PROCEDURE Disch_Conversion;
(*============================================================*)

BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='DISCHARGE CONVERSION';
  CASE Menu('0cub.m/sec 1cub.m/min 2m/sec 3quit') OF

(* Discharge-conversion to cubic m/hr; time in hour           *)
(* Not implemented l/s , 10E6 cub.m/day or month or year, cf/s*)

     '0' :  BEGIN
             MulQ:=1;
             Quit:=True;
            END;
     '1' :  BEGIN
             MulQ:=1/60;
             Quit:=True;
            END;
     '2' :  BEGIN
             Write('Give the cross-section in sqm of the river:');
             Readln(R); WriteLn;
             MulQ:=3600*R;
             Quit:=True;
            END;
     '3' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Discharge_Conversion *)


(*============================================================*)
PROCEDURE Nett_Disch;
(*============================================================*)

BEGIN
 WriteLn('BRUTO_DISCHARGE-DATAFILE ..........................');
 Delay(3000);
 Input_File;
 Qbr:=PQ;
 tQbr:=t;

 WriteLn('DISCHARGE-SEPARATION_DATAFILE .....................');
 WriteLn
 ('This must be in connection with the bruto_discharge-file');
 Delay(10000);
 Input_File;
 Qbs:=PQ;
 tQbs:=t;

 Disch_Conversion;
 FOR TEL:=1 TO MaxTEL DO
 BEGIN
  StrPQ:='NETT DISCHARGE Qnett';Strt:='TIME tQnett';
  Qnett[TEL]:=Qbr[TEL]-Qbs[TEL];
  Qnett[TEL]:=MulQ*Qnett[TEL];
  tQnett[TEL]:=t[TEL];
 END;
 WriteLn('Give filename to the NETT DISCHARGE file ..........');
 WriteLn('Use now the QN-filenamespecification_option .......');
 Delay(5000);
 File_Name_Num;
 Assign(FV,FileName);
 ReWrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 BEGIN
  Af:=Qnett[TEL];
  Bf:=tQnett[TEL];
  WriteLn(FV,TEL:6,Af:20:3,Bf:20);
 END;
 Close(FV);
END; (* Nett_Disch *)



(*============================================================*)
PROCEDURE Accumul_Nett_Disch;
(*============================================================*)
(*        Accumulated Nett Discharge                          *)

BEGIN
 WriteLn('WIPED! NETT_DISCHARGE-DATAFILE ................... ');
 Delay(3000);
 Line:=Line2;
 Input_File;
 Qnett:=PQ;
 tQnett:=t;
 Qntot:=0.0E00;
 FOR TEL:=1 TO MaxTEL DO
 Qntot:=
 Qntot+(Qnett[TEL]+Qnett[TEL-1])*0.5*(tQnett[TEL]-tQnett[TEL-1])
        *3600;
 Write('Do you want to save this in a datafile ? (Y/N) ');HV;
 Read(Kbd,Ch);WriteLn;
 IF Ch IN ['Y','y'] THEN
 BEGIN
  FNM:=Copy(FileName,3,7);
  FileSpec:='QT';
  FileNumE:=Copy(FileName,10,10);
  FileName:=Concat('b:',FNM,'QT',FileNumE,'.DAT');
  Assign(FV,FileName);
  ReWrite(FV);
  FOR TEL:=1 TO 6 DO WriteLn(FV,Line2);
  WriteLn(FV,'Accumulated nett discharge ',Qntot,'in cubic m.');
  Close(FV);
 END;
END; (* Accumul_Nett_Disch *)


(*============================================================*)
PROCEDURE Disch_Menu;
(*============================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='DISCHARGE MENU';
  CASE Menu('Bruto Separ Nett Zero_wiping Accum_nett Quit') OF

     'A' :  BEGIN
             Accumul_Nett_Disch;
            END;
     'B' :  BEGIN
             StrPQ:='DISCHARGE Qbr';Strt:='TIME tQbr';
             PQ:=Qbr;t:=tQbr;
             Keyboard_Input;
            END;
     'S' :  BEGIN
             StrPQ:='DISCHARGE Qbs';Strt:='TIME tQbs';
             Separ_disch;
            END;
     'N' :  BEGIN
             StrPQ:='DISCHARGE Qnett';Strt:='TIME tQnett';
             Nett_Disch;
            END;
     'Z' :  BEGIN
             Zero_Wiping;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Disch_Menu *)


(*============================================================*)
PROCEDURE Precip_Disch;
(*============================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='PRECIP./DISCH. MENU';
  CASE Menu('Precipition Discharge Compare Timestep Quit') OF

     'P' :  BEGIN
             Precip_Menu;
            END;
     'D' :  BEGIN
             Disch_Menu;
            END;
     'C' :  BEGIN
             WriteLn('Do you want to compare ');
             Write('accumulated precipitation and discharge?');
             LV;Write('(Y/N)');HV;
             Read(Kbd,Ch);WriteLn;
             IF Ch IN ['Y','y'] THEN
             BEGIN
              Scroll;ClrScr;
              Accumul_Nett_Precip;
              WriteLn('Accumulated nett precipitation  : ',Pntot,
              ' cubic m.'); WriteLn; Accumul_Nett_Disch;
              WriteLn('Accumulated nett discharge       : ',Qntot,
              ' cubic m.');  WriteLn; WriteLn
              ('Pntot-Qntot         = ',Pntot-Qntot,' cubic m.');
              WriteLn
          ('If you are satisfied you can QUIT and use GRAPHICS');
              WriteLn('or derive a Unit Hydrograph ...........');
              WriteLn
          ('Otherwise retry Precipitation/Discharge operations');
              PressKey;
             END; (* Compare *)
             Delay(2000);ClrScr;
            END;
     'T' :  BEGIN
             Time_Step;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Precip_Disch *)

(*===================== DISCHARGE ============================*)

(*END ================ HYDROL04.INC ==========================*)

(***************************************************************
* HYDROL04.INC                                                 *
*                                                              *
* CONTENTS :                                                   *
*                                                              *
* MISCELLANEOUS HYDROLIN-PROCEDURES  TU DELFT / M.J.Vos / 1988 *
****************************************************************
* Editer_Menu; Unit_Hydrograph;Nash_Model; Tank_Model          *
*                                 , Model_Menu; Main_Menu.     *
***************************************************************)


(*============================================================*)
PROCEDURE Editer_Menu;
(*============================================================*)

BEGIN
WriteLn('Required : all editers/filehandlers in drive B !');
Delay(5000);ClrScr;Quit:=False;
 REPEAT
  Menu_Heading:='EDITER MENU';
  CASE Menu('Edlin File_mngr Hydr_edit Nort Turbo Words Quit')
   OF
      'E' : BEGIN
             FileName:='b:EDLIN.COM';
             IF NOT Exist(FileName) THEN
             BEGIN
              Bell;
              WriteLn(FileName,' does not exist !');
              Delay(1000);
             END ELSE
             BEGIN
              Write('Give Edit File Name : ');
              ReadLn(FileName);Delay(1000);
              Exec('b:Edlin.com',FileName);
             END;
             ClrScr;
            END;
      'H' : BEGIN
             Hydr_Edit;
            END;
      'N' : BEGIN
             FileName:='b:NE.COM';
             IF NOT Exist(FileName) THEN
             BEGIN
              Bell;
              WriteLn(FileName,' does not exist !');Delay(1000);
             END ELSE
             BEGIN
              Write('Give Edit File Name : ');
              ReadLn(FileName);Delay(1000);
              Exec('b:NE.COM',FileName);
             END;
             ClrScr;
            END;
      'T' : BEGIN
             FileName:='b:TURBO.COM';
             IF NOT Exist(FileName) THEN
             BEGIN
              Bell;
              WriteLn(FileName,' does not exist !');Delay(1000);
             END ELSE
             BEGIN
              Exec('b:TURBO.COM','b:');
             END;
             ClrScr;
            END;
      'W' : BEGIN
             FileName:='b:WS.COM';
             IF NOT Exist(FileName) THEN
             BEGIN
              Bell;
              WriteLn(FileName,' does not exist !');Delay(1000);
             END ELSE
             BEGIN
              Exec('b:WS.COM','b:');
             END;
             ClrScr;;
            END;
      'F' : BEGIN
             FileName:='b:FM.COM';
             IF NOT Exist(FileName) THEN
             BEGIN
               Bell;
               WriteLn(FileName,' not present on B: !');
               Delay(1000);
             END ELSE
             BEGIN
               Write('Give Target Drivers Name :');
               Readln(FileName);
               Exec('b:FM.COM',FileName);
             END;
             ClrScr;
            END;
      'Q' : BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END;  (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Editer_Menu *)


(*============================================================*)
PROCEDURE Model_Menu;
(*============================================================*)

BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='MODEL MENU';
  CASE Menu('Nash_casc Okelly_model Unit_hyg Quit') OF

     'N' :  BEGIN
             NASHMAIN;
             Delay(1000);ClrScr;
            END;
     'O' :  BEGIN
             OKELLYMAIN;
             Delay(1000);ClrScr;
            END;
     'U' :  BEGIN
             WriteLn
             ('Derivation of the Unit Hydrograph must exist:');
             WriteLn;WriteLn('1. Zero-wiped datafiles;');
             WriteLn('2. Files with nett data;');
             WriteLn;
             IF Yes
             ('are you sure these conditions are fulfilled?')
             THEN  BEGIN
             {Chain(FV);} hydrocm;
             END ELSE
             WriteLn('Choose again the precip_disch-menu ...');
             PressKey;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Model_Menu *)


(*============================================================*)
PROCEDURE Main_Menu;
(*============================================================*)

BEGIN
ClrScr;
Quitt:=False;
 REPEAT
  Menu_Heading:='MAIN MENU';
  CASE Menu(' Dir Editer Filehandling Help Input Model Quit') OF

      'D' : BEGIN
             Write('Give Directive Name ( a:,b: or c: ) : ');
             Readln(FN);
             Exec('a:command.com','/c dir '+FN+'/p'); Presskey;
            END;
      'E' : BEGIN
             Editer_Menu;
            END;
      'F' : BEGIN
             File_Handling;
            END;
      'H' : BEGIN
             Help_Menu;
            END;
      'I' : BEGIN
             Precip_Disch;
            END;
      'M' : BEGIN
             Model_Menu;
            END;
      'Q' : BEGIN
             IF Yes('... are you sure ?') THEN Quitt:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quitt=True;
END; (* Main-Menu *)

(*END ==================== HYDROL04.INC ==================== *)


BEGIN
 HYDROLIN_Heading;
 Start:
 Main_Menu; (* to subsequent menues *)
 ClrLines(1,5);GotoXY(20,12);
 Write(' Quit  /// HYDROLIN  ///   ???');LV;Write('    (Y/N)');
 HV;Read(Kbd,Ch);WriteLn;
 IF Ja or Yes('...are you sure to quit ?') THEN
 BEGIN
  Scroll;
  GOTO Exit;
 END else
 GOTO Start;
 Exit:
 ClrScr;
END.

(*END ===================== HYDROLIN.PAS ===================== *)


