unit nash;
{Unit NASH;}
{$R-}    {Range checking off}
{$B+}    {Boolean complete evaluation on}
{$S+}    {Stack checking on}
{$I+}    {I/O checking on}
{$N-}    {No numeric coprocessor}
{$M $4000,0,0} {Turbo 3 default stack and heap}

interface

  Uses Crt,Turbo3,Graph3,Dos
       ,Types,Turbolib,hydrol;

  TYPE
    String1                 = String[1];

  VAR
    dummy                   : String1;
    f1,f2,f3,f4,f5,f6,FV    : Text;
    flg,i, j, kk,nk,ii,dt,Teller: Integer;
    n,k,k0,k1,aa,a,d,d1,dum,p0,p1,p2,q0,q1,
    q2,q21,p21,sq,meanq,sqm,sqq,r2,deltak,
    deltan,km,nm,im,tt,r2m,n0: Real;
    r22                     : ARRAY [1..9]  OF Real;
    nq                      : ARRAY [1..9]  OF Real;
    kq                      : ARRAY [1..9]  OF Real;
    p                       : ARRAY [1..200] OF Real;
    q                       : ARRAY [-99..320] OF Real;
    qh                      : ARRAY [-99..299] OF Real;
    qt                      : ARRAY [-99..299] OF Real;
    qtt                     : ARRAY [-99..299] OF Real;
    choice ,dumy            : char;
    answer                  : boolean;
    FN1,FN2,FN,FileName     : String[14];
  function Gamma(nn: real): real;
  procedure presspace;
  procedure input;
  procedure nkvalue;
  procedure iuhtouh;
  procedure uhtoh;
  procedure criteria;
  procedure semisimulation;
  procedure nashmain;

implementation

Function GAMMA(nn: real): real;
var
  pp : real;
  n1 : real;
  n2 : integer;
  pi : array[0..10] of real;
begin
  pp := 1.0;
  n1 := nn-1.0;
      repeat
        pp := pp * n1;
        n1 := n1 - 1.0;
      until n1 < 1.0;
  n1 :=n1*10;
  n2 :=trunc(n1);
  pi[0] := 1.000;
  pi[1] := 0.951;
  pi[2] := 0.918;
  pi[3] := 0.897;
  pi[4] := 0.887;
  pi[5] := 0.886;
  pi[6] := 0.894;
  pi[7] := 0.909;
  pi[8] := 0.931;
  Pi[9] := 0.962;
  Pi[10]:= 1.000;
  pp := pp * pi[n2];
  gamma :=pp;if nn <= 2.0 then gamma := 1.0;
end;

(*===================================================================*)
FUNCTION Menu(MenuStr:Str80):Char;
(*===================================================================*)

VAR  Ch            : Char;
     ChPos,Lengte,i: Integer;
     Found         : Boolean;
     Line          : Str80;


 PROCEDURE PrintMenu(Menu_Heading:Str20;MenuStr:Str80);

VAR
  i      :   integer;

BEGIN
  GotoXY(1,1);ClrEol;LV;
  Write('             *****      ',Menu_Heading,'      *****');
  HV;
  GotoXY(1,3); ClrEol;
  Lengte:=LENGTH(MenuStr);i:=1;
  for  i:= 1 to Lengte DO
{! 3. ^FOR loop counter variables must be pure locals or globals in Turbo 4.0.}
  BEGIN
    Ch:=MenuStr[i];
    IF Ch IN ['A'..'Z','0'..'9'] THEN HV ELSE LV;
    Write(Ch);
  END;
  HV; Write(' ? ');
END;
BEGIN
  PrintMenu(Menu_Heading,MenuStr); Read(Kbd,Ch); WriteLn(Ch);
  IF Ch IN ['a'..'z'] THEN Ch:=UpCase(Ch);
  ChPos:=1; Found:=False; Line:=MenuStr;
  REPEAT
    Lengte:=LENGTH(Line);
    Found:=(Ch = Line[1]);
    ChPos:=POS(' ',Line)+1;
    Line:=Copy(Line,ChPos,Lengte);
  UNTIL ((ChPos=1) OR Found);
  IF Found THEN Menu:=Ch ELSE
  BEGIN
    Menu:=' ';
    Bell;WriteLn(' ... is no choice !');Delay(500);
  END;
  ClrScr;PrintMenu(Menu_Heading,MenuStr);WriteLn(Ch);
END; (* Menu *)


PROCEDURE Presspace;
  BEGIN
    GoTOXY(22,22);
    WriteLn('Strike space key when ready...');
    Read(Kbd,dummy);
    ClrScr;
  END;

PROCEDURE Infilename;
{LABEL
    Start;}
BEGIN
{Start:}
 Write('Give input-filename '); Write('(b:12345pn0.dat) or (b:12345qn0.dat): ');
 Readln(FileName);
{IF Exist(FileName)=False THEN
 BEGIN
  WriteLn('File does not exist !');
 END;
IF Exist(FileName)=False THEN GOTO Start;
Clrscr;}
END;

PROCEDURE Outfilename;
{LABEL
    START; }
BEGIN
{Start:}
  Write('Give output-filename ');Write('(b:12345pnN.dat) or (b:12345qnN.dat):');
  Readln(FN);
{ IF Exist(FN)=True THEN
  BEGIN
   WriteLn(FN,' exists !');
   Write('Overwrite ',FN,' ?');LV;Write(' (Y/N)');HV;
   Read(Kbd,Ch);WriteLn;
   IF Ja THEN GOTO Start ;
  END;    ClrScr; }
END;

(*===================================================================*)
PROCEDURE CopyFile;
(*===================================================================*)
{
CONST
  Arr_Afm              = 20;(* max number in dataset *)
 }
VAR LineTel,LineTelMax : Integer;
 {  LineArr            : ARRAY[1..Arr_Afm] OF String[80];
    Filvar,FV          : Text;
    Filename,FN        : string[14];
 }
BEGIN
 Assign(Filvar,FileName);
 Reset(FilVar);
 Assign(FV,FN);
 ReWrite(FV);

 LineTel:=0;
 REPEAT
  LineTel:=LineTel+1;
  ReadLn(Filvar,LineArr[LineTel]);
  IF Eof(Filvar) THEN LineTelMax:=LineTel;
 UNTIL Eof(Filvar);
 FOR LineTel:=1 TO LineTelMax DO
 WriteLn(FV,LineArr[LineTel]);

 Close(Filvar);
 Close(FV);
END; (* CopyFile *)

(*===================================================================*)
PROCEDURE Input_Menu;
(*===================================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='INPUT MENU';
  CASE Menu(' Copyedit Existfile Modifyfile ') OF

      'C' :  BEGIN
              Writeln('Copy the net rainfall file and edit');
              Write('Give input-filename '); Write('(b:12345pn0.dat) ');
              Readln(FileName);
              Write('Give output-filename ');Write('(b:12345pnN.dat) ');
              Readln(FN1);
              Exec('\command.com','/c copy '+FileName+' '+FN1);
              Assign(f1,FN1); Reset(f1);
              Exec('b:\NE.COM',FN1); Close(f1);
              Scroll;Clrscr;
              Writeln('Copy the direct runoff file and edit');
              Write('Give input-filename '); Write('(b:12345qn0.dat): ');
              Readln(FileName);
              Write('Give output-filename ');Write('(b:12345qnN.dat):');
              Readln(FN2);
              Exec('\command.com','/c copy '+filename+' '+fn2);
              Assign(f2,FN2); Reset(f2);
              Exec('b:\NE.COM',FN2); Close(f2);
              IF Yes('... are you ready to run NASH ?') THEN Quit:=True;
             END;

      'M' :  BEGIN
              WriteLn('modify the existing net rainfall file ');Delay(100);
              Write('Net Rainfall : ');HV;Delay(100);
              Write('Give File Name b:12345pnN.dat ');
              Readln(FN1);
              Exec('b:\NE.COM',FN1);
              WriteLn('modify the existing direct runoff file ');Delay(100);
              Write('Direct Runoff : ');HV;Delay(100);
              Write('Give File Name b:12345qnN.dat ');
              Readln(FN2);
              Exec('b:\NE.COM',FN2);
              IF Yes('... are you ready to run NASH ?') THEN Quit:=True;
             END;
      'E' :  BEGIN
              LV;WriteLn('TestFiles :');
              Write('Net Rainfall : ');HV;Delay(100);
              Write('Give File Name b:12345pn0.dat ');
              Readln(FN1);WriteLn;LV;
              Write('Direct runoff: ');HV;Delay(100);
              Write('Give File Name b:12345qn0.dat ');
              Readln(FN2);WriteLn;
              IF Yes('... are you ready to run NASH ?') THEN Quit:=True;
             END;
     {'Q' :  BEGIN
              IF Yes('... are you sure ?') THEN Quit:=True;
             END;        }
  END; (* Case *)
  HV;
 UNTIL Quit=True;
 Scroll;ClrScr;
END; (* Input-Menu *)

PROCEDURE input;
  BEGIN
    Input_Menu;
    Assign(f1,FN1); Reset(f1);
    Assign(f2,FN2); Reset(f2);
    Assign(f3,'b:nkiuh.dat');  ReWrite(f3);
    Assign(f4,'b:nkuh.dat');   Rewrite(f4);
    Assign(f5,'b:h.dat');      Rewrite(f5);
    Assign(f6,'b:hb.dat');     Rewrite(f6);
    ClrScr; flg :=1;
    FOR i :=1 to 6 DO WriteLn(f6,'   ');
    WriteLn(f6,'     0                 0.0                   0');
    for i := 1 to 120 do q[i]:=0.0;
    for i := -99 to 200 do qt[i]:=0.0;
    for i := -99 to 200 do qtt[i]:=0.0;
    GotoXY(10,10);
    Begin
      FOR i :=1 to 6 do
      Readln(f1);
    End;
    Begin
      FOR i :=1 to 6 do
      Readln(f2);
    End;ClrScr;
    Write('Give Area in Km(sq):');Readln(aa);
    Write('Give Unit Depth in mm:');Readln(d);
    WriteLn('Input net rainfall(mm/hr) and its time(hr)');
    ReadLn(f1,i,p[1],dt);p[dt]:=p[1];GotoXY(10,4);
    WriteLn('p[',dt:2,']=',p[dt]:4:1);
    Repeat
      BEGIN
        ReadLn(f1,i,p[i*dt],j);GotoXY(10,3+i);
        WriteLn('p[',j:2,']=',p[j]:6:2);
        kk:=i;
      END;
    Until Eof(f1);Close(f1);
    PRESSPACE;
    WriteLn('Input direct run-off(cms) and its time(hr)');
    Repeat
      BEGIN
        ReadLn(f2,i,q[i*dt],j);GotoXY(10,3+i);
        WriteLn('q[',j:2,'] = ',q[j]:7:2);
        j:=i;
      END;
    Until Eof(f2);Close(f2);
  PRESSPACE;
  END;
PROCEDURE nkvalue;
  BEGIN
    p0 := 0;
    p1 := 0;
    p2 := 0;
    q0 := 0;
    q1 := 0;
    q2 := 0;
    q[0]:=0;
    FOR i := 1 TO kk DO
      BEGIN
        p0 := p0+p[i*dt]*aa*1000*dt;
        p1 := p1+p[i*dt]*(i-0.5)*aa*1000*3600*dt*dt;
        p2 := p2+p[i*dt]*(i-0.5)*(i-0.5)*aa*1000*3600*3600*dt*dt*dt
      END;
    FOR i := 1 TO j DO
      BEGIN
        q0 := q0+((q[(i-1)*dt]+q[i*dt])/2)*3600*dt;
        q1 := q1+(q[i*dt]/2)*((i-1/3)+(i+1/3))*3600*3600*dt*dt;
        q2 := q2+(q[i*dt]/2)*((i-1/3)*(i-1/3)+(i+1/3)*(i+1/3))*3600*3600*3600*
               dt*dt*dt;
      END;
    Writeln('p0=',p0:12:0);
    Writeln('p1=',p1:16:0);
    Writeln('p2=',p2:20:0);
    Writeln('q0=',q0:12:0);
    Writeln('q1=',q1:16:0);
    Writeln('q2=',q2:20:0);
    p21 := p2-p1*p1/p0;
    q21 := q2-q1*q1/q0;
    k   := (q21-p21)/((q1-p1)*3600);
    n   := (q1-p1)*(q1-p1)/(p0*(q21-p21));
    k0  :=k; km :=k;
    n0  :=n; nm :=n;
   {Writeln(f3,' k = ');}
    Write(' k =  ',k:5:2,'  n =   ',n:5:2);
   {Writeln(f3,k);}
   {Writeln(f3,' n = ');}
   {Writeln(f3,n);}
    PRESSPACE;
  END;
PROCEDURE iuhTOuh;
  BEGIN
    k1  :=k*3600;
    d1  :=d/1000;
    qt[0] :=0.0;
   {Writeln(f3,'j=',j:4);}
   {WriteLn(f3,'qt[0]=',qt[0]:4:2);}
    FOR i := 1 TO j+3 DO
    BEGIN
      qt[i*dt] := aa*1000000.0*(d1/k1)*
        (1.0/gamma(n))*(exp((n-1)*ln(i*dt/k)))*exp(-i*dt/k);
{     WriteLn(f3,'qt[',i*dt,']=',qt[i*dt]:8:2);  }
{     WriteLn('qt[',i:2,'] = ',qt[i]:5:1);       }
    END;
{   WriteLn(f4,'uh[  0]=',qtt[0]:8:2);           }
    FOR i :=1 TO j+3 DO
    BEGIN
      qtt[i*dt] := (qt[i*dt]+qt[(i-1)*dt])/2;
{     WriteLn(f4,'uh[',i*dt:3,']=',qtt[i*dt]:8:2);     }
{     WriteLn('qtt[',i*dt:2,'] = ',qtt[i*dt]:5:1);     }
    END;
{    PRESSPACE;                                  }
  END;

PROCEDURE uhtoh;
  BEGIN
{    RESET(f4);                                 }
        FOR i :=1 to j+3 DO
    BEGIN
      dum  := 0.0;
      nk   := 0;
      Repeat
        nk  := nk+dt;
        dum := dum+qtt[(i+1)*dt-nk]*p[nk]*dt/d;
      Until nk = kk*dt;
      qh[i*dt] := dum;
      WriteLn('qh[',i*dt:2,']=',qh[i*dt]:5:1,'  q[',i*dt:2,']=',q[i*dt]:5:1);
      if flg = 1 then  WriteLn(f6,i:6,qh[i*dt]:20:1,i*dt:20);
    END;

{   PRESSPACE;                          }
  END;

PROCEDURE criteria;
  BEGIN
    sq := 0.0;
    FOR i :=1 TO j+3 DO
    BEGIN
      sq := sq+q[i*dt];
    END;
    meanq :=sq/(j+3);
    sqm := 0.0;
    sqq := 0.0;
    FOR i :=1 TO j+3 DO
    BEGIN
       sqm := sqm+(q[i*dt]-meanq)*(q[i*dt]-meanq)*q[i*dt];
      sqq := sqq+(q[i*dt]-qh[i*dt])*(q[i*dt]-qh[i*dt])*q[i*dt];
    END;
    r2 := (sqm/(j+3)-sqq/(j+3))/(sqm/(j+3));
  END;
PROCEDURE semisimulation;
  BEGIN
    ClrScr;{Scrool;}
    GotoXY(2,2);WriteLn('which deltak AND deltan will be used'
                        ,'in the semisimulation') ;
    GotoXY(4,4);Write('delta-k = ');Readln(deltak);
    GotoXY(6,6);Write('delta-n = ');Readln(deltan);
    ClrScr;
    km :=0.0;
    im :=0.0;
    nm :=0.0;
    FOR ii := 1 TO 9 DO
      BEGIN
        IF ii = 1 THEN
        BEGIN
          k:=k0;
          n:=n0;
        END;
        IF ii = 2 THEN
        BEGIN
          k:=k0+deltak;
          n:=n0;
        END;
        IF ii = 3 THEN
        BEGIN
          k:=k0-deltak;
          n:=n0;
        END;
        IF ii = 4 THEN
        BEGIN
          k:=k0;
          n:=n0+deltan;
        END;
        IF ii = 5 THEN
        BEGIN
          k:=k0;
          n:=n0-deltan;
        END;
        IF ii = 6 THEN
        BEGIN
          k:=k0+deltak;
          n:=n0+deltan;
        END;
        IF ii = 7 THEN
        BEGIN
          k:=k0+deltak;
          n:=n0-deltan;
        END;
        IF ii = 8 THEN
        BEGIN
          k:=k0-deltak;
          n:=n0+deltan;
        END;
        IF ii = 9 THEN
        BEGIN
          k:=k0-deltak;
          n:=n0-deltan;
        END; flg :=2;
        iuhTOuh;
        uhtoh;
        criteria;
        r22[ii] :=r2;
        GotoXY(20,20);
        WriteLn('ii=',ii:2,'  k=',k:4:2,'  n=',n:4:2,'  r2=',r22[ii]:6:4);
        Presspace;
        nq[ii]  :=n;
        kq[ii]  :=k;
        IF r22[ii] > r2m  THEN
        BEGIN
          km:=k;
          nm:=n;
          im:=ii;
          r2m:=r22[ii];
        END;
      END;
    FOR ii := 1 to 9 DO
      BEGIN
        WriteLn('ii=',ii:2,'  k=',kq[ii]:4:2,'  n=',nq[ii]:4:2,'  r2=',
                r22[ii]:6:4);
      END;
    GoToXY(12,12);
    Writeln('old k value = ',k0);
    GoToXY(12,14);
    Writeln('old n value = ',n0);
    GoToXY(12,16);
    Writeln('new k value = ',km);
    GoToXY(12,18);
    Writeln('new n value = ',nm);
    GotoXY(10,21);Write('Do you want to change k n value ?(y/n)');
    Readln(dummy);
    IF dummy ='y' THEN
    BEGIN
      k0:=km;
      n0:=nm;
    END;
    GotoXY(10,22);Write('Do you intend to improve again  ?(y/n)');
    Readln(dummy);ClrScr;
    IF dummy ='y' THEN
    BEGIN
      semisimulation ;
    END;
  END;
PROCEDURE autosimulation;
  BEGIN
    ClrScr;GotoXY(10,10);
    Writeln('AUTOSIMULATION (Waiting!)');
    deltak:=0.1;
    deltan:=0.1;
    km :=0.0;
    im :=0.0;
    nm :=0.0;
   REPEAT
    Teller:=1;
    FOR ii := 1 TO 9 DO
      BEGIN
        IF ii = 1 THEN
        BEGIN
          k:=k0;
          n:=n0;
        END;
        IF ii = 2 THEN
        BEGIN
          k:=k0+deltak;
          n:=n0;
        END;
        IF ii = 3 THEN
        BEGIN
          k:=k0-deltak;
          n:=n0;
        END;
        IF ii = 4 THEN
        BEGIN
          k:=k0;
          n:=n0+deltan;
        END;
        IF ii = 5 THEN
        BEGIN
          k:=k0;
          n:=n0-deltan;
        END;
        IF ii = 6 THEN
        BEGIN
          k:=k0+deltak;
          n:=n0+deltan;
        END;
        IF ii = 7 THEN
        BEGIN
          k:=k0+deltak;
          n:=n0-deltan;
        END;
        IF ii = 8 THEN
        BEGIN
          k:=k0-deltak;
          n:=n0+deltan;
        END;
        IF ii = 9 THEN
        BEGIN
          k:=k0-deltak;
          n:=n0-deltan;
        END;
        {iuh to uh}
        BEGIN
         k1  :=k*3600;
         d1  :=d/1000;
         qt[0] :=0.0;
         FOR i := 1 TO j+3 DO
          BEGIN
           qt[i*dt] := aa*1000000.0*(d1/k1)*
                  (1.0/gamma(n))*(exp((n-1)*ln(i*dt/k)))*exp(-i*dt/k);
          END;
         FOR i :=1 TO j+3 DO
          BEGIN
           qtt[i*dt] := (qt[i*dt]+qt[(i-1)*dt])/2;
          END;
        END;

      { uh to h }
        BEGIN
         FOR i :=1 to j+3 DO
          BEGIN
           dum  := 0.0;
           nk   := 0;
           Repeat
            nk  := nk+dt;
            dum := dum+qtt[(i+1)*dt-nk]*p[nk]*dt/d;
           Until nk = kk*dt;
           qh[i*dt] := dum;
          END;
        END;

     { criteria }
        BEGIN
         sq := 0.0;
         FOR i :=1 TO j+3 DO
          BEGIN
           sq := sq+q[i*dt];
          END;
         meanq :=sq/(j+3);
         sqm := 0.0;
         sqq := 0.0;
         FOR i :=1 TO j+3 DO
          BEGIN
           sqm := sqm+(q[i*dt]-meanq)*(q[i*dt]-meanq);
           sqq := sqq+(q[i*dt]-qh[i*dt])*(q[i*dt]-qh[i*dt]);
          END;
         r2 := (sqm/(j+3)-sqq/(j+3))/(sqm/(j+3));
        END;
        r22[ii] :=r2;
        nq[ii]  :=n;
        kq[ii]  :=k;
        IF r22[ii] > r2m  THEN
        BEGIN
          km:=k;
          nm:=n;
          im:=ii;
          r2m:=r22[ii];
          Teller:=2;
        END;
      END;
      IF Teller = 1 THEN
      BEGIN
        deltak:=deltak-0.02;
        deltan:=deltan-0.02;
        Gotoxy(20,20);
        Write('rem=',r2m:5:3);
      END;
      IF Teller = 2 THEN
      BEGIN
        k0:=km;
        n0:=nm;
      END;
   UNTIL deltak <= 0.0;
   GotoXY(10,12);Writeln('BEST K VALUE = ',km:5:2);
   GotoXY(10,13);Writeln('BEST N VALUE = ',nm:5:2);
   Writeln('Its Deterministic Coefficient =',r2m:6:4);
   Presspace; flg :=2;
   iuhtouh; uhtoh;
   Presspace;
  END;

(*===================================================================*)
PROCEDURE Simulation_Menu;
(*===================================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='SIMULATION MENU';
  CASE Menu('Autosimulation Semisimulation Quit') OF

      'A' :  BEGIN
              Autosimulation;
             END;

      'S' :  BEGIN
              Semisimulation;
             END;
      'Q' :  BEGIN
              IF Yes('... are you sure ?') THEN Quit:=True;
             END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
 Scroll;ClrScr;
END; (* Simulation-Menu *)

procedure nashmain;
BEGIN
  IF Yes('Do you want to have a look of the help message ?')
  THEN Help_NASH;
  input;
  nkvalue;
  iuhTOuh;
  uhtoh;
  criteria;
  GoToXY(20,20);Write('r2(deterministic coefficient)=',r2:6:4);
  PRESSPACE;
  r2m := r2;
  simulation_menu;GotoXY(1,10);
  IF Yes('Do you want to store n&k value and UH in file b:nkuh.dat ? ')
  THEN
   BEGIN
    Writeln(f3,'BEST N VALUE = ',nm:5:2);
    Writeln(f3,'BEST K VALUE = ',km:5:2);
    Writeln(f4,'BEST N VALUE = ',nm:5:2);
    Writeln(f4,'BEST K VALUE = ',km:5:2);
    k1  :=km*3600;
    d1  :=d/1000;
    qt[0] :=0.0;
    WriteLn(f3,'IUH[  0]=',qt[0]:8:2);
    FOR i := 1 TO j+3 DO
    BEGIN
      qt[i*dt] := aa*1000000.0*(d1/k1)*
                (1.0/gamma(nm))*(exp((nm-1)*ln(i*dt/km)))*exp(-i*dt/km);
      WriteLn(f3,'IUH[',i*dt:3,']=',qt[i*dt]:8:2);
    END;
    WriteLn(f4,'UH[  0]=',qtt[0]:8:2);
    FOR i :=1 TO j+3 DO
    BEGIN
      qtt[i*dt] := (qt[i*dt]+qt[(i-1)*dt])/2;
      WriteLn(f4,'UH[',i*dt:3,']=',qtt[i*dt]:8:2);
    END;

    FOR i :=1 to 6 DO WriteLn(f5,'   ');
    WriteLn(f5,'     0                 0.0                   0');
    FOR i :=1 to j+3 DO
    BEGIN
      dum  := 0.0;
      nk   := 0;
      Repeat
        nk  := nk+dt;
        dum := dum+qtt[(i+1)*dt-nk]*p[nk]*dt/d;
      Until nk = kk*dt;
      qh[i*dt] := dum;
      WriteLn(f5,i:6,qh[i*dt]:20:1,i*dt:20);
    END;
    Close(f3);Close(f4);Close(f5);
   END;    Close(f6);
END;
END.