unit turbolib;

(**************************************************************
*  TURBOLIB.PAS                                               *
*                                                             *
*                                                             *
*MISCELLANEOUS TURBO PASCAL PROCEDURES TU DELFT/M.J.Vos /1988 *
***************************************************************
* LV; HV; Bell; ClrLine; ClrLines; Scroll; CursorOff;CursorOn;*
* CopyFile; WriteXY, PressKey; DisplayFile; DrawBloc;Exist;Ja;*
* File_Text; PrintFile; Yes; Menu; MSDOS_Volume;File_Handling;*
* Init_BitImage; Sort; Quicksort; Nee                         *
**************************************************************)

interface

  uses crt,turbo3,printer,dos,types{,MSDOSDIR,COMM300};

  procedure lv; procedure hv; procedure clrline(x,y:integer);
  procedure displayfile(filename:string); procedure bell;
  procedure writexy(x,y:integer;str:string);procedure presskey;
  procedure copyfile;procedure file_handling;
  procedure printfile(Filename:str14);
  procedure sort(var x:arr;var n: integer);
  procedure quicksort(var x:arr; i1,i2 : integer);
  procedure clrlines(first,last:integer);
  function exist(filename:string):boolean;function ja: boolean;
  function nee:boolean; function yes(question: str80):boolean;
  procedure scroll;function menu(menustr:str80):char;

implementation


(*===========================================================*)
PROCEDURE LV;
(*===========================================================*)

BEGIN
  LowVideo;
END; (* LV *)


(*===========================================================*)
PROCEDURE HV;
(*===========================================================*)

BEGIN
  HighVideo;
END; (* HV *)


(*===========================================================*)
PROCEDURE Bell;
(*===========================================================*)

BEGIN
  Write(Chr(7));
  Delay(500);
END; (* Bell *)

{
(*===========================================================*)
PROCEDURE Init_BitImage;CRT-Hdcopy 640X400 with M24-PROCEDURE
(*===========================================================*)

BEGIN
 Write(LST,#$27,'*',#$4,#$128,#$2);
END; (* Init_BitImage *)
}

(*===========================================================*)
PROCEDURE ClrLine(X,Y:Integer);
(*===========================================================*)

BEGIN
 GotoXY(X,Y);
 ClrEol;
END; (* ClrLine *)


(*===========================================================*)
PROCEDURE ClrLines(First,Last:Integer);
(*===========================================================*)

{VAR   i :Integer;}

BEGIN
 FOR i:=First TO Last DO ClrLine(1,i);
END;  (* ClrLines *)


(*===========================================================*)
PROCEDURE Scroll;
(*===========================================================*)

{VAR  i : Integer;}

BEGIN
 FOR i:=1 TO 32 DO
 BEGIN
  WriteLn;
  Delay(10);
 END;
END;  (* Scroll *)
{
(*===========================================================*)
PROCEDURE CursorOn;
(*===========================================================*)

BEGIN
  Write(Chr(27),'B',4);
END; (* CursorOn *)

(*===========================================================*)
PROCEDURE CursorOff;
(*===========================================================*)

BEGIN
  Write(Chr(27),'C',4);
END; (* CursorOff *)

}
(*===========================================================*)
PROCEDURE CopyFile;
(*===========================================================*)
{
CONST
  Arr_Afm              = 20;(* max number in dataset *)

VAR LineTel,LineTelMax : Integer;
    LineArr            : ARRAY[1..Arr_Afm] OF String[80];
    Filvar,FV          : Text;
    Filename,FN        : string[14];
 }
BEGIN
 Assign(Filvar,FileName);
 Reset(FilVar);
 Assign(FV,FN);
 ReWrite(FV);

 LineTel:=0;
 REPEAT
  LineTel:=LineTel+1;
  ReadLn(Filvar,LineArr[LineTel]);
  IF Eof(Filvar) THEN LineTelMax:=LineTel;
 UNTIL Eof(Filvar);
 FOR LineTel:=1 TO LineTelMax DO
 WriteLn(FV,LineArr[LineTel]);

 Close(Filvar);
 Close(FV);
END; (* CopyFile *)

(*===========================================================*)
PROCEDURE WriteXY(X,Y{,video}:Integer;Str:String);
(*===========================================================*)

BEGIN
 GotoXY(X,Y);
 {VideoMode(video,True;}
 Write(Str);
 {VideoMode(video,False);}
END; (* WriteXY *)


(*===========================================================*)
PROCEDURE Presskey;
(*===========================================================*)

{VAR  Ch : Char;}

BEGIN
  ClrLines(23,24);
  LV;WriteXY(1,23,{1,}'Continue with a key ...');
  Read(Kbd,Ch);
  Scroll;ClrScr;HV;
END; (* PressKey *)


(*===========================================================*)
PROCEDURE DisplayFile(FileName:String);
(*===========================================================*)

{VAR Line   : String[80];
    F      : Text;
    Nr,bNr : Integer;}

BEGIN
 Assign(F,FileName);
 Reset(F);
 Nr:=0;bNr:=1;
 REPEAT
   Nr:=Nr+1;
   ReadLn(F,Line);
   WriteLn(Line);
   Delay(200);
   IF Nr=BNr*20 THEN
   BEGIN
    bNr:=bNr+1;
    PressKey;
   END;
 UNTIL Eof(F);
 Close(F);
END; (* DisplayFile *)

{
(*===========================================================*)
PROCEDURE DrawBloc(X1,Y1,X2,Y2:Integer);           (* MS DOS *)
(*===========================================================*)

BEGIN
 ClrScr;
 Write(Chr(27),'L',Chr(Y1+31),Chr(X1+31),Chr(Y1+31),Chr(X2+31));
 Write(Chr(27),'L',Chr(Y1+31),Chr(X2+31),Chr(Y2+31),Chr(X2+31));
 Write(Chr(27),'L',Chr(Y2+31),Chr(X2+31),Chr(Y2+31),Chr(X1+31));
 Write(Chr(27),'L',Chr(Y2+31),Chr(X1+31),Chr(Y1+31),Chr(X1+31));
END;  (* DrawBloc *)
}

(*===========================================================*)
FUNCTION Exist(FileName:String) : Boolean;
(*===========================================================*)

{VAR  F : File;}

BEGIN
  Exist:=True;
  IF (FileName<>'TPU:') AND (FileName<>'TPU:') THEN
  BEGIN
    (*$I-*)
    Assign(FV,FileName);
    Reset(FV);
    Close(FV);
    (*$I+*)
    Exist:=(IOresult=0);
  END;
END; (* Exist *)


(*===========================================================*)
FUNCTION Ja:Boolean;
(*===========================================================*)

BEGIN
 Ja:=False;
 IF (Ch IN ['Y','y']) THEN Ja:=True;
END; (* Ja *)


(*===========================================================*)
FUNCTION Nee:Boolean;
(*===========================================================*)

BEGIN
 Nee:=False;
 IF (Ch IN ['N','n']) THEN Nee:=True;
END; (* Nee *)


(*===========================================================*)
PROCEDURE PrintFile(FileName : Str14);
(*===========================================================*)

{VAR Line : Str80;
    F    : Text;}

BEGIN
  Assign(FV,FileName);
  Reset(FV);
  WriteLn(LST,#$64);
  REPEAT
    ReadLn(FV,Line);
    WriteLn(LST,Line);
  UNTIL Eof(FV);
  WriteLn(LST,#$12);
  Close(FV);
END; (* PrintFile *)


(*===========================================================*)
FUNCTION Yes(question:Str80):Boolean;
(*===========================================================*)

{VAR Ch : Char;}

BEGIN
  Write(question);LV;Write(' (Y/N) : ');HV;
  REPEAT Read(Kbd,Ch); UNTIL Ch IN ['y','Y','n','N'];
  WriteLn;
  Yes:=(Ch IN ['y','Y']);
END; (* Yes *)


{
(*====================== MSDOS ==============================*)
FUNCTION MSDOS_Volume(drive_nr : Byte) : Str255;
(*===========================================================*)

VAR
    nam : Str11;
    k   : Byte;
    FCB : RECORD
           flag             : Byte;
           dos_reserved     : ARRAY[1..5] OF Byte;
           attribute,
           drive            : Byte;
           name             : ARRAY[1..11] OF Char;
           not_used         : ARRAY[12..36] OF Byte;
          END;
    reg : RECORD
           ax,bx,cx,dx,bp,si,di,ds,es,flags
                            : Integer;
          END;

BEGIN
WITH FCB,reg DO
 BEGIN
  ds:= Seg(FCB);
  dx:= Ofs(FCB);
  ax:= $1A00;
  MSDOS(reg);
  flag:=$FF;
  attribute:=$08;
  drive:=drive_nr;
  FillChar(name,11,'?');
  ax:=$1100;
  MSDOS(reg);
  nam:=' ';
  k:=1;
  IF Lo(ax)=0 THEN
  WHILE (k<=11) AND (name[k]<>' ') DO
  BEGIN
   nam:=nam+name[k];
   k:=Succ(k);
  END;
  MSDOSVolume:=nam;
 END;
END; (* MSDOS_Volume *)
}

(*===========================================================*)
FUNCTION Menu(MenuStr:Str80):Char;
(*===========================================================*)

{VAR  Ch            : Char;
     ChPos,Lengte,i: Integer;
     Found         : Boolean;
     Line          : Str80;}


 PROCEDURE PrintMenu(Menu_Heading:Str20;MenuStr:Str80);

{VAR
  i      :   integer;}

BEGIN
  GotoXY(1,1);ClrEol;LV;
  Write('             *****      ',Menu_Heading,'      *****');
  HV;
  GotoXY(1,3); ClrEol;
  Lengte:=LENGTH(MenuStr);i:=1;
  for  i:= 1 to Lengte DO
  BEGIN
    Ch:=MenuStr[i];
    IF Ch IN ['A'..'Z','0'..'9'] THEN HV ELSE LV;
    Write(Ch);
  END;
  HV; Write(' ? ');
END;
BEGIN
  PrintMenu(Menu_Heading,MenuStr); Read(Kbd,Ch);
  IF Ch IN ['a'..'z'] THEN Ch:=UpCase(Ch);
  ChPos:=1; Found:=False; Line:=MenuStr;
  REPEAT
    Lengte:=LENGTH(Line);
    Found:=(Ch = Line[1]);
    ChPos:=POS(' ',Line)+1;
    Line:=Copy(Line,ChPos,Lengte);
  UNTIL ((ChPos=1) OR Found);
  IF Found THEN Menu:=Ch ELSE
  BEGIN
    Menu:=' ';
    Bell;WriteLn(' ... is no choice !');Delay(500);
  END;
  ClrScr;PrintMenu(Menu_Heading,MenuStr);WriteLn(Ch);
END; (* Menu *)


(*===========================================================*)
PROCEDURE File_Handling;
(*===========================================================*)

{VAR Dr,LineTel,LineTelMax : Integer;
    St                    : Str14;}


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='FILE HANDLING MENU';
  CASE Menu('Copy Directory Erase File_mngr Nt_edit Print'+
            ' Rename Show Quit ')
  OF
      'C' : BEGIN
             REPEAT
               Write('Give filename');LV;
               Write('  (d:filename.typ) : ');
               HV;Readln(FileName);WriteLn;
               IF Exist(FileName)=True THEN
              BEGIN
               REPEAT
                LV;Write('New filename     : ');
                HV;Readln(FN);WriteLn;
                IF Exist(FN)=True THEN
                BEGIN
                 Bell;WriteLn('File exists !');
                 Delay(1000);
                 Write('Replace ',FileName,' ?');
                END;
               UNTIL Yes('... o.k. ?');
               LV;WriteLn('WAIT !');HV;
               CopyFile;
               LV;Write(FileName,'  copied to  ');
               HV;Write(FN);WriteLn;
              END;
              IF Exist(FileName)=False THEN
              BEGIN
               Bell;
               WriteLn('File does not exist  !');
               Delay(1000);
              END;
              Write('More COPY ?');LV;
              Write('  (Y/N) ');HV;
              Read(Kbd,Ch);WriteLn;WriteLn;
             UNTIL Nee;
             Delay(1000);ClrScr;
            END; (* Copy *)
      'D' : BEGIN
             Write('Give Directive Name (a:, b: or c:): ');
             Readln(FN);
             Exec('a:command.com','/c dir '+FN+'/p');PressKey;
            END; (* Directory *)
      'E' : BEGIN
             REPEAT
              Write('Give filename');LV;
              Write('  (d:filename.typ) : ');
              HV;Readln(FileName);WriteLn;
              Assign(Filvar,FileName);
              IF NOT Exist(FileName) THEN
              BEGIN
               Bell;
               WriteLn('File does not exist !');
               Delay(1000);
              END;
              IF Exist(FileName)=True THEN
              BEGIN
               Erase(Filvar);
               WriteLn('File is erased !');
               Delay(1000);
              END;
              Write('More ERASE ?');LV;
              Write('  (Y/N) ');HV;
              Read(Kbd,Ch);WriteLn;WriteLn;
             UNTIL Nee;
             Delay(1000);ClrScr;
            END; (* Erase *)
      'N' :  BEGIN
              Repeat
               Write('Give File Name b:filename.typ ');
               Readln(FN);
              Until Exist(FN);
              Assign(FV,FN); Reset(FV);
              Exec('b:NE.COM',FN); Close(FV);
             END;  (* Edit *)
      'F' : BEGIN
             FileName:='b:FM.COM';
             IF NOT Exist(FileName) THEN
             BEGIN
               Bell;
               WriteLn(FileName,' not present on B: !');
               Delay(1000);
             END ELSE
             BEGIN
               Write('Give Target Drivers Name :');
               Readln(FileName);
               Exec('b:FM.COM',FileName);
             END;
             ClrScr;
            END;  (* FileManager *)

      'P' : BEGIN
              Bell;
              LV;WriteLn('You will use the ... ');HV;
              Delay(1000);GotoXY(20,12);
              WriteLn('/// HYDROLIN /// print-program : ');
              Delay(2000);Scroll;ClrScr;
              REPEAT
               Write('Give filename');LV;
               Write('  (d:filename.typ) : ');
               HV;Readln(FileName);WriteLn;
               IF Exist(FileName)=True THEN
               PrintFile(FileName) ELSE
               BEGIN
                Bell;WriteLn('File does not exist');
                Delay(1000);
               END;
               Write('More PRINT ?');LV;
               Write('  (Y/N) ');HV;
               Read(Kbd,Ch);
              UNTIL Nee;
              Delay(1000);ClrScr;
            END; (* Print *)
      'Q' : BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END; (* Quit *)
      'R' : BEGIN
             REPEAT
              Write('Give old filename');LV;
              Write('  (d:filename.typ) : ');
              HV;Readln(FileName);WriteLn;
              Assign(Filvar,FileName);
              IF Exist(FileName)=True THEN
              BEGIN
                REPEAT
                 LV;Write('New name                   : ');
                 HV;Readln(FN);WriteLn;
                 IF Exist(FN)=True THEN
                 BEGIN
                  Bell;
                  WriteLn('File exists !');
                 END;
                UNTIL Exist(FN)=False;
                Rename(Filvar,FN);
                WriteLn(FileName,' renamed.',FN);
              END ELSE
              BEGIN
               Bell;WriteLn('File does not exist !');
               Delay(1000);
              END;
              Write('More RENAME ?');LV;
              Write('  (Y/N) ');HV;
              Read(Kbd,Ch);WriteLn;WriteLn;
             UNTIL Nee;
             Delay(1000);ClrScr;
            END; (* Rename *)
      'S' : BEGIN
             LV;WriteLn('You will use the ... ');HV;
             Delay(1000);GotoXY(20,12);
             WriteLn('/// HYDROLIN /// display-program : ');
             Delay(2000);Scroll;ClrScr;
             REPEAT
              Write('Give filename');LV;
              Write('  (d:filename.typ):  ');
              HV;Readln(FileName);WriteLn;
              IF Exist(FileName)=True THEN
              DisplayFile(FileName) ELSE
              BEGIN
               Bell;WriteLn(FileName,' does not exist !');
               Delay(1000);
              END;
              WriteLn;Write('SHOW more ?');
              LV;Write('  (Y/N) ');HV;
              Read(Kbd,Ch);WriteLn;ClrScr;
             UNTIL Nee;
            END; (* Show *)
{     'U'  : BEGIN
             Write('Give filename');LV;
             Write('  (b:filename.typ) :  ');
             HV;Readln(FileName);WriteLn;
             IF NOT Exist(FileName) THEN
             BEGIN
              Bell;
              WriteLn(FileName,' not yet implemented !');
              Delay(1000);
             END ELSE
             BEGIN
              LV;WriteLn('Input command : ',FileName);HV;
              Delay(3000);
             END;
             ClrScr;
            END; (* User_defined *)        }
  END; (* Case *)
 HV;
 UNTIL Quit=True;
END; (* File_Handling *)


(*===========================================================*)
PROCEDURE SORT(Var X : Arr ; Var N :Integer);
(*===========================================================*)

{Var j,k,p : Integer;}


PROCEDURE WISSEL(Var X,Y : Real);

{Var H     : Real;}

BEGIN
 H:=X;X:=Y;Y:=H;
END; (*WISSEL *)


BEGIN
 j:=0;
 WHILE j<>N DO
 BEGIN
  j:=j+1;
  k:=j;p:=j;
  WHILE p<>N DO
  BEGIN
   p:=p+1;
   IF X[p]>X[k] THEN k:=p
  END;
  WISSEL(X[j],X[k]);
 END;
END; (* SORT *)


(*===========================================================*)
PROCEDURE QUICKSORT (Var X : Arr; I1,I2 : Integer);
(*===========================================================*)
Var      R      : Integer;
{Var     R,S    : Integer;
        G      : Real;}


PROCEDURE WISSEL(Var X,Y : Real);

{Var     H      : Real;}

BEGIN
H:=X;X:=Y;Y:=H;
END; (*WISSEL *)


BEGIN
 IF I1<I2 THEN
 BEGIN
  G:=X[(I1+I2) DIV 2];
  R:=I1;S:=I2;
  WHILE R<=S DO
  BEGIN
   WHILE X[R]>G DO R:=R+1;
   WHILE X[S]<G DO S:=S-1;
   IF R<=S THEN
   BEGIN
    WISSEL(X[R],X[S]);
    R:=R+1;S:=S-1;
   END;
  END;
  QUICKSORT(X,I1,S);
  QUICKSORT(X,R,I2);
 END;
END; (* QUICKSORT *)

(*END =================== TURBOLIB.INC =================== *)
END.