PROGRAM HydroGr;

(**********************************************************************
* HYDROGR.PAS                                                         *
*                                                                     *
* CONTENTS :                                                          *
*                                                                     *
* MISCELLANEOUS HYDROLIN-GRAPHICS-PROCEDURES    TU DELFT/M.J.Vos/1988 *
***********************************************************************
* P_Histo; Q_Poly; PQ_Wind(P_Hist_Wind/Q_Poly_Wind); UH_grph;         *
* Smooth_UH; Graphics_Menu; Main program.                             *
**********************************************************************)

(*Hydrolin declarations*)
CONST
  Arr_Afm            = 30; (* Dimension measurement-datasets *)
LABEL
  Start,Exit;

TYPE

  Str1             = STRING[1];
  Str2             = STRING[2];
  Str5             = STRING[5];
  Str6             = STRING[6];
  Str10            = STRING[10];
  Str12            = STRING[12];
  Str14            = STRING[14];
  Str20            = STRING[20];
  Str80            = STRING[80];
  Arr              = ARRAY[0..Arr_Afm] OF Real;
  ArrInt           = ARRAY[0..Arr_Afm] OF Integer;

VAR

(*Hydrolin variables*)

  Ch               : Char;
  Quit             : Boolean;
  FileName,FN,FN0,
  FN1,FN2          : Str14;
  Filvar,FV,FV0,FV1,
  FV2              : Text;
  Line,Line1,Line2,
  HdrTxt,HdrTxt1,
  HdrTxt2,Hdr,Hdr1,
  Hdr2             : Str80;
  Menu_Heading,Name,
  Titel,Method     : Str20;
  jjmmdd,Seq,Spc   : Str6;
  tt_tt            : Str5;
  Version,FileSpec : Str2;
  FNM              : Str5;
  FileNumE,FileNumR: Str1;
  PQ,rcQ,Qbr,Qbs,
  Qnett,Ibr,Iinit,
  Iphi,Inett       : Arr;
  t,tQbr,tQbs,tQnett,
  tIbr,tIinit,tIphi,
  tInett           : ArrInt;
  tIinit1,tIinit2,
  tQu,Bf,Bpr       : Integer;
  TEL,tTEL,fTEL,
  bTEL,sTEL,MaxTEL : Byte;
  Area,ha,sqkm,Af,
  Apr,Qu,Phi,
  Pbrtot,Qbrtot,
  Pntot,R,Qntot    : Real;
  StrPQ,Strt,
  DimStrPQ,DimStrt : Str20;

(*Included files: graphics*)

{$I b:turbolib.inc    }

(*{$I b:m24.inc     }*)
(*{$I b:quickvid.inc}*)

{$I a:typedef.sys     }
{$I a:graphix.sys     }
{$I a:kernel.sys      }
{$I a:windows.sys     }
{$I a:findwrld.hgh    }
{$I a:hatch.hgh       }
{$I a:axis.hgh        }
{$I a:histogrm.hgh    }
{$I a:polygon.hgh     }
{$I a:spline.hgh      }
{
(*===================================================================*)
PROCEDURE P_Histo;                                    (* Fixed World *)
(*===================================================================*)

VAR    I, DisplyLen, HatchDen : Integer;
       A1,A2                  : PlotArray;
       T                      : ARRAY[1..6] OF Str80;
       R                      : Real;
       Ch                     : Char;
       Hatch                  : Boolean;

       FV1,FV2                : Text;
       FN1,FN2                 : Str14;
       TEL,fTEL,MaxTEL,Bf     : Integer;
       Af                     : Real;
       Line1,Line2            : Str80;



PROCEDURE P_Histogram(A1,A2 : PlotArray);

BEGIN
 REPEAT
  Write('Give name of precipitation-datafile        ');LV;
  Write('(d:XXXXXPXX.DAT)  ');HV;Read(FN1);WriteLn;
  IF Exist(FN1)=False THEN
  BEGIN
   Bell;WriteLn(FN1,' ... does not exist !');
   WriteLn('Try again .');Delay(3000);
  END;
 UNTIL (Exist(FN1)=True);
 Assign(FV1,FN1);
 Reset(FV1);
 FOR I:=1 TO 6 DO
 BEGIN
  Readln(FV1,Line1);
  T[I]:=Line1;
 END;
 I:=1;
 REPEAT
  ReadLn(FV1,fTEL,Af,Bf);
  A1[I,2]:=Af;
  A1[I,1]:=Bf;
  I:=I+1;
 UNTIL Eof(FV1);
 MaxTEL:=fTEL;
 Close(FV1);

 Hatch := False;
 HatchDen := 7;
 Write('Give Header-text : ');Read(Hdr1);WriteLn;

 Write('Give name of precipitation(-loss-)datafile ');LV;
 Write('(d:XXXXXPXX.DAT)  ');HV;Read(FN2);WriteLN;
 IF Exist(FN2)=True THEN
 BEGIN
  Assign(FV2,FN2);
  Reset(FV2);
  FOR I:=1 TO 6 DO
  BEGIN
   Readln(FV2,Line2);
   T[I]:=Line2;
  END;
  I:=1;
  REPEAT
   ReadLn(FV2,fTEL,Af,Bf);
   A2[I,2]:=Af;
   A1[I,1]:=Bf;
   I:=I+1;
  UNTIL Eof(FV2);
  Close(FV2);

  Write('Give Header-text : ');Read(Hdr2);WriteLn;
 END ELSE
 BEGIN
  Bell;WriteLn(FN2,' ... does not exist !');Delay(1000);
  Hatch := True;
  HatchDen := 7;
  FOR I:=1 TO 6 DO
  T[I]:=Line1;
  FOR I:=1 TO MaxTEL-1 DO
  BEGIN
   A2[I,2]:=A1[I,2];
  END;
  Hdr2:='';
 END;
 IF Hdr2='' THEN HdrTxt:=ConCat(' ',Hdr1,' ') ELSE
 HdrTxt:=ConCat(' ',Hdr1,' / ',Hdr2,' ');

 InitGraphic;
 ClearScreen;
 DisplyLen:=fTEL;
 SetColorWhite;
 SetBackground(0);
 SetHeaderOn;
 DefineWindow(1,0,0,XMaxGlb,YMaxGlb);
 DefineHeader(1,HdrTxt);
 DefineWorld(1,0,0,100,100);
 SelectWorld(1);
 SelectWindow(1);

 DrawBorder;
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 DrawHistogram(A1,-DisplyLen,Hatch,HatchDen);
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 DrawHistogram(A2,-DisplyLen,Hatch,HatchDen);
 FOR I:=1 TO 6 DO
 DrawTextW(50,10+I*5,1,T[I]);
END; (* P_Histogram *)


BEGIN (* Main   *)
      (*M24(64);*)
 P_Histogram(A1,A2);
 REPEAT UNTIL KeyPressed;
 Clearscreen;
 LeaveGraphic;
 Close(FV1);
 Close(FV2);
END; (* P_Histo *)
}
(*===================================================================*)
PROCEDURE P_Histo;                                    (*Find a World *)
(*===================================================================*)

VAR    I, DisplyLen, HatchDen : Integer;
       A1,A2                  : PlotArray;
       T                      : ARRAY[1..6] OF Str80;
       R                      : Real;
       Ch                     : Char;
       Hatch                  : Boolean;

       FV1,FV2                : Text;
       FN1,FN2                : Str14;
       dx,dy,TELdx,TELdy,
       TEL,fTEL,MaxTEL,Bf     : Integer;
       Af,Temp                : Real;
       Line1,Line2            : Str80;



PROCEDURE P_Histogram(A1,A2 : PlotArray);

BEGIN
 REPEAT
  Write('Give name of precipitation-datafile        ');LV;
  Write('(d:XXXXXPXX.DAT)  ');HV;Read(FN1);WriteLn;
  IF Exist(FN1)=False THEN
  BEGIN
   Bell;WriteLn(FN1,' ... does not exist !');
   WriteLn('Try again .');Delay(3000);
  END;
 UNTIL (Exist(FN1)=True);
 Assign(FV1,FN1);
 Reset(FV1);
 FOR I:=1 TO 6 DO
 BEGIN
  Readln(FV1,Line1);
  T[I]:=Line1;
 END;
 I:=1;
 REPEAT
  ReadLn(FV1,fTEL,Af,Bf);
  A1[I,2]:=Af;
  A1[I,1]:=Bf;
  I:=I+1;
 UNTIL Eof(FV1);
 MaxTEL:=fTEL;
 DisplyLen:=fTEL;
 Close(FV1);

 Hatch := False;
 HatchDen := 3;
 Write('Give Header-text : ');Read(Hdr1);WriteLn;

 Write('Give name of precipitation(-loss-)datafile ');LV;
 Write('(d:XXXXXPXX.DAT)  ');HV;Read(FN2);WriteLN;
 IF Exist(FN2)=True THEN
 BEGIN
  Assign(FV2,FN2);
  Reset(FV2);
  FOR I:=1 TO 6 DO
  BEGIN
   Readln(FV2,Line2);
   T[I]:=Line2;
  END;
  I:=1;
  REPEAT
   ReadLn(FV2,fTEL,Af,Bf);
   A2[I,2]:=Af;
   A2[I,1]:=Bf;
   I:=I+1;
  UNTIL Eof(FV2);
  Close(FV2);

  Write('Give Header-text : ');Read(Hdr2);WriteLn;
 END ELSE
 BEGIN
  Bell;WriteLn(FN2,' ... does not exist !');Delay(1000);
  FOR I:=1 TO 6 DO
  T[I]:=Line1;
  FOR I:=1 TO MaxTEL-1 DO
  BEGIN
   A2[I,2]:=A1[I,2];
   A2[I,1]:=A1[I,1];
  END;
  Hdr2:='';
 END;
 IF Hdr2='' THEN HdrTxt:=ConCat(' ',Hdr1,' ') ELSE
 HdrTxt:=ConCat(' ',Hdr1,' / ',Hdr2,' ');

 InitGraphic;
 ClearScreen;
 SetColorWhite;
 SetBackground(0);
 DefineWindow(1,0,0,XMaxGlb,YMaxGlb);
 DefineWindow(2,0,0,XMaxGlb,YMaxGlb);
 DefineHeader(2,HdrTxt);
 DefineWorld(1,0,1000,1000,0);
 SelectWindow(2);
 SetHeaderOn;

 FindWorld(2,A1,DisPlyLen,1,1);
 SelectWindow(2);
 DrawBorder;
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 DrawHistogram(A1,-DisplyLen,Hatch,HatchDen);
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 Hatch := True;
 DrawHistogram(A2,-DisplyLen,Hatch,HatchDen);
 SelectWorld(1);
 SelectWindow(1);
 dy:=100;TELdy:=1000 DIV dy;
 FOR TEL:=2 TO TELdy-1 DO
 DrawLine(50,TEL*dy,500,TEL*dy);
 WITH World[I] DO
 BEGIN
  Temp:=Y1;Y2:=Y1;Y2:=Temp;
 END;
 FOR I:=1 TO 6 DO
 DrawTextW(550,600+I*25,1,T[7-I]);
(*DrawTextW(300,500+I*50,1,T[I]);*)
(*Delay(1000);InvertScreen;*)
END; (* P_Histogram *)


BEGIN
      (*M24(64);*)
 P_Histogram(A1,A2);
 REPEAT UNTIL KeyPressed;
 LeaveGraphic;
END; (* P_Histo *)
{
(*===================================================================*)
PROCEDURE Q_Poly;                                     (* Fixed World *)
(*===================================================================*)

VAR
  N,I                    : Integer;
  B1,B2                  : PlotArray;
  T                      : ARRAY[1..6] OF Str80;
  Ch                     : Char;
  X1, X2                 : Integer;
  FV3,FV4                : Text;
  FN3,FN4                : Str14;
  TEL,fTEL,MaxTEL,Bf     : Integer;
  Af                     : Real;
  Line1,Line2            : Str80;


PROCEDURE Q_Polygon(B1,B2 : PlotArray);

BEGIN
 REPEAT
  Write('Give name of discharge-datafile              ');LV;
  Write('(d:XXXXXQXX.DAT)  ');HV;Read(FN3);WriteLN;
  IF Exist(FN3)=False THEN
  BEGIN
   Bell;WriteLn(FN3,' ... does not exist !');
   WriteLn('Try again .');Delay(3000);
  END;
 UNTIL (Exist(FN3)=True);
 Assign(FV3,FN3);
 Reset(FV3);
 FOR I:=1 TO 6 DO
 BEGIN
  ReadLn(FV3,Line1);
  T[I]:=Line1;
 END;
 I:=1;
 REPEAT
  ReadLn(FV3,fTEL,Af,Bf);
  B1[I,1]:=Bf;
  B1[I,2]:=Af;
  I:=I+1;
 UNTIL Eof(FV3);
 MaxTEL:=fTEL;
 N:=MaxTEL;
 Close(FV3);
 Write('Give Header-text : ');Read(Hdr1);WriteLn;
 HdrTxt:=Hdr1;

 Write('Give name of discharge(-separation-)datafile ');LV;
 Write('(d:XXXXXQXX.DAT)  ');HV;Read(FN4);WriteLN;
 IF Exist(FN4)=True THEN
 BEGIN
  Assign(FV4,FN4);
  Reset(FV4);
  FOR I:=1 TO 6 DO
  BEGIN
   Readln(FV4,Line2);
   T[I]:=Line2;
  END;
  I:=1;
  REPEAT
   ReadLn(FV4,fTEL,Af,Bf);
   B2[I,1]:=Bf;
   B2[I,2]:=Af;
   I:=I+1;
  UNTIL Eof(FV4);
  MaxTEL:=fTEL;
  N:=MaxTEL;
  Close(FV4);
  Write('Give Header-text : ');Read(Hdr2);WriteLn;
 END ELSE
 BEGIN
  Bell;WriteLn(FN4,' ... does not exist !');Delay(1000);
  FOR I:=1 TO 6 DO
  T[I]:=Line1;
  FOR I:=1 TO N-1 DO
  BEGIN
   B2[I,1]:=B1[I,1];
   B2[I,2]:=0.0;
  END;
  Hdr2:='';
 END;
 IF Hdr2='' THEN HdrTxt:=ConCat(' ',Hdr1,' ') ELSE
 HdrTxt:=ConCat(' ',Hdr1,' / ',Hdr2,' ');

 InitGraphic;
 SetBackground(0);
 SetHeaderOn;
 DefineWindow(1,0,0,XMaxGlb,YMaxGlb);
 DefineHeader(1,HdrTxt);
 DefineWorld(1,0,0,100,5000);
 SelectWorld(1);
 SelectWindow(1);
 DrawBorder;
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 DrawPolygon(B1,1,N,0,0,0);
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 DrawPolygon(B2,1,N,0,0,0);
 FOR I:=1 TO 6 DO
 DrawTextW(50,500+I*200,1,T[I]);
END; (* Q_Polygon *)

BEGIN (* Main   *)
      (*M24(64);*)
 Q_Polygon(B1,B2);
 REPEAT UNTIL KeyPressed;
 LeaveGraphic;
 Close(FV3);
 Close(FV4);
END; (* Q_Poly  *)
}
(*===================================================================*)
PROCEDURE Q_Poly;                                    (*Find a World *)
(*===================================================================*)

VAR    I,N                    : Integer;
       B1,B2                  : PlotArray;
       T                      : ARRAY[1..6] OF Str80;
       R                      : Real;
       Ch                     : Char;
       FV3,FV4                : Text;
       FN3,FN4                : Str14;
       dx,dy,TELdx,TELdy,
       TEL,fTEL,MaxTEL,Bf     : Integer;
       Af,Temp                : Real;
       Line1,Line2            : Str80;


PROCEDURE Q_Polygon(B1,B2 : PlotArray);

BEGIN
 REPEAT
  Write('Give name of discharge-datafile              ');LV;
  Write('(d:XXXXXQXX.DAT)  ');HV;Read(FN3);WriteLN;
  IF Exist(FN3)=False THEN
  BEGIN
   Bell;WriteLn(FN3,' ... does not exist !');
   WriteLn('Try again .');Delay(3000);
  END;
 UNTIL (Exist(FN3)=True);
 Assign(FV3,FN3);
 Reset(FV3);
 FOR I:=1 TO 6 DO
 BEGIN
  ReadLn(FV3,Line1);
  T[I]:=Line1;
 END;
 I:=1;
 REPEAT
  ReadLn(FV3,fTEL,Af,Bf);
  B1[I,1]:=Bf;
  B1[I,2]:=Af;
  I:=I+1;
 UNTIL Eof(FV3);
 MaxTEL:=fTEL;
 N:=MaxTEL;
 Close(FV3);
 Write('Give Header-text : ');Read(Hdr1);WriteLn;
 HdrTxt:=Hdr1;

 Write('Give name of discharge(-separation-)datafile ');LV;
 Write('(d:XXXXXQXX.DAT)  ');HV;Read(FN4);WriteLN;
 IF Exist(FN4)=True THEN
 BEGIN
  Assign(FV4,FN4);
  Reset(FV4);
  FOR I:=1 TO 6 DO
  BEGIN
   Readln(FV4,Line2);
   T[I]:=Line2;
  END;
  I:=1;
  REPEAT
   ReadLn(FV4,fTEL,Af,Bf);
   B2[I,1]:=Bf;
   B2[I,2]:=Af;
   I:=I+1;
  UNTIL Eof(FV4);
  MaxTEL:=fTEL;
  N:=MaxTEL;
  Close(FV4);
  Write('Give Header-text : ');Read(Hdr2);WriteLn;
 END ELSE
 BEGIN
  Bell;WriteLn(FN4,' ... does not exist !');Delay(1000);
  FOR I:=1 TO 6 DO
  T[I]:=Line1;
  FOR I:=1 TO N-1 DO
  BEGIN
   B2[I,1]:=B1[I,1];
   B2[I,2]:=0.0;
  END;
  Hdr2:='';
 END;
 IF Hdr2='' THEN HdrTxt:=ConCat(' ',Hdr1,' ') ELSE
 HdrTxt:=ConCat(' ',Hdr1,' / ',Hdr2,' ');

 InitGraphic;
 SetBackground(0);
 SetHeaderOn;
 DefineWindow(1,0,0,XMaxGlb,YMaxGlb);
 DefineWindow(2,0,0,XMaxGlb,YMaxGlb);
 DefineHeader(2,HdrTxt);
 DefineWorld(1,0,1000,1000,0);
 SelectWindow(2);
 SetHeaderOn;
 FindWorld(2,B1,N,1,1);
 SelectWindow(2);
 DrawBorder;
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 DrawPolygon(B1,1,N,0,0,0);
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 DrawPolygon(B2,1,N,0,0,0);
 SelectWorld(1);
 SelectWindow(1);
 dy:=100;TELdy:=1000 DIV dy;
 FOR TEL:=2 TO TELdy-1 DO
(*DrawLine(50,TEL*dy,1000,TEL*dy);*)
 DrawLine(50,TEL*dy,500,TEL*dy);
 WITH World[I] DO
 BEGIN
  Temp:=Y1;Y2:=Y1;Y2:=Temp;
 END;
 FOR I:=1 TO 6 DO
 DrawTextW(550,600+I*25,1,T[7-I]);
(*DrawTextW(50,300+I*50,1,T[I]);*)
(*Delay(1000);InvertScreen;*)
END; (* Q_Polygon *)

BEGIN
      (*M24(64);*)
 Q_Polygon(B1,B2);
 REPEAT UNTIL KeyPressed;
 LeaveGraphic;
END; (* Q_Poly *)

(*===================================================================*)
PROCEDURE UH_grph;
(*===================================================================*)

VAR
  N,I                    : Integer;
  C                      : PlotArray;
  T                      : ARRAY[1..6] OF Str80;
  Ch                     : Char;
  X1, X2                 : Integer;
  FV5                    : Text;
  FN5                    : Str14;
  TEL,fTEL,MaxTEL,Bf     : Integer;
  Af                     : Real;
  Line1,Line2            : Str80;


PROCEDURE UH_Poly(C : PlotArray);

BEGIN
 REPEAT
  Write('Give name of unit hydrograph-datafile      ');LV;
  Write('(d:XXXXXQXX.DAT)  ');HV;Read(FN5);WriteLN;
  IF Exist(FN5)=False THEN
  BEGIN
   Bell;WriteLn(FN5,' ... does not exist !');
   WriteLn('Try again .');Delay(3000);
  END;
 UNTIL (Exist(FN5)=True);
 Assign(FV5,FN5);
 Reset(FV5);
 FOR I:=1 TO 6 DO
 BEGIN
  ReadLn(FV5,Line1);
  T[I]:=Line1;
 END;
 I:=1;
 REPEAT
  ReadLn(FV5,fTEL,Af,Bf);
  C[I,1]:=Bf;
  C[I,2]:=Af;
  I:=I+1;
 UNTIL Eof(FV5);
 MaxTEL:=fTEL;
 N:=MaxTEL;
 Close(FV5);
 Write('Give Header-text : ');Read(Hdr);WriteLn;
 HdrTxt:=Hdr;

 InitGraphic;
 ClearScreen;
 DefineWindow(1, 0, 0, XMaxGlb, YMaxGlb);
 DefineHeader(1,HdrTxt);
 DefineWorld(1,0,0,50,1);
 SelectWorld(1);
 SelectWindow(1);
 SetBackground(0);
 SetHeaderOn;
 DrawBorder;
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 DrawPolygon(C,1,N,0,0,0);
 FOR I:=1 TO 6 DO
 DrawTextW(25,0.1+I*0.05,1,T[I]);
END; (* U_H *)


BEGIN(* Main    *)
     (*M24(64); *)
 UH_Poly(C);
 REPEAT UNTIL KeyPressed;
 LeaveGraphic;
 Close(FV5);
END; (* U_Hgrph *)


(*===================================================================*)
PROCEDURE Smooth_UH;
(*===================================================================*)

VAR
  N,I                    : Integer;
  D                      : PlotArray;
  T                      : ARRAY[1..6] OF Str80;
  Ch                     : Char;
  X1, X2                 : Integer;
  FV6                    : Text;
  FN6                    : Str14;
  TEL,fTEL,MaxTEL,Bf     : Integer;
  Af                     : Real;
  Line1,Line2            : Str80;


PROCEDURE UH_smooth(D : PlotArray);

BEGIN
 REPEAT
  Write('Give name of unit hydrograph-datafile      ');LV;
  Write('(d:XXXXXQXX.DAT)  ');HV;Read(FN6);WriteLN;
  IF Exist(FN6)=False THEN
  BEGIN
   Bell;WriteLn(FN1,' ... does not exist !');
   WriteLn('Try again .');Delay(3000);
  END;
 UNTIL (Exist(FN6)=True);
 Assign(FV6,FN6);
 Reset(FV6);
 FOR I:=1 TO 6 DO
 BEGIN
  ReadLn(FV6,Line1);
  T[I]:=Line1;
 END;
 I:=1;
 REPEAT
  ReadLn(FV6,fTEL,Af,Bf);
  D[I,1]:=Bf;
  D[I,2]:=Af;
  I:=I+1;
 UNTIL Eof(FV6);
 MaxTEL:=fTEL;
 N:=MaxTEL;
 Close(FV6);
 Write('Give Header-text : ');Read(Hdr);WriteLn;
 HdrTxt:=Hdr;

 InitGraphic;
 ClearScreen;
 DefineWindow(1, 0, 0, XMaxGlb, YMaxGlb);
 DefineHeader(1,HdrTxt);
 DefineWorld(1,0,0,50,1);
 SelectWorld(1);
 SelectWindow(1);
 SetBackground(0);
 SetHeaderOn;
 DrawBorder;
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 Spline(D,N,D[2,1],D[N-1,1],D,50);
 DrawPolygon(D,1,N,0,0,0);
 FOR I:=1 TO 6 DO
 DrawTextW(45,0.1+I*0.05,1,T[I]);
END; (* UH_Smoooth *)


BEGIN(* Main      *)
     (*M24(64);   *)
 UH_Smooth(D);
 REPEAT UNTIL KeyPressed;
 LeaveGraphic;
 Close(FV6);
END; (* Smooth_uh *)


(*===================================================================*)
PROCEDURE PQ_Wind;
(*===================================================================*)

VAR

  I,N,DisplyLen,HatchDen,
  X1, X2                      : Integer;
  E,F                         : PlotArray;
  T1,T2                       : ARRAY[1..6] OF Str80;
  R                           : Real;
  Ch                          : Char;

  FV,FilVar                   : Text;
  FN,FileName                 : Str14;
  TEL,fTEL,MaxTEL,Bf          : Integer;
  Af                          : Real;
  Line                        : Str80;
  CharHeight,CharWidth        : Real;


PROCEDURE Total_Wind;

PROCEDURE P_Histo_Wind;

VAR Hatch : Boolean;

BEGIN
 DefineWindow(2,Trunc(XMaxGlb/10),Trunc(3*YMaxGlb/20),
                Trunc(XMaxGlb/2),Trunc(1*YMaxGlb/2));
 DefineWorld(2,0,0,100,100);

 SelectWorld(2);
 SelectWindow(2);
 SetHeaderOn;
 DefineHeader(2,HdrTxt1);
 SetBackground(0);
 DrawBorder;
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 Hatch := True;
 HatchDen := 2;

 DrawHistogram(E,-DisplyLen,Hatch,HatchDen);
END; (* P_Histo_Wind *)


PROCEDURE Q_Poly_Wind;

BEGIN
 DefineWindow(3,Trunc(XMaxGlb/10),Trunc((YMaxGlb*12)/20),
                Trunc(XMaxGlb*5/10),Trunc((YMaxGlb*19)/20));
 DefineWorld(3,0,0,100,5000);

 SelectWorld(3);
 SelectWindow(3);
 SetBackground(0);
 SetHeaderOn;
 DefineHeader(3,HdrTxt2);
 DrawBorder;
 DrawAxis(8,-8,0,0,0,0,0,0,True);
 DrawPolygon(F,1,N,0,0,0);

 DefineWindow(4,Trunc(XMaxGlb*21/40),Trunc(3*YMaxGlb/20),
                Trunc(XMaxGlb*19/20),Trunc((YMaxGlb*19)/20));
 DefineWorld(4,0,0,250,250);

 SelectWorld(4);
 SelectWindow(4);
 SetBackground(0);
 DrawBorder;

 FOR I:=1 TO 6 DO
 DrawTextW(5,10+I*10,1,T1[I]);
 FOR I:=1 TO 6 DO
 DrawTextW(5,150+I*10,1,T2[I]);
END;  (* Q_Poly_Wind *)

BEGIN
 REPEAT
  Write('Give name of precipitation-datafile  ');LV;Write('(d:XXXXXPXX.DAT)  ');
  HV;Read(FileName);WriteLn;
  IF Exist(FileName)=False THEN
  BEGIN
   Bell;WriteLn(FileName,' does not exist !');
   WriteLn('Try again .');Delay(3000);
  END;
 UNTIL (Exist(FileName)=True);
 Write('Give Header-text : ');Read(Hdr1);WriteLn;
 HdrTxt1:=Hdr1;
 Assign(Filvar,FileName);
 Reset(Filvar);
 FOR I:=1 TO 6 DO
 BEGIN
  Readln(Filvar,Line);
  T1[I]:=Line;
 END;
 I:=1;
 REPEAT
  ReadLn(Filvar,fTEL,Af,Bf);
  E[I,2]:=Af;
  E[I,1]:=Bf;
  I:=I+1;
 UNTIL Eof(Filvar);
 DisplyLen:=fTEL;

 REPEAT
  Write('Give name of discharge    -datafile  ');LV;Write('(d:XXXXXQXX.DAT)  ');
  HV;Read(FN);WriteLn;
  IF Exist(FN)=False THEN
  BEGIN
   Bell;WriteLn(FN,' does not exist !');
   WriteLn('Try again .');Delay(3000);
  END;
 UNTIL (Exist(FN)=True);
 Write('Give Header-text : ');Read(Hdr2);WriteLn;
 IF Hdr2='' THEN HdrTxt:=Hdr1 ELSE
 HdrTxt2:=Hdr2;
 HdrTxt:=ConCat('CONCATENATED ',Hdr1,'  /  ',Hdr2,' GRAPHICS');
 Assign(FV,FN);
 Reset(FV);
 FOR I:=1 TO 6 DO
 BEGIN
  ReadLn(FV,Line);
  T2[I]:=Line;
 END;
 I:=1;
 REPEAT
  ReadLn(FV,fTEL,Af,Bf);
  F[I,1]:=Bf;
  F[I,2]:=Af;
  I:=I+1;
 UNTIL Eof(FV);
 MaxTEL:=fTEL;
 N:=MaxTEL;

(*M24(64);*)
 InitGraphic;
 DrawBorder;
 DefineWindow(1,2,10,XmaxGlb-2,YMaxGlb-10);
 DefineHeader(1,HdrTxt);
 SetHeaderOn;
 SelectWindow(1);
 SelectWorld(1);
 DefineWorld(1,0,0,XmaxGlb,YMaxGlb);
 DrawBorder;
 SetBackground(51);
 P_Histo_Wind;
 Q_Poly_Wind;
END;

BEGIN(* Main    *)
 Total_Wind;
 REPEAT UNTIL KeyPressed;
 LeaveGraphic;
 Close(FilVar);
 Close(FV);
END; (* PQ_Wind *)

(*===================================================================*)
PROCEDURE Graphics_Menu;
(*===================================================================*)

BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='GRAPHICS MENU';
  CASE Menu('Histo_p Poly_q Unit_hydrogr Wind_pq Smooth_uh Quit') OF

     'H' :  BEGIN
             P_Histo;
            END;
     'P' :  BEGIN
             Q_Poly;
            END;
     'S' :  BEGIN
             Smooth_uh;
            END;
     'U' :  BEGIN
             UH_grph;
            END;
     'W' :  BEGIN
             PQ_Wind;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN
             Quit:=True;
            END; (* Quit *)
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END;   (* Graphics_Menu *)

(*===================================================================*)
(*                           MAINPROGRAM                             *)
(*===================================================================*)

BEGIN
 Start:
 Scroll;ClrScr;
 GotoXY(12,5);
 Write('H H H H H H H H H H H H H H H H H H H H H H H H H H H H H');
 GotoXY(12,6);
 Write('H                                                       H');
 GotoXY(12,7);
 Write('H                                                       H');
 GotoXY(12,8);
 Write('H          HYDROLIN/1.00  TURBO  GRAPHICS               H');
 GotoXY(12,9);
 Write('H                                                       H');
 GotoXY(12,10);
 Write('H                                                       H');
 GotoXY(12,11);
 Write;
 GotoXY(12,12);
 Write('          ');LV;Write('TU DELFT / Ct   (C)    M.J. Vos   ');
 HV;GotoXY(12,13);
 Write;
 GotoXY(12,14);
 Write('H                                                       H');
 GotoXY(12,15);
 Write('H H H H H H H H H H H H H H H H H H H H H H H H H H H H H');
  Delay(3000);HV;
 Graphics_Menu;
 GotoXY(20,10);
 Write('Do you want to use more Graphics ?');LV;Write('  (Y/N)');Read(Kbd,Ch);
 HV;WriteLn;
 IF Ja THEN GOTO Start ELSE
 IF Yes('... are you sure ?') THEN
 BEGIN
  Bell;Scroll;ClrScr;
  FOR TEL:=1 TO 2 DO
  BEGIN
   Bell;GotoXY(20,10);Write('Exit  ///  HYDROLIN 1.00 - GRAPHICS  ///');
   Delay(1000);ClrLine(1,10);Delay(1000);
  END;
  Scroll;ClrScr;
 END ELSE
 GOTO Start;
 Exit:
 Assign(FilVar,'a:HYDRODAT.COM');
 Execute(Filvar);
END. (* HYDROGR.PAS *)

(*END ====================== HYDROGR.PAS =========================== *)

