(**********************************************************************
* HYDROL01.INC                                                        *
*                                                                     *
* CONTENTS :                                                          *
*                                                                     *
* MISCELLANEOUS HYDROLIN-PROCEDURES         TU DELFT / M.J.Vos / 1988 *
***********************************************************************
* File_Name_Num; File_Renum; File_Text; Input_File; Keyboard_Input;   *
* Input_Menu; Hydr_Edit.                                              *
**********************************************************************)


(*===================================================================*)
PROCEDURE File_Name_Num;
(*===================================================================*)

BEGIN
 REPEAT
  Scroll;ClrScr;
  GotoXY(20,1);Write('*** DATA-FILE : NAME / NUMBER ***'); WriteLn;Delay(500);
  LV;Write('Default drive is');HV;Write(' b:');WriteLn;Delay(500);
  LV;WriteLn('Give your file-identification : ');WriteLn;
  Write('of exactly');HV;Write(' 5 ');LV;Write('characters ');WriteLn;
  WriteLn('without: drivenr.(d:), [|.\:";/<*]+> and filetype(.typ) : ',Chr(22));
  WriteLn;Write('XXXXX',Chr(13));HV;Read(FNM);WriteLn;
  Delay(500);
  LV;WriteLn('Give your file-specification : ');WriteLn;
  HV;Write('PB');LV;Write(' = bruto             precipitation;');
  WriteLn;
  HV;Write('PW');LV;Write(' = zeros wiped       precipitation ;');
  WriteLn;
  HV;Write('PI');LV;Write(' = initial losses    precipitation;');
  WriteLn;
  HV;Write('PF');LV;Write(' = phi-index loss    precipitation;');
  WriteLn;
  HV;Write('PU');LV;Write(' = user-def loss     precipitation;');
  WriteLn;
  HV;Write('PN');LV;Write(' = nett              precipitation;');
  WriteLn;
  HV;Write('PT');LV;Write(' = accumulated nett  precipitation;');
  WriteLn;WriteLn;Delay(500);
  HV;Write('QB');LV;Write(' = bruto             discharge;');
  WriteLn;
  HV;Write('QC');LV;Write(' = constant separ.  discharge ;');
  WriteLn;
  HV;Write('QL');LV;Write(' = linear separation discharge ;');
  WriteLn;
  HV;Write('QU');LV;Write(' = user-def separ.   discharge ;');
  WriteLn;
  HV;Write('QN');LV;Write(' = nett              discharge;');
  WriteLn;
  HV;Write('QW');LV;Write(' = zeros wiped       discharge');
  WriteLn;
  HV;Write('QT');LV;Write(' = accumulated nett  discharge;');
  WriteLn;WriteLn;
  HV;Write('UH');LV;Write(' = unit hydrograph            .');
  WriteLn;WriteLn;
  Write('XX',Chr(13));HV;Read(FileSpec);WriteLn;
  LV;Write('Give your file-number : (');HV;Write('0,1,2');
  LV;Write(' or');HV;Write(' 3) :');WriteLn;WriteLn;
  Write('X',Chr(13));HV;Read(FileNumE);WriteLn;
  WriteLn(Chr(22));
  FileName:=Concat('b:',FNM,FileSpec,FileNumE,'.DAT');
  IF Exist(FileName)=True THEN
  BEGIN
   Bell;
   WriteLn(FileName,' already exists !');Delay(1000);
   WriteLn('You should assemble another name ');
   Write('or do you want to overwrite an existing file ?');LV;
   Write(' (Y/N)');HV;WriteLn;Read(Kbd,Ch);
  END;
 UNTIL (Exist(FileName)=False OR (Ch IN ['y','Y']));
END; (* File_Name_Num *)


(*=================================================================*)
PROCEDURE File_Renum;
(*=================================================================*)

Label  DoIt;

BEGIN
 Scroll;ClrSCr;
 GotoXY(20,1);Write('*** DATA-FILE : RENUMBER ***');WriteLn;Delay(500);
 LV;Write('Default drive is ');HV;Write('b:');LV;WriteLn;WriteLn;Delay(500);
 WriteLn('If you desire substitutions in the source-program, consult the ');
 HV;WriteLn('                TU DELFT / HOLLAND.');WriteLn;Delay(500);
 WriteLn;
 Write('Do you want to use File_Handling ?  ');LV;Write('(Y/N)');HV;
 Read(Kbd,Ch);WriteLn;IF Ja THEN File_Handling;

 FNM:=Copy(FileName,3,7);
 FileSpec:=Copy(FileName,8,9);
 FileNumE:=Copy(FileName,10,10);

 IF FileNumE='0' THEN
 BEGIN FileNumR:='1';GOTO DoIt; END ELSE
 IF FileNumE='1' THEN
 BEGIN FileNumR:='2';GOTO DoIt; END ELSE
 IF FileNumE='2' THEN
 BEGIN FileNumR:='3';GOTO DoIt; END ELSE
 IF FileNumE='3' THEN
 BEGIN
  LV;Write('Overwrite an existing datafile ? ');HV;
  Write('(Y/N)');Read(Kbd,Ch);WriteLn;
  IF Ja THEN
  REPEAT
   LV;Write('Give datafile-');HV;Write('number : ');
   Read(FileNumR);WriteLn;
  UNTIL Yes('... are you sure ?') ELSE
  BEGIN
   WriteLn('This edited version will be saved as number 4,');
   WriteLn('but will be operable after: Copy/Delete/Rename');
   WriteLn('with sequence-number 1,2 or 3 in FileHandling.');WriteLn;
   FileNumR:='4';
  END;
 END;
 DoIt:
 FileName:=Concat('b:',FNM,FileSpec,FileNumR,'.DAT');
END; (* File_Renum *)


(*===================================================================*)
PROCEDURE File_Text; {Implemented with six textlines}
(*===================================================================*)

BEGIN
  Scroll;ClrScr;
  GotoXY(20,1);Write('*** DATA-FILE : TEXT ***');WriteLn;
  LV;Write('Project/version/Nr.                   : ');HV;
  Read(Line);WriteLn;
  LV;Write('Date      (jjmmdd)                    : ');HV;
  Read(jjmmdd);WriteLn;
  LV;Write('Dimension of ',StrPQ:20,'     : ');HV;
  Read(DimStrPQ);WriteLn;
  LV;Write('Dimension of ',Strt:20,'     : ');HV;
  Read(DimStrt);WriteLn;Seq:='SEQ.NR';Spc:='      ';
  WriteLn(FV,'Project/Version/Nr.      : ',Line);
  WriteLn(FV,'Date      (jjmmdd)       : ',jjmmdd);
  WriteLn(FV);
  WriteLn(FV,Seq:6,StrPQ:20,Strt:20);
  WriteLn(FV,Spc:6,DimStrPQ:20,DimStrt:20);
  WriteLn(FV);
  Scroll;ClrScr;
END; (* File_Text *)


(*===================================================================*)
PROCEDURE Input_File;
(*===================================================================*)

VAR  bTEL : Integer;

BEGIN
ClrScr;
REPEAT
 Write('Give input-filename ');LV;Write('(d:inputfile.dat) : ');HV;
 HV;Read(FileName);WriteLn;
 IF Exist(FileName)=False THEN
 BEGIN
  Bell;
  WriteLn('File does not exist !');
  Delay(3000);
 END;
UNTIL Exist(FileName)=True;Scroll;ClrScr;

Assign(FV,FileName);
Reset(FV);
WriteLn;
FOR TEL:=0 TO Arr_Afm DO
BEGIN
 PQ[TEL]:=0.0E00;
 t[TEL]:=00;
END; (* Initialisation *)

BEGIN
FOR tTEL:=1 TO 3 DO
 BEGIN
  Readln(FV,Line);
  WriteLn(CON,Line);
 END;
 ReadLn(FV,Seq,StrPQ,Strt);
 WriteLn(CON,Seq:6,StrPQ:20,Strt:20);
 ReadLn(FV,Spc,DimStrPQ,DimStrt);
 WriteLn(CON,Spc:6,DimStrPQ:20,DimStrt:20);
 Readln(FV,Line);
 WriteLn(CON,Line);
 Delay(200);
END; (* Text *)
fTEL:=0;bTEL:=1;
 REPEAT
  fTEL:=fTEL+1;
  IF fTEL=bTEL*15 THEN
  BEGIN
   bTEL:=bTEL+1;
   WriteLn;PressKey;
   Scroll;ClrScr;
   WriteLn(CON);
   WriteLn(CON,Seq:6,StrPQ:20,Strt:20);
   WriteLn(CON,Spc:6,DimStrPQ:20,DimStrt:20);
   WriteLn(CON,'-----------------------------------------------');
   WriteLn(CON);
  END;
  Readln(FV,fTEL,Af,Bf);
  TEL:=fTEL;
  PQ[TEL]:=Af;
  t[TEL]:=Bf;
  WriteLn(CON,TEL:6,PQ[TEL]:20:3,t[TEL]:20);
  Delay(200);
 UNTIL Eof(FV);
MaxTEL:=TEL;
Close(FV);

REPEAT
 WriteLn;
 Write('Repeated display of the file-contents ?  ');LV;
 Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;Scroll;ClrScr;
 IF JA THEN
 BEGIN
  WriteLn(CON);
  WriteLn(CON,Seq:6,StrPQ:20,Strt:20);
  WriteLn(CON,Spc:6,DimStrPQ:20,DimStrt:20);
  WriteLn(CON,'-----------------------------------------------');
  WriteLn(CON);
  BEGIN
   bTEL:=1;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF TEL=bTEL*15 THEN
    BEGIN
     bTEL:=bTEL+1;
     WriteLn;PressKey;
     Scroll;ClrScr;
     WriteLn(CON);
     WriteLn(CON,Seq:6,StrPQ:20,Strt:20);
     WriteLn(CON,Spc:6,DimStrPQ:20,DimStrt:20);
     WriteLn(CON,'-----------------------------------------------');
     WriteLn(CON);
    END;
    WriteLn(CON,TEL:6,PQ[TEL]:20:3,t[TEL]:20);
    Delay(200);
   END;
  END;
 END;
UNTIL Nee;
END; (* Input_File *)


(*===================================================================*)
PROCEDURE Keyboard_Input;
(*===================================================================*)

LABEL Exit;

BEGIN
 ClrScr;

 FOR TEL:=0 TO Arr_Afm DO
 BEGIN
  PQ[TEL]:=0.0E00;
  t[TEL]:=00;
 END; (* Initialisering *)

 GotoXY(1,1);Write(Seq);
 GotoXY(15,1);Write(StrPQ);GotoXY(40,1);Write(Strt);LV;
 GotoXY(1,2);Write('-----------------------------------------------');
 HV;TEL:=0;
 REPEAT
  TEL:=TEL+1;
  GotoXY(1,TEL+3);Write(TEL:6);
  GotoXY(15,TEL+3);Read(Apr);
  GotoXY(40,TEL+3);Read(Bpr);
  PQ[TEL]:=Apr;
  t[TEL]:=Bpr;
  GotoXY(1,TEL+4);LV;
  Write('Continue wih <RETURN>   <<==>>   Stop with  S ');Read(Kbd,Ch);
  ClrLine(1,TEL+4);HV;
 UNTIL (Ch IN ['S','s']);
 MaxTEL:=TEL;
 Scroll;ClrScr;
 Write(Seq:6);Write(StrPQ:20);Write(Strt:20);WriteLn;
 LV;WriteLn('-----------------------------------------------');HV;
 WriteLn;
 REPEAT
  BEGIN
   bTEL:=1;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF TEL=bTEL*15 THEN
    BEGIN
     bTEL:=bTEL+1;
     WriteLn;PressKey;
     Scroll;ClrScr;
     Write(Seq:6);Write(StrPQ:20);Write(Strt:20);WriteLn;
     LV;Write('-----------------------------------------------');HV;
     WriteLn;
    END;
    WriteLn(CON,TEL:6,PQ[TEL]:20:3,t[TEL]:20);
    Delay(200);
   END;
  END;
  WriteLn;
  Write('Repeated display of the file-contents ?  ');LV;
  Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;Scroll;ClrScr;
 UNTIL Nee;
 Write('SAVE keyboard-input ?');LV;Write(' (Y/N)');
 HV;Read(Kbd,Ch);WriteLn;ClrScr;
 IF Ja THEN
 REPEAT
  File_Name_Num;
  IF Exist(FileName)=True THEN
  BEGIN
   Bell;
   WriteLn(FileName,' exists !');
   Delay(1000);
   Write('Overwrite ',FileName,' ?');LV;Write(' (Y/N)');HV;
   Read(Kbd,Ch);WriteLn;
  END;
 UNTIL ((Exist(FileName)=False) OR Ja);
 Assign(FV,FileName);
 ReWrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 BEGIN
  fTEL:=TEL;
  Af:=PQ[TEL];
  Bf:=t[TEL];
  WriteLn(FV,fTEL:6,Af:20:3,Bf:20);
 END;
 Close(FV);
 PressKey;
END; (* Keyboard_Input *)


(*===================================================================*)
PROCEDURE Input_Menu;
(*===================================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='INPUT MENU';
  CASE Menu('Keyboard Filehandling Inputfile Test Quit') OF

      'F' :  BEGIN
              File_Handling;
             END;
      'K' :  BEGIN
              WriteLn('Used for first input of data.');Delay(1000);
              WriteLn('For modifications use the I option.');Delay(1000);
              Write('Do you want to continue ? ');LV;Write('(Y/N)');
              HV;Read(Kbd,Ch);WriteLn;PressKey;
              IF Ja THEN Keyboard_Input ELSE
             END;
      'I' :  BEGIN
              WriteLn('Used for modifications. ');Delay(1000);
              WriteLn('Use for first input of data the K option.');Delay(1000);
              Write('Do you want to continue ? ');LV;Write('(Y/N)');
              HV;Read(Kbd,Ch);WriteLn;PressKey;
              IF Ja THEN Input_File ELSE
             END;
      'T' :  BEGIN
              LV;WriteLn('TestFiles :');
              Write('Precipitation : ');HV;Delay(1000);
              Write('b:12345PB0.DAT');WriteLn;LV;
              Write('Discharge     : ');HV;Delay(1000);
              Write('b:12345QB0.DAT');WriteLn;
              Write('Do you want to continue ?');LV;Write(' (Y/N) ');HV;
              WriteLn;Read(Kbd,Ch);
              IF Ja THEN Input_File ELSE
             END;
      'Q' :  BEGIN
              IF Yes('... are you sure ?') THEN Quit:=True;
             END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
 Scroll;ClrScr;
END; (* Input-Menu *)


(*===================================================================*)
PROCEDURE Hydr_Edit;
(*===================================================================*)

LABEL Exit;

VAR   bTEL :Integer;

BEGIN
 Scroll;GotoXY(20,12);
 Write('      /// HYDR');LV;Write('olin-');HV;Write('EDIT');
 LV;Write('er ');HV;Write('1.00 ///  ');
 Delay(3000);Scroll;ClrScr;
 WriteLn('You will see the contents of a chosen input-file.');WriteLn;
 WriteLn('Afterwards remember the sequential line-numbers to edit !');
 PressKey;
 Input_File;
 Write('Do you want to continue with HYDREDIT ?  ');LV;
 Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;IF Nee THEN GOTO Exit;
 REPEAT
  PressKey;
  GotoXY(1,1);LV;WriteLn('HYDREDIT 1.00');HV;
  GotoXY(1,5);Write(Seq:6);
  GotoXY(15,5);Write(StrPQ:20);GotoXY(40,5);Write(Strt:20);LV;
  GotoXY(1,6);Write('-----------------------------------------------');
  HV;WriteLn;
  sTEL:=0;
  REPEAT
   GotoXY(1,7+sTEL);Write(Seq:6,' : ');Read(TEL);
   GotoXY(1,7+sTEL);ClrEol;
   GotoXY(1,7+sTEL);Write(TEL:6);
   GotoXY(15,7+sTEL);Write(PQ[TEL]:20);LV;Write(' wordt ');
   HV;Af:=PQ[TEL];Read(Af);PQ[TEL]:=Af;
   GotoXY(15,7+sTEL);ClrEol;Write(PQ[TEL]:20);
   GotoXY(40,7+sTEL);Write(t[TEL]:20);LV;Write(' wordt ');
   HV;Bf:=t[TEL];Read(Bf);t[TEL]:=Bf;
   GotoXY(40,7+sTEL);ClrEol;
   Write(t[TEL]:20);WriteLn;WriteLn;
   GotoXY(1,23);LV;Write('More ?   (Y/N)');Read(Kbd,Ch);
   GotoXY(1,23);ClrEol;
   WriteLn;HV;
   sTEL:=sTEL+1;
  UNTIL Nee;
  REPEAT
   Scroll;ClrScr;
   GotoXY(1,1);LV;WriteLn('HYDREDIT 1.00');HV;
   GotoXY(1,5);Write(Seq:6);
   Write(StrPQ:20);Write(Strt:20);LV;
   GotoXY(1,6);Write('-----------------------------------------------');
   HV;WriteLn;
   TEL:=1;bTEL:=1;
   WHILE t[TEL]<>00 DO
   BEGIN
    WriteLn(CON,TEL:6,PQ[TEL]:20:3,t[TEL]:20);
    Delay(200);
    TEL:=TEL+1;
    IF TEL=bTEL*15 THEN
    BEGIN
     bTEL:=bTEL+1;
     WriteLn;PressKey;
    END; (* Block *)
   END;
   WriteLn;WriteLn;WriteLn('End of data-file.');
   WriteLn;Write('Repeated display of file-contents ?  ');LV;
   Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;
  UNTIL Nee;
  WriteLn;WriteLn;GotoXY(1,12);
  Write('      ||| End of Edit-session ||| ?  ');LV;
  Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;
 UNTIL (Ja AND Yes('... o.k. ?'));
 Write('Save data ?  ');LV;Write(' (Y/N)');Read(Kbd,Ch);WriteLn;
 IF Ja THEN {Save_Data}
 BEGIN
  LV;Write('Previous FileName                        : ');HV;
  Write(FileName);WriteLn;
  REPEAT
  Scroll;ClrScr;
  File_Renum;
  LV;Write('Next FileName in sequence    : ');HV;
  Write(FileName);WriteLn;
  IF Exist(FileName)=True THEN
   BEGIN
    Bell;WriteLn(FileName,' exists !');
    Delay(1000);
    WriteLn('Overwrite ',FileName,' ?');LV;Write(' (Y/N)');HV;
    Read(Kbd,Ch);WriteLn;
   END;
  UNTIL ((Exist(FileName)=False) OR Ja);
  Assign(FV,FileName);
  Rewrite(FV);
  File_Text;
  TEL:=1;
  WHILE t[TEL]<>0 DO
  BEGIN
   fTEL:=TEL;
   Af:=PQ[TEL];
   Bf:=t[TEL];
   WriteLn(FV,fTEL:6,Af:20,Bf:20);
   TEL:=TEL+1;
  END;
  Close(FV);
  PressKey;
  Scroll;ClrScr;
 END;
 Exit:
END; (* Hydr_Edit *)

(*END ======================= HYDROL01.INC ======================= *)