(**********************************************************************
* HYDROL02.INC                                                        *
*                                                                     *
* CONTENTS                                                            *
*                                                                     *
* MISCELLANEOUS HYDROLIN-PROCEDURES         TU DELFT / M.J.Vos / 1988 *
***********************************************************************
* Time_Step; Area_Define; Zero_Wiping; Initial_Loss; Phi_Index;       *
* Nett_Precip;Precip_Conversion; Accumul_Nett_Precip; Precip_Menu.    *
**********************************************************************)

(*===================================================================*)
PROCEDURE Time_Step;
(*===================================================================*)

VAR  dt,ts,nTEL,nMaxTEL,
     timestep           : Integer;
     nPQ                : Arr;
     nt                 : ArrInt;
     iPQ                : Real;

BEGIN
 ClrScr;
 Quit:=False;
 WriteLn('WARNING !');Delay(1000);WriteLn;LV;
 WriteLn('The program will give a runtime error if the declared bounds ');
 WriteLn('of a new timestep-array  - initiated in the constant : Arr_Afm');
 WriteLn('in the declarationlist at the beginning of the program HYDRODAT -');
 WriteLn('will be to small.');HV;PressKey;
 REPEAT
  Menu_Heading:='TIME-STEP MENU';
  CASE Menu('Precipitation Discharge Quit') OF

'P' :
   BEGIN
    WriteLn;Write('Give filename ...');LV;Write('  (d:XXXXXPXXX.DAT)');HV;
    WriteLn;Delay(3000);
    Input_File;
    Write('Give a new timestep            : ');Read(timestep);WriteLn;

    ts:=timestep;
    dt:=t[2]-t[1];
    TEL:=0;nTEL:=0;
    PQ[0]:=0.0E00;nPQ[0]:=0.0E00;
    t[0]:=0;nt[0]:=0;

    IF ts<=dt THEN     (* Smaller timestep *)
    REPEAT
     TEL:=TEL+1;
     REPEAT
      nTEL:=nTEL+1;
      nt[nTEL]:=nt[nTEL-1]+ts;
      nPQ[nTEL]:=PQ[TEL];
     UNTIL nt[nTEL]>=t[TEL];
     nPQ[nTEL]:=PQ[TEL]*(t[TEL]-nt[nTEL-1])/dt+PQ[TEL+1]*(nt[nTEL]-t[TEL])/dt;
    UNTIL TEL=MaxTEL;

    IF ts>dt THEN     (* Bigger timestep *)
    REPEAT
     nTEL:=nTEL+1;
     nt[nTEL]:=nt[nTEL-1]+ts;
     REPEAT
      TEL:=TEL+1;
      nPQ[nTEL]:=nPQ[nTEL-1]+PQ[TEL];
     UNTIL t[TEL]>=nt[nTEL];
     iPQ:=((nt[nTEL]-t[TEL-1])/dt)*PQ[TEL];
     iPQ:=iPQ+((t[TEL]-nt[nTEL])/dt)*PQ[TEL+1];
     nPQ[nTEL]:=(nPQ[nTEL]-PQ[TEL]+iPQ)*dt/(nt[nTEL]-nt[nTEL-1]);
    UNTIL TEL=MaxTEL;
    nMaxTEL:=nTEL;

    FNM:=Copy(FileName,3,7);
    FileName:=Concat('b:',FNM,'PTS.DAT');
    WriteLn('Your timestep-filename will be b:',FNM,'PTS.DAT');
    Write('Do you agree ? ');LV;Write(' (Y/N)');HV;Read(Kbd,Ch);WriteLn;
    IF Nee THEN
     BEGIN
      LV;Write('Give your name of the file : ');HV;Read(FileName);WriteLn;
     END;
    Assign(FV,FileName);
    ReWrite(FV);
    File_Text;
    FOR nTEL:=1 TO nMaxTEL DO
    BEGIN
     Af:=nPQ[nTEL];
     Bf:=nt[nTEL];
     WriteLn(FV,nTEL:6,Af:20:3,Bf:20);
    END;
    Close(FV);
    WriteLn('Your filename has received a new number only !');
    WriteLn('If you want to rename : use the procedure Filehandling .');
    PressKey;
   END; (* Precipitation *)

'D' :

   BEGIN
    WriteLn;Write('Give filename ...');LV;Write('  (d:XXXXXQXX.DAT)');HV;
    WriteLn;Delay(3000);
    Input_File;
    Write('Give a new timestep   : ');Read(timestep);WriteLn;

    ts:=timestep;
    dt:=t[2]-t[1];
    TEL:=0;nTEL:=0;
    PQ[0]:=0.0E00;nPQ[0]:=0.0E00;
    t[0]:=0;nt[0]:=0;

    IF ts<=dt THEN     (* Smaller timestep *)
    REPEAT
     TEL:=TEL+1;
     REPEAT
      nTEL:=nTEL+1;
      nt[nTEL]:=nt[nTEL-1]+ts;
      nPQ[nTEL]:=nPQ[nTEL-1]+(PQ[TEL]-PQ[TEL-1])*ts/dt;
     UNTIL nt[TEL]>=t[TEL];
     nPQ[nTEL]:=nPQ[nTEL-1]+(PQ[TEL]-PQ[TEL-1])*(t[TEL]-nt[nTEL-1])/dt;
     nPQ[nTEL]:=nPQ[nTEL]+(PQ[TEL+1]-PQ[TEL])*(nt[nTEL]-t[TEL])/dt;
    UNTIL TEL=MaxTEL;

    IF ts>dt THEN     (* Bigger timestep *)
    REPEAT
     nTEL:=nTEL+1;
     nt[nTEL]:=nt[nTEL-1]+ts;
     REPEAT
      TEL:=TEL+1;
      nPQ[nTEL]:=nPQ[nTEL-1]+PQ[TEL]-PQ[TEL-1];
     UNTIL t[TEL]>=nt[nTEL];
     iPQ:=((nt[nTEL]-t[TEL-1])/dt)*(PQ[TEL]-PQ[TEL-1]);
     nPQ[nTEL]:=nPQ[nTEL-1]+PQ[TEL-1]-PQ[TEL-2]+iPQ;
    UNTIL TEL=MaxTEL;
    nMaxTEL:=nTEL;

    FNM:=Copy(FileName,3,7);
    FileName:=Concat('b:',FNM,'QTS.DAT');
    WriteLn('Your timestep-filename will be b:',FNM,'QTS.DAT');
    Write('Do you agree ? ');LV;Write(' (Y/N)');HV;Read(Kbd,Ch);WriteLn;
    IF Nee THEN
     BEGIN
      LV;Write('Give your name of the file : ');HV;Read(FileName);WriteLn;
     END;
    Assign(FV,FileName);
    ReWrite(FV);
    File_Text;
    FOR nTEL:=1 TO nMaxTEL DO
    BEGIN
     Af:=nPQ[nTEL];
     Bf:=nt[nTEL];
     WriteLn(FV,nTEL:6,Af:20:3,Bf:20);
    END;
    Close(FV);
    WriteLn('Your filename has received a new number only !');
    WriteLn('If you want to rename : use the procedure Filehandling .');
    PressKey;
   END; (* Discharge *)

'Q' :
   BEGIN
    IF Yes('... are you sure ?') THEN Quit:=True;
    ClrScr;
   END;
  END;  (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Time_Step *)


(*===================================================================*)
PROCEDURE Area_Define;
(*===================================================================*)
(*                    Conversion to square m                         *)

VAR  are,sqm,ha,sqkm  :  Real;

BEGIN
 ClrScr;
 WriteLn('HYDROLIN/test/1.00 - Area       :  52510 ha  ..............');
 PressKey;
 Quit:=False;
 REPEAT
  Menu_Heading:='AREA DEFINE MENU';
  CASE Menu('Are Hectare M(sq) Km(sq)  Quit') OF

      'A' : BEGIN
             Write('Area               (are) : ');Read(are);WriteLn;
             Area:=are*1E+2;{sq.m}
             WriteLn('Area              (sq.m) : ',AREA);
             Delay(5000);
             Quit:=True;
            END;
      'H' : BEGIN
             Write('Area                (ha) : ');Read(ha);WriteLn;
             Area:=ha*1E+4;{sq.m}
             WriteLn('Area              (sq.m) : ',AREA);
             Delay(5000);
             Quit:=True;
            END;
      'M' : BEGIN
             Write('Area              (sq.m) : ');Read(sqm);WriteLn;
             Area:=sqm;{sq.m}
             WriteLn('Area              (sq.m) : ',AREA);
             Delay(5000);
             Quit:=True;
            END;
      'K' : BEGIN
             Write('Area               (sq.km) : ');Read(sqkm);WriteLn;
             Area:=sqkm*1E+06;{sq.m}
             WriteLn('Area              (sq.m) : ',AREA);
             Delay(5000);
             Quit:=True;
            END;
      'Q' : BEGIN
             IF Yes('... are you sure ?') THEN  Quit:=True;
             ClrScr;
            END;
  END;  (* Case *)
  HV;
  UNTIL Quit=True;
  WriteLn;
  WriteLn('Further characteristics  : not yet implemented.');Delay(3000);
 END; (* Area_define *)


(*===================================================================*)
PROCEDURE Zero_Wiping;
(*===================================================================*)

VAR    WipeTEL : Integer;

BEGIN
 WriteLn('DATAFILE to apply zero-wiping to .........................');
 WriteLn;PressKey;;
 Input_File;

 WriteLn('ZERO-WIPED DATAFILENAME ................................. ');
 WriteLn;PressKey;
 File_Name_Num;

 BEGIN
  TEL:=0;
  REPEAT
   TEL:=TEL+1;
  UNTIL PQ[TEL]<>0.0E00;
  WipeTEL:=TEL;
  REPEAT
   TEL:=TEL+1;
  UNTIL PQ[TEL]=0.0E00;
  MaxTEL:=TEL;
 END;
 Assign(FV,FileName);
 Rewrite(FV);
 File_Text;
 PressKey;
 FOR TEL:=WipeTEL TO MaxTEL DO
 BEGIN
  Af:=PQ[TEL];Bf:=t[TEL]-t[WipeTEL-1];
  WriteLn(FV,TEL-WipeTEL+1:6,Af:20:3,Bf:20);
 END;
 Close(FV);
END; (* Zero_Wiping *)


(*========================= PRECIPITATION ===========================*)

(*===================================================================*)
PROCEDURE Initial_Loss;
(*===================================================================*)

BEGIN
 Write('ZERO-WIPED PRECIPITATION-DATAFILE to apply initial losses to');
 LV;Write(' (d:XXXXXPWX.DAT)');HV;WriteLn;PressKey;
 Input_File;
 WriteLn('INITIAL-LOSS DATAFILE  :');Delay(3000);WriteLn;WriteLn;
 StrPQ:='INITIAL LOSS Iinit';Strt:='TIME tIinit';

 FOR TEL:=1 TO MaxTEL DO PQ[TEL]:=0.0E00;
 WriteLn('First an initialisation-datafile is written ............. ');
 WriteLn('INITIAL_LOSS_DATAFILE name .............................. ');
 WriteLn('Use the PI-option of .................................... ');
 PressKey;
 File_Name_Num;
 Assign(FV,FileName);
 ReWrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 WriteLn(FV,TEL:6,PQ[TEL]:20:3,t[TEL]:20);
 Close(FV);Delay(3000); (* Initialisation *)

 LV;
 WriteLn('Continue for datafile editing QUIT to use       : HYDREDIT');
 WriteLn('                                             or : TURBO   ');
 WriteLn('the initial_loss-datafile ................................');
 Delay(3000);WriteLn;WriteLn;
 WriteLn('F for File_Handling');
 WriteLn('Q for Main-menu    ');HV;
 REPEAT
  Read(Kbd,Ch);
  IF Ch IN ['f','F'] THEN File_Handling;
 UNTIL Ch IN ['f','F','q','Q'];
 PressKey;
END; (* Initial_Loss *)


(*===================================================================*)
PROCEDURE Phi_Index;
(*===================================================================*)

VAR       Pbrtot : Real;

BEGIN
 Write('ZERO-WIPED PRECIPITATION-DATAFILE to apply phi-index to');
 LV; Write(' (d:XXXXXPWX.DAT)');WriteLn;HV;PressKey;
 Input_File;

 WriteLn('HYDROLIN/test/1.00 - Phi-index  :  2.48 mm/hour .............');
 WriteLn;
 Write('Give estimated phi-index        : ');Read(Apr);WriteLn;Delay(1000);
 WriteLn;
 WriteLn('PHI_INDEX-DATAFILE name ................................. ');
 WriteLn('Use the PF option of .................................... ');
 PressKey;
 File_Name_Num;
 StrPQ:='PHI-INDEX LOSS Iphi';Strt:='TIME tIphi';
 {
 Write('Phi-index                     : ');Read(Phi);WriteLn;
 TEL:=0;Pbrtot:=0.0E00;t[0]:=0;
 BEGIN
  REPEAT
   TEL:=TEL+1;
   Pbrtot:=Pbrtot+PQ[TEL]*(t[TEL]-t[TEL-1]);
   MaxTEL:=TEL-1;
  UNTIL PQ[TEL]=0.0E00;
 END;
 Apr:=Phi*Pbrtot/t[MaxTEL];
 Write('Phi-index precipitation loss   : ',Apr);
 }
 Assign(FV,FileName);
 Rewrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 BEGIN
  Iphi[TEL]:=Apr;
  Af:=Iphi[TEL];Bf:=t[TEL];
  WriteLn(FV,TEL:6,Af:20:3,Bf:20);
 END;
 Close(FV);
 PressKey;
END; (* Phi_index *)

(*===================================================================*)
PROCEDURE User_Def_Loss;
(*===================================================================*)


BEGIN
 Write('ZERO-WIPED PRECIPITATION-DATAFILE to apply userdef. losses to');
 LV;Write(' (d:XXXXXPWX.DAT)');HV;WriteLn;PressKey;
 Input_File;
 WriteLn('USERDEF-LOSS DATAFILE  :');Delay(3000);WriteLn;WriteLn;
 StrPQ:='USERDEF LOSS Iusr';Strt:='TIME tIusr';

 FOR TEL:=1 TO MaxTEL DO PQ[TEL]:=0.0E00;
 WriteLn('First an initialisation-datafile is written ............. ');
 WriteLn('USERDEF_LOSS_DATAFILE name .............................. ');
 WriteLn('Use the PU-option of .................................... ');
 PressKey;
 File_Name_Num;
 Assign(FV,FileName);
 ReWrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 WriteLn(FV,TEL:6,PQ[TEL]:20:3,t[TEL]:20);
 Close(FV);Delay(3000); (* Initialisation *)

 LV;
 WriteLn('Continue for datafile editing in the Input_Menu : HYDREDIT');
 WriteLn('                           or Quit to use       : TURBO   ');
 WriteLn('the userdef_loss-datafile ................................');
 Delay(3000);WriteLn;WriteLn;
 WriteLn('Give                     : I for Input_Menu   ');
 WriteLn('                         : F for File_Handling');
 WriteLn('                         : Q for Main-menu    ');HV;
 REPEAT
  Read(Kbd,Ch);
  IF Ch IN ['i','I'] THEN Input_Menu;
  IF Ch IN ['f','F'] THEN File_Handling;
 UNTIL Ch IN ['i','I','f','F','q','Q'];
 PressKey;
END; (* User_Def_Loss *)

(*===================================================================*)
PROCEDURE Precip_Loss;
(*===================================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='PRECIP. LOSS MENU';
  CASE Menu('Initial Phi_index User_def Quit') OF

     'I' :  BEGIN
             StrPQ:='PRECIP_LOSS Iinit';Strt:='TIME tIinit';
             PQ:=Iinit;t:=tIinit;
             Initial_Loss;
            END;
     'P' :  BEGIN
             StrPQ:='PRECIP_LOSS Iphi';Strt:='TIME tIphi';
             PQ:=Iphi;t:=tIphi;
             Phi_Index;
            END;
     'U' :  BEGIN
             StrPQ:='PRECIP_LOSS Iusr';Strt:='TIME tIusr';
             PQ:=Iusr;t:=tIusr;
             User_Def_Loss;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
  UNTIL Quit=True;
END; (* Precip_Loss *)


(*===================================================================*)
PROCEDURE Precip_Conversion;
(*===================================================================*)

BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='PRECIP. CONVERSION';
  CASE Menu('0mm/hour 1mm/half_an_hour 2mm/day 3quit ') OF

(* Conversion Intensity to mm/hour counted ; time in hour.          *)
(* Not implemented l/s.ha= 8.64 mm/day , mm/year                    *)

     '0' :  BEGIN
             MulP:=1.0;
             Quit:=True;
            END;
     '1' :  BEGIN
             MulP:=0.5;
             Quit:=True;
            END;
     '2' :  BEGIN
             Mulp:=1/24;
             Quit:=True;
            END;
     '3' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
UNTIL Quit=True;
END; (* Precip_Conversion *)

(*===================================================================*)
PROCEDURE Nett_Write;
(*===================================================================*)

BEGIN
 WriteLn('Give filename to the NETT PRECIPITATION file ...............');
 WriteLn('Use now the PN-specification_option of .....................');
 Delay(5000);
 File_Name_Num;
 Assign(FV,FileName);
 ReWrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 BEGIN
 Af:=Inett[TEL];
 Bf:=tInett[TEL];
 WriteLn(FV,TEL:6,Af:20:3,Bf:20);
 END;
Close(FV);
END; (* Nett_Write *)

(*===================================================================*)
PROCEDURE Nett_Precip;
(*===================================================================*)

BEGIN
 Write('ZERO-WIPED PRECIPITATION-DATAFILE   ');LV;
 Write(' (d:XXXXXPWX.DAT)');WriteLn; HV;PressKey;
 Input_File;
 Ibr:=PQ;
 tIbr:=t;


 WriteLn('PRECIPITATION_LOSS_DATAFILE(S)  ');LV;
 WriteLn('d:XXXXXPIX.DAT and/or d:XXXXXPFX.DAT and/or d:XXXXXPUX.DAT');
 WriteLn;HV;PressKey;
 Quit:=False;
 REPEAT
  Menu_Heading:='PRECIP_LOSS_DATAFILE';
  CASE Menu('Initial Phi_index User_def Quit') OF

'I' :
  BEGIN
   WriteLn('You should give a filename like d:XXXXXPIX.DAT ...........');
   PressKey;
   Input_File;
   Iinit:=PQ;tIinit:=t;
   StrPQ:='NETT PRECIP Inett';Strt:='TIME tInett';
   Precip_Conversion;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF Ibr[TEL]-Iinit[TEL]<=0.0E00 THEN Inett[TEL]:=0.0E00 ELSE
    BEGIN
     Inett[TEL]:=Ibr[TEL]-Iinit[TEL];
     Inett[TEL]:=Inett[TEL]*MulP;
     tInett[TEL]:=t[TEL];
    END;
   END;
   Nett_Write;
  END;

'P' :
  BEGIN
   WriteLn('You should give a filename like d:XXXXXPFX.DAT ...........');
   PressKey;
   Input_File;
   Iphi:=PQ;tIphi:=t;
   StrPQ:='NETT PRECIP Inett';Strt:='TIME tInett';
   Precip_Conversion;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF Ibr[TEL]-Iphi[TEL]<=0.0E00 THEN Inett[TEL]:=0.0E00 ELSE
    BEGIN
     Inett[TEL]:=Ibr[TEL]-Iphi[TEL];
     Inett[TEL]:=MulP*Inett[TEL];
     tInett[TEL]:=t[TEL];
    END;
   END;
   Nett_Write;
  END;

'U' :
  BEGIN
   WriteLn('You should give a filename like d:XXXXXPUX.DAT ...........');
   PressKey;
   Input_File;
   Iusr:=PQ;tIusr:=t;
   StrPQ:='NETT PRECIP Inett';Strt:='TIME tInett';
   Precip_Conversion;
   FOR TEL:=1 TO MaxTEL DO
   BEGIN
    IF Ibr[TEL]-Iinit[TEL]<=0.0E00 THEN Inett[TEL]:=0.0E00 ELSE
    BEGIN
     Inett[TEL]:=Ibr[TEL]-Iusr[TEL];
     Inett[TEL]:=Inett[TEL]*MulP;
     tInett[TEL]:=t[TEL];
    END;
   END;
   Nett_Write;
   Close(FV);
  END;

'Q' :
  BEGIN
   IF Yes('... are you sure ?') THEN Quit:=True;
    ClrScr;
  END;

 END; (* Case *)
 HV;
 UNTIL Quit=True;(* Precip_Loss_Menu *)
END; (* Nett_Precip *)


(*===================================================================*)
PROCEDURE Accumul_Nett_Precip;
(*===================================================================*)
(*        Accumulated nett precipitation in cubic m                  *)

BEGIN
 Area_Define;
 WriteLn('WIPED NETT-PRECIPITATION-DATAFILE ........................ ');
 PressKey;
 Line:=Line1;
 Input_File;
 Inett:=PQ;
 tInett:=t;
 Pntot:=0.0E00;
 FOR TEL:=1 TO MaxTEL DO
 Pntot:=Pntot+(Inett[TEL]+Inett[TEL-1])*0.5*(tInett[TEL]-tInett[TEL-1]);
 Pntot:=Pntot*1E-3*Area;
 WriteLn('Accumulated nett precipitation : ',Pntot,' cubic m.');
 Write('Do you want to save this in a datafile ?');LV;Write(' (Y/N) ');HV;
 Read(Kbd,Ch);WriteLn;
 IF Ja THEN
 BEGIN
  FNM:=Copy(FileName,3,7);
  FileSpec:='PT';
  FileNumE:=Copy(FileName,10,10);
  FileName:=Concat('b:',FNM,'PT',FileNumE,'.DAT');
  Assign(FV,FileName);
  ReWrite(FV);
  FOR TEL:=1 TO 6 DO WriteLn(FV,Line1);
  WriteLn(FV,'Accumulated Nett Precipitation ',Pntot,' cubic m.');
 END;
 Close(FV);
END; (* Accumul_Nett_Precip *)


(*===================================================================*)
PROCEDURE Precip_Menu;
(*===================================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='PRECIPITATION MENU';
CASE Menu('Bruto Zero_wiping Losses Nett Accum_nett Quit') OF

     'A' :  BEGIN
             Accumul_Nett_Precip;
            END;
     'B' :  BEGIN
             StrPQ:='PRECIPITATION Ibr';Strt:='TIME tIbr';
             PQ:=Ibr;t:=tIbr;
             Keyboard_Input;
            END;
     'L' :  BEGIN
             Precip_Loss;
            END;
     'N' :  BEGIN
             StrPQ:='PRECIPITATION Inett';Strt:='TIME tInett';
             PQ:=Inett;t:=tInett;
             Nett_Precip;
            END;
     'Z' :  BEGIN
             Zero_Wiping;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Precip_Menu *)

(*END ======================= HYDROL02.INC ======================= *)
