(**********************************************************************
* HYDROL03.INC                                                        *
*                                                                     *
* CONTENTS :                                                          *
*                                                                     *
* MISCELLANEOUS HYDROLIN-PROCEDURES         TU DELFT / M.J.Vos / 1988 *
***********************************************************************
* Depletion; Separ_disch ;Nett_Disch; Disch_Conversion;               *
* Accumul_Nett_Disch; Disch_Menu; Precip_Disc_Menu.                   *
**********************************************************************)

(*===================================================================*)
PROCEDURE Depletion;
(*===================================================================*)

BEGIN
 Scroll;ClrScr;
 WriteLn('BRUTO_DISCHARGE DATAFILE .................................');
 WriteLn('assumed to have one maximum discharge ....................');
 WriteLn('to calculate end resp. start of depletion-curves .........');
 PressKey;
 Input_File;
 Qbr:=PQ;tQbr:=t;
 TEL:=1;
 BEGIN
  REPEAT
   TEL:=TEL+1;
   QT1:=PQ[TEL]/PQ[TEL-1];
   QT2:=PQ[TEL+1]/PQ[TEL];
   QT3:=QT1-QT2;
  UNTIL ((QT2>=0.0E00) OR (ABS(QT3)<=2E-2));
  Qs:=PQ[TEL+1];tQs:=t[TEL+1];
 END; (* Separation starting point *)

 TEL:=1;
 REPEAT
  TEL:=TEL+1;
 UNTIL (((PQ[TEL]-PQ[TEL-1])/(t[TEL]-t[TEL-1]))>=0.0E00) AND
       (((PQ[TEL+1]-PQ[TEL])/(t[TEL+1]-t[TEL]))< 0.0E00);
 LV;WriteLn('                        *** DISCHARGE SEPARATION  ***');HV;
 WriteLn;WriteLn;WriteLn('Maximum discharge                  : ',PQ[TEL]:20:3);
 WriteLn('             time                  : ',t[TEL]:20);
(* Maximum discharge *)
 WriteLn;
TEL:=TEL-1;
 BEGIN
  REPEAT
   TEL:=TEL+1;
   QT1:=PQ[TEL]/PQ[TEL-1];
   QT2:=PQ[TEL+1]/PQ[TEL];
   QT3:=QT1-QT2;
  UNTIL ABS(QT3)<=2E-2;
  Qd:=PQ[TEL-1];tQd:=t[TEL-1];
 END; (* Depletion starting point  *)

 WriteLn('Start separation curve at time     : ',tQs:20);
 WriteLn('                 and discharge     : ',Qs:20:3);WriteLn;Delay(3000);
 WriteLn('Start depletion  curve at time     : ',tQd:20);
 WriteLn('                 and discharge     : ',Qd:20:3);WriteLn;
 PressKey;
END; (* Depletion *)


(*===================================================================*)
PROCEDURE Separ_Disch;
(*===================================================================*)

BEGIN
 Depletion;
 Quit:=False;
 REPEAT
  Menu_Heading:='DISCH. SEPARATION';
  CASE Menu('Constant Linear User_def Quit') OF

'C' :
   BEGIN
    WriteLn('Separation assumed to be constant with time ..............');
    WriteLn;
    WriteLn('Use now the QC-filenamespecification_option ..............');
    StrPQ:='CONSTANT SEPAR. Qc';Strt:='TIME tQc';
    PressKey;
    File_Name_Num;
    Assign(FV,FileName);
    ReWrite(FV);
    File_Text;
    TEL:=0;
    REPEAT
     TEL:=TEL+1;
     Qsc[TEL]:=PQ[TEL];
    UNTIL PQ[TEL]=Qs;   (* First depletion curve   *)
    REPEAT
     IF PQ[TEL]>=Qs THEN
     Qsc[TEL]:=Qs;
     TEL:=TEL+1;
    UNTIL PQ[TEL]<=Qs; (* Constant separationline *)
    TEL:=TEL-1;
    REPEAT
     TEL:=TEL+1;
     Qsc[TEL]:=PQ[TEL];
    UNTIL TEL=MaxTEL;
    FOR TEL:=1 TO MaxTEL DO
    WriteLn(FV,TEL:6,Qsc[TEL]:20:3,t[TEL]:20);
    Close(FV);
    PressKey;
   END; (* Linear constant *)

'L' :
   BEGIN
    WriteLn('Separation assumed to be linear with time ................');
    WriteLn;
    WriteLn('Use now the QL-filenamespecification_option ..............');
    StrPQ:='LINEAR SEPAR. Ql';Strt:='TIME tQl';
    PressKey;
    File_Name_Num;
    Assign(FV,FileName);
    ReWrite(FV);
    File_Text;
    TEL:=0;
    REPEAT
     TEL:=TEL+1;
     Qsl[TEL]:=PQ[TEL];
    UNTIL PQ[TEL]=Qs;   (* First depletion curve   *)
    TEL:=TEL-1;
    REPEAT
     TEL:=TEL+1;
     Qsl[TEL]:=Qs+((t[TEL]-tQs)*(Qd-Qs)/(tQd-tQs));
    UNTIL PQ[TEL]=Qd;   (* Linear separation line  *)
    IF TEL<MaxTEL THEN
    REPEAT
     TEL:=TEL+1;
     Qsl[TEL]:=PQ[TEL];
    UNTIL t[TEL]=MaxTEL; (* Last depletion curve    *)
    FOR TEL:=1 TO MaxTEL DO
    WriteLn(FV,TEL:6,Qsl[TEL]:20:3,t[TEL]:20);
    Close(FV);
    PressKey;
   END; (* Linear up or down *)

'U' :
   BEGIN
    WriteLn('Separation assumed to be user defined ....................');
    WriteLn;
    WriteLn('Use now the QU-filenamespecification_option ..............');
    StrPQ:='USER DEF SEPAR. Qu';Strt:='TIME tQu';
    PressKey;
    File_Name_Num;
    Assign(FV,FileName);
    ReWrite(FV);
    File_Text;
    FOR TEL:=1 TO MaxTEL DO
    BEGIN
     IF t[TEL]<=tQs THEN Qsu[TEL]:=PQ[TEL];
     IF ((t[TEL]>tQs) AND (t[TEL]<tQd)) THEN Qsu[TEL]:=0.0E00;
     IF t[TEL]>=tQd THEN Qsu[TEL]:=PQ[TEL];
    END;
    FOR TEL:=1 TO MaxTEL DO
    WriteLn(FV,TEL:6,Qsu[TEL]:20:3,t[TEL]:20);
    Close(FV);
    Delay(3000);
    WriteLn('In ',FileName,' :');
    WriteLn('you are to give sequential discharge_separation_data .....');
    WriteLn('in a certain time-interval using an EDITER ...............');
    Delay(1000);
    WriteLn('Take option QUIT and return to the MAIN MENU .............');
    PressKey;
   END; (* User-def *)

'Q' :
   BEGIN
    IF Yes('... are you sure ?') THEN Quit:=True;
    ClrScr;
   END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Separ_disch *)


(*===================================================================*)
PROCEDURE Disch_Conversion;
(*===================================================================*)

BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='DISCHARGE CONVERSION';
  CASE Menu('0cub.m/sec 1cub.m/min 2m/sec 3quit') OF

(* Discharge-conversion to cubic m/s; time in hour                   *)
(* Not implemented l/s , 10E6 cub.m/day or month or year , cf/s      *)

     '0' :  BEGIN
             MulQ:=1;
             Quit:=True;
            END;
     '1' :  BEGIN
             MulQ:=1/60;
             Quit:=True;
            END;
     '2' :  BEGIN
             Write('Give the cross-section in sq m of the river : ');Read(R);
             WriteLn;
             MulQ:=R;
             Quit:=True;
            END;
     '3' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Discharge_Conversion *)


(*===================================================================*)
PROCEDURE Nett_Disch;
(*===================================================================*)

BEGIN
 WriteLn('BRUTO_DISCHARGE-DATAFILE ................................ ');
 Delay(3000);
 Input_File;
 Qbr:=PQ;
 tQbr:=t;

 WriteLn('DISCHARGE-SEPARATION_DATAFILE ........................... ');
 WriteLn('This must be in conjunction with the bruto_discharge-datafile');
 Delay(10000);
 Input_File;
 Qbs:=PQ;
 tQbs:=t;

 Disch_Conversion;
 FOR TEL:=1 TO MaxTEL DO
 BEGIN
  StrPQ:='NETT DISCHARGE Qnett';Strt:='TIME tQnett';
  Qnett[TEL]:=Qbr[TEL]-Qbs[TEL];
  Qnett[TEL]:=MulQ*Qnett[TEL];
  tQnett[TEL]:=t[TEL];
 END;
 WriteLn('Give filename to the NETT DISCHARGE file .................');
 WriteLn('Use now the QN-filenamespecification_option ..............');
 Delay(5000);
 File_Name_Num;
 Assign(FV,FileName);
 ReWrite(FV);
 File_Text;
 FOR TEL:=1 TO MaxTEL DO
 BEGIN
  Af:=Qnett[TEL];
  Bf:=tQnett[TEL];
  WriteLn(FV,TEL:6,Af:20:3,Bf:20);
 END;
 Close(FV);
END; (* Nett_Disch *)



(*===================================================================*)
PROCEDURE Accumul_Nett_Disch;
(*===================================================================*)
(*        Accumulated Nett Discharge                                 *)

BEGIN
 WriteLn('WIPED! NETT_DISCHARGE-DATAFILE ............................ ');
 Delay(3000);
 Line:=Line2;
 Input_File;
 Qnett:=PQ;
 tQnett:=t;
 Qntot:=0.0E00;
 FOR TEL:=1 TO MaxTEL DO
 Qntot:=Qntot+(Qnett[TEL]+Qnett[TEL-1])*0.5*(tQnett[TEL]-tQnett[TEL-1]);
 Write('Do you want to save this in a datafile ?');LV;Write(' (Y/N) ');HV;
 Read(Kbd,Ch);WriteLn;
 IF Ja THEN
 BEGIN
  FNM:=Copy(FileName,3,7);
  FileSpec:='QT';
  FileNumE:=Copy(FileName,10,10);
  FileName:=Concat('b:',FNM,'QT',FileNumE,'.DAT');
  Assign(FV,FileName);
  ReWrite(FV);
  FOR TEL:=1 TO 6 DO WriteLn(FV,Line2);
  WriteLn(FV,'Accumulated nett discharge ',Qntot,' in cubic m.');
 END;
 Close(FV);
END; (* Accumul_Nett_Disch *)


(*===================================================================*)
PROCEDURE Disch_Menu;
(*===================================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='DISCHARGE MENU';
  CASE Menu('Bruto Separ Reservoir Nett Zero_wiping Accum_nett Quit') OF

     'A' :  BEGIN
             Accumul_Nett_Disch;
            END;
     'B' :  BEGIN
             StrPQ:='DISCHARGE Qbr';Strt:='TIME tQbr';
             PQ:=Qbr;t:=tQbr;
             Keyboard_Input;
            END;
     'R' :  BEGIN
             Bell;WriteLn('Reservoir in/outlet not implemented !');
             Delay(1000);
             WriteLn('With an EDITER you will manage in an PI-file.');
             Delay(3000);
            END;
     'S' :  BEGIN
             StrPQ:='DISCHARGE Qbs';Strt:='TIME tQbs';
             Separ_disch;
            END;
     'N' :  BEGIN
             StrPQ:='DISCHARGE Qnett';Strt:='TIME tQnett';
             Nett_Disch;
            END;
     'Z' :  BEGIN
             Zero_Wiping;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Disch_Menu *)


(*===================================================================*)
PROCEDURE Precip_Disch;
(*===================================================================*)


BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='PRECIP./DISCH. MENU';
  CASE Menu('Precipition Discharge Compare Timestep Quit') OF

     'P' :  BEGIN
             Precip_Menu;
            END;
     'D' :  BEGIN
             Disch_Menu;
            END;
     'C' :  BEGIN
             WriteLn('Do you want to compare ');
             Write('accumulated precipitation and discharge ?  ');
             LV;Write('(Y/N)');HV;Read(Kbd,Ch);WriteLn;
             IF Ja THEN
             BEGIN
              Scroll;ClrScr;
              Accumul_Nett_Precip;
              WriteLn('Accumulated nett precipitation  : ',Pntot,' cubic m.');
              WriteLn;
              Accumul_Nett_Disch;
              WriteLn('Accumulated nett discharge       : ',Qntot,' cubic m.');
              WriteLn;
              WriteLn('Pntot-Qntot                      = ',Pntot-Qntot,' cubic m.');
              WriteLn('If you are satisfied you can QUIT and start GRAPHICS ');
              WriteLn('or derive a Unit Hydrograph .........................');
              WriteLn('Otherwise start again Precipitation/Discharge operations');
              PressKey;
             END; (* Compare *)
             Bell;WriteLn('Use another option ...');Delay(5000);ClrScr;
            END;
     'T' :  BEGIN
             Time_Step;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Precip_Disch *)

(*========================= DISCHARGE ===============================*)

(*END ==================== HYDROL03.INC =============================*)