(**********************************************************************
* HYDROL04.INC                                                        *
*                                                                     *
* CONTENTS :                                                          *
*                                                                     *
* MISCELLANEOUS HYDROLIN-PROCEDURES         TU DELFT / M.J.Vos / 1988 *
***********************************************************************
* Editer_Menu; Unit_Hydrograph; Theory_Menu; Main_Menu.               *
**********************************************************************)

(*===================================================================*)
PROCEDURE Editer_Menu;
(*===================================================================*)

BEGIN
WriteLn('Required : all editers/filehandlers in drive A !');Delay(5000);
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='EDITER MENU';
  CASE Menu('Edlin File_mngr Hydr_edit Norton Turbo User_def Wordstar Quit') OF

      'E' : BEGIN
             FileName:='a:EDLIN.COM';
             IF NOT Exist(FileName) THEN
             BEGIN
              Bell;
              WriteLn(FileName,' does not exist !');Delay(1000);
             END ELSE
             BEGIN
              WriteLn('Input command : ',FileName);Delay(3000);
              Assign(FV,'a:COMM211.CHN');
              Chain(FV);
             END;
             ClrScr;
            END;
      'H' : BEGIN
             Hydr_Edit;
            END;
      'N' : BEGIN
             FileName:='a:NE.EXE';
             IF NOT Exist(FileName) THEN
             BEGIN
              Bell;
              WriteLn(FileName,' does not exist !');Delay(1000);
             END ELSE
             BEGIN
              WriteLn('Input command : ',FileName);Delay(3000);
              Assign(FV,'a:COMM211.CHN');
              Chain(FV);
             END;
             ClrScr;
            END;
      'T' : BEGIN
             FileName:='a:TURBO.COM';
             IF NOT Exist(FileName) THEN
             BEGIN
              Bell;
              WriteLn(FileName,' does not exist !');Delay(1000);
             END ELSE
             BEGIN
              WriteLn('Input command : ',FileName);Delay(3000);
              Assign(FV,'a:COMM211.CHN');
              Chain(FV);
             END;
             ClrScr;
            END;
      'U' : BEGIN
             LV;Write('Give filename  (d:filename.typ) :  ');
             HV;Read(FileName);WriteLn;
             IF NOT Exist(FileName) THEN
             BEGIN
              Bell;
              WriteLn(FileName,' does not exist !');Delay(1000);
             END ELSE
             BEGIN
              WriteLn('Input command : ',FileName);Delay(3000);
              Assign(FV,'a:COMM211.CHN');
              Chain(FV);
             END;
             ClrScr;
            END;
      'W' : BEGIN
             FileName:='a:WS.COM';
             IF NOT Exist(FileName) THEN
             BEGIN
              Bell;
              WriteLn(FileName,' does not exist !');Delay(1000);
             END ELSE
             BEGIN
              WriteLn('Input command : ',FileName);Delay(3000);
              Assign(FV,'a:COMM211.CHN');
              Chain(FV);
             END;
             ClrScr;;
            END;
      'F' : BEGIN
             FileName:='a:PFM.COM';
             IF NOT Exist(FileName) THEN
             BEGIN
              FN:='a:FM.COM';
              IF NOT Exist(FileName) THEN
              BEGIN
               Bell;
               WriteLn(FileName,'or ',FN,' not present on A: !');Delay(1000);
              END ELSE
              BEGIN
               WriteLn('Input command : ',FileName);Delay(3000);
               Assign(FV,'a:COMM211.CHN');
               Chain(FV);
               END;
              END;
              BEGIN
              BEGIN
               WriteLn('Input command : ',FileName);Delay(3000);
               Assign(FV,'a:COMM211.CHN');
               Chain(FV);
              END;
             END;
             ClrScr;
            END;
      'Q' : BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END;  (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Editer_Menu *)


(*===================================================================*)
PROCEDURE Model_Menu;
(*===================================================================*)

BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='MODEL MENU';
  CASE Menu('Nash_cascade Stochast Tank_model Unit_hydrograph Quit') OF

     'N' :  BEGIN
            {Nash_cascade;}
             Bell;WriteLn('Nash Cascade not yet implemented !');
             Delay(1000);ClrScr;
            END;
     'S' :  BEGIN
            {Stochastic model}
             Bell;WriteLn('Stochastic models not yet implemented !');
             Delay(1000);ClrScr;
            END;
     'T' :  BEGIN
            {Tank_model;}
             Bell;WriteLn('Tank Model not yet implemented !');
             Delay(1000);ClrScr;
            END;
     'U' :  BEGIN
             WriteLn('Derivation of the Unit Hydrograph is possible only with :');
             WriteLn;WriteLn('1. Zero-wiped datafiles;');
             WriteLn('2. Files with nett data;');
             WriteLn('3. Same timestep for precipitation and discharge data;');
             WriteLn('4. Datafiles which are compared : accumulated nett.');
             WriteLn;
             IF Yes('... are you sure these conditions are fulfilled ?  (Y/N)') THEN
             BEGIN
              Assign(FV,'b:HYDROCAL.CHN');
              Chain(FV);
             END ELSE
             WriteLn('Choose again the precip_disch-menu ...');PressKey;
            END;
     'Q' :  BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Model_Menu *)


(*===================================================================*)
PROCEDURE Main_Menu;
(*===================================================================*)

BEGIN
ClrScr;
Quit:=False;
 REPEAT
  Menu_Heading:='MAIN MENU';
  CASE Menu('Comm Dir Edit File_hnd Graphics Help Input Model Quit') OF

      'C' : BEGIN
             Assign(FV,'a:COMM211.CHN');
             Chain(FV);
            END;
      'D' : BEGIN
             Assign(FV,'a:MSDOSDIR.CHN');
             Chain(FV);
           (*alternative :                      *)
           (*WriteLn('DOS-Command is PDIR ...');*)
           (*Assign(FV,'a:COMM211.CHN');        *)
           (*Chain(FV);                         *)
            END;
      'E' : BEGIN
             Editer_Menu;
            END;
      'F' : BEGIN
             File_Handling;
            END;
      'G' : BEGIN
             Assign(FV,'a:HYDROGR.CHN');
             Chain(FV);
            END;
      'H' : BEGIN
             Help_Menu;
            END;
      'I' : BEGIN
             Precip_Disch;
            END;
      'M' : BEGIN
             Model_Menu;
            END;
      'Q' : BEGIN
             IF Yes('... are you sure ?') THEN Quit:=True;
             ClrScr;
            END;
  END; (* Case *)
  HV;
 UNTIL Quit=True;
END; (* Main-Menu *)

(*END ====================== HYDROL04.INC ========================= *)