(**********************************************************************
* MSDOSDIR.PAS                                                        *
*                                                                     *
* CONTENTS                                                            *
*                                                                     *
* MISCELLANEOUS MSDOS DIRECTORY-PROCEDURES  TU DELFT / M.J.Vos / 1988 *
***********************************************************************
* Beep; Display; DecodeDTA; Display_Data; Lees_Volume_Label;          *
* Bladhoofd; Directory.                                               *
**********************************************************************)

CONST
  Papierlengte       = 72;

TYPE
  Str2             = STRING[2];
  Str3             = STRING[3];
  Str4             = STRING[4];
  Str5             = STRING[5];
  Str9             = STRING[9];
  Str11            = STRING[11];
  Str12            = STRING[12];
  Str80            = STRING[80];
  Char80Arr        = ARRAY [1..80] OF Char;

  Regpack          = RECORD
                      AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags : Integer;
                     END;

  Filegegevens     = RECORD
                       Attribute : Integer;
                       Tijd      : Str5;
                       Datum     : Str11;
                       Lengte    : Real;
                       FileNaam  : Str12;
                     END;


VAR
  Regs             : Regpack;
  Filedata         : Filegegevens;
  DTA              : ARRAY [1..43] OF Byte;
  OldDTA_Seg,
  OldDTA_Ofs,
  Error,I,Blad,
  Aantal_Files,
  Regel            : Integer;
  Path             : Char80Arr;
  AsciizString,
  InvoerString     : Str80;
  Drive            : Char;
  UsedBytes        : Real;
  AttribuutTekst   : Str80;
  VolumeLabel      : Str12;
  VolumeTijd       : Str5;
  VolumeDatum      : Str11;
  Space            : Real;
  Fout             : Boolean;
  Ch               : Char;
  FV               : Text;

{$I b:MSDOSLIB.INC }


(*===================================================================*)
{PROCEDURE Beep;                                                      }
(*===================================================================*)

{BEGIN                            }
{  Sound(1200);Delay(300);NoSound;}
{  Sound(1600);Delay(500);NoSound;}
{  Sound(1200);Delay(300);NoSound;}
{END;                             }


(*===================================================================*)
PROCEDURE Display(X,Y(*,KleurIn,KleurUit*): Integer; Txt : Str80);
(*===================================================================*)

BEGIN
 {TextColor(KleurIn);                                         }
 {IF KleurIn=8 THEN TextBackground(15) ELSE TextBackground(8);}
  GotoXY(X,Y);
  Write(Txt);
 {IF KleurIn <> KleurUit THEN                                 }
 {BEGIN                                                       }
 {  TextColor(KleurUit);                                      }
 {  TextBackground(8);                                        }
 {END;                                                        }
END; {Display}


(*===================================================================*)
PROCEDURE DecodeDTA( VAR Filedata : Filegegevens );
(*===================================================================*)

TYPE
  Maanden          = ARRAY [1..12] OF Str3;

CONST
  Maand : Maanden  =
    ('Jan','Feb,','Mrt','Apr','Mei','Jun','Jul','Aug','Sep','Okt','Nov','Dec');

VAR
  Uur,Minuut,Dag   : Str2;
  Jaar             : Str4;
  I,Spaties,Punt,
  Plek             : Integer;
  M                : Byte;

BEGIN {DTA}
  WITH Filedata DO
  BEGIN
    Attribute := DTA [22];
    AttribuutTekst:='';
    IF Attribute AND 1 = 1 THEN AttribuutTekst:='Read-Only ';
    IF Attribute AND 2 = 2 THEN AttribuutTekst:=AttribuutTekst+'Hidden ';
    IF Attribute AND 4 = 4 THEN AttribuutTekst:=AttribuutTekst+'System ';
    IF Attribute AND 32 = 32 THEN AttribuutTekst:=AttribuutTekst+'Archive ';

    Str(((DTA [24] Shl 3) AND $3F)+((DTA [23] Shr 5) AND $07),Minuut);
    IF Length(Minuut)=1 THEN Insert('0',Minuut,1);
    Str((DTA [24] Shr 3),Uur);
    IF Length(Uur)=1 THEN Insert('0',Uur,1);
    Tijd := Uur + ':' + Minuut;

    Str(DTA [25] AND $1F,Dag);
    IF (Length(Dag)<2) AND (Attribute<>40) THEN Insert(' ',Dag,1);
    M:=((DTA [26] Shl 3)AND $0F)+((DTA [25] Shr 5) AND $07);
    Str(((DTA [26] Shr 1)+1980),Jaar);
    Datum:=Dag + ' ' + Maand [M]+ ' ' + Jaar;

    Lengte := DTA [27]+(256.0 * DTA [28])+(65536.0 * DTA [29]);

    I := 1;
    FillChar(FileNaam,SizeOf(FileNaam),' ');
    REPEAT
      FileNaam [I] := Chr(DTA [I+30]);
      I := I+1;
    UNTIL   (NOT (FileNaam [I-1]  IN [' '..'~']));
    IF NOT (Attribute IN [8,40,16]) THEN
    BEGIN
      FileNaam [0] :=Chr(12);
      Spaties := 14-I;
      Punt := Pos('.',FileNaam);
      Delete(FileNaam,Punt,1);
      FOR I := Punt TO Punt+Spaties DO Insert(' ',FileNaam,I);
    END ELSE
    Filenaam[0]:=Chr(I-1);
    IF Attribute=40 THEN Delete(FileNaam,9,1);
    IF Attribute=16 THEN
    BEGIN
      IF Length(FileNaam)<8 THEN
      BEGIN
        Plek:=Length(FileNaam);
        FOR I:=8-Length(FileNaam) TO 8 DO Insert(' ',FileNaam,Plek);
      END;
    END;
  END;{FileData}
END;{DecodeDTA}


(*===================================================================*)
PROCEDURE Display_Data(Filedata:Filegegevens);
(*===================================================================*)

BEGIN
  DecodeDTA(Filedata);
  WITH FileData DO
  BEGIN
    IF Attribute=16 THEN
    BEGIN
      Write(Filenaam);
      Writeln('<DIR>         ',Datum,'  ',Tijd,'  ',AttribuutTekst);
    END ELSE
    BEGIN
      UsedBytes:=UsedBytes+Lengte;
    Writeln
      (Filenaam,'  ',Lengte:6:0,'  ',Datum,'  ',Tijd,'  ',AttribuutTekst);
    END;
   END;
END;{ Display_Data}


(*===================================================================*)
PROCEDURE Lees_Volumelabel;
(*===================================================================*)

BEGIN
  FindFirst(Path,8,Error);
  IF Error=0 THEN
  BEGIN
    DecodeDTA(FileData);
    WITH FileData DO
    BEGIN
      Volumelabel:=FileNaam;
      VolumeDatum:=Datum;
      VolumeTijd:=Tijd;
    END;
   END ELSE
   BEGIN
     VolumeLabel:='';
     VolumeDatum:='';
     VolumeTijd:='';
   END;
END;{ Lees_VolumeLabel }


(*===================================================================*)
PROCEDURE Bladhoofd;
(*===================================================================*)

BEGIN
  Writeln('VolumeLabel : ',VolumeLabel,'                        ',Datum);
  Write('Directory   : ');
  I:=1;
  WHILE Path[I] <> '*' DO
  BEGIN
    Write(Path[I]);
    I:=I+1;
  END;

 Writeln;
  Writeln('Created on         : ',VolumeDatum,'  ',VolumeTijd);

  FOR I:=1 TO 73 DO
 BEGIN
  Write('=');
 END;
 Writeln;
END; {BladHoofd }


(*========================= MSDOS ===================================*)
(*                      MAIN PROGRAM                                 *)
(*========================= = = = ===================================*)

BEGIN
  GetDTA(OldDTA_Seg,OldDTA_Ofs);
  SetDTA(Seg(DTA),Ofs(DTA));
  ClrScr;
  FillChar(DTA,43,0); {init DTA}

  REPEAT
    ClrScr;
    Display(20,1,{9,2,}'///  M  S  D  O  S    D  I  R  E  C  T  O  R  Y  ///');
    LowVideo;Display(1,2,{2,2,}'Give :');
    Display(17,4,{10,10,}'[ Drive: ][ \PATH ][ \PATH ][ etc. ]');
    Display(17,5,{10,10,}' i.e. a: or b:Name\Name\ etc.');
    UsedBytes:=0;
    Aantal_Files := 0;
    InvoerString:='';
    FillChar(Path,80,Chr(0));
    Blad:=1;
    GotoXY(35,8);ClrEol;
    Display(17,8,{2,10,}'Directory path : ');HighVideo;
    Read(InvoerString);Writeln;
    IF Length(InvoerString)=0 THEN
    BEGIN
      CurrentDisk(Drive);
      AsciizString:=Drive+':\*.*';
      Display(34,8,{2,10,}Drive+':\*.*');
    END ELSE
    BEGIN
      Invoerstring[1]:=Upcase(Invoerstring[1]);
      Drive:=Invoerstring[1];
      IF NOT (Drive in ['A'..'C']) THEN CurrentDisk(Drive);
      AsciizString:=InvoerString+'\*.*';
      Display(33,8,{2,10,}Drive+':\*.*');
    END;

    FOR I:=1 TO Length(AsciizString) DO Path[I]:=Upcase(AsciizString[I]);

    Display(1,10,{2,10,}'MSDOS DIRECTORY :');
    I:=1;
    WHILE Path[I] <> '*' DO
    BEGIN
      Write(Path[I]);
      I:=I+1;
    END;

    Display(1,12,{10,2,}'D');LowVideo;Write('isplay MSDOS Directory');HighVideo;
    Display(1,13,{10,2,}'G');LowVideo;Write('ive path again');HighVideo;
    Display(1,14,{10,2,}'S');LowVideo;Write('top procedure');
    Display(1,16,{10,10,}'Your choice :  ');HighVideo;
    REPEAT
     Read(Kbd,Ch);
    UNTIL Upcase(Ch) in ['D','G','S'];Writeln;
    Ch:=Upcase(Ch);
    IF Ch='D' THEN
    BEGIN
      Writeln;Writeln;
      ClrScr;
      Lees_VolumeLabel;
      FindFirst(Path,22,Error);
      Aantal_Files:=0;
      IF Error=0 THEN
      BEGIN
        WHILE Error=0 DO
        BEGIN
          BladHoofd;
          Regel:=10;
          WHILE (Error = 0) AND (Regel < PapierLengte-5) DO
          BEGIN
            Display_Data(FileData);
            Regel:=Regel+1;
            Aantal_Files := Aantal_Files + 1;
            FindNext(Error);
          END;
          IF Error=18 THEN
          BEGIN
            Writeln;
            Writeln(UsedBytes:6:0,' bytes in ',Aantal_Files,' files.');
            I:=Ord(Drive)-64;
            IF NOT I IN [1..3] THEN I:=0;
            GetDiskFreeSpace(I,Space,Fout);
            IF NOT Fout THEN
            BEGIN
              Writeln;Writeln(Space:6:0,' bytes free.');
            END;
          END;
          Writeln; Writeln;
          Write(^G,'press <RETURN> ....');Read(Kbd,Ch);
        END;
      END ELSE
      BEGIN
        Display(5,22,{25,10,}'* Bad input * ');
        Writeln('Path not found !');
        Writeln('Try again......');
       {Beep;}
        Delay(4000);
      END;
    END;
    FOR I:=10 TO 25 DO
    BEGIN
      GotoXY(1,I);
      ClrEol;
    END;
  UNTIL Ch='S';
  SetDTA(OldDTA_Seg,OldDTA_Ofs);
  Assign(FV,'a:HYDRODAT.COM');
  Execute(FV);
END.

(*END ===================== MSDOSDIR.PAS ============================*)
