(**********************************************************************
* MSDOSLIB.INC                                                        *
*                                                                     *
* CONTENTS                                                            *
*                                                                     *
* MISCELLANEOUS MSDOS DIRECTORY-PROCEDURES  TU DELFT / M.J.Vos / 1988 *
***********************************************************************
* SetCurSor; CurrentDisk; SetDTA; Datum; GetDTA; GetDiskFreeSpace     *
* FindFirst; FindNext.                                                *
**********************************************************************)

(*==================================================================*)
PROCEDURE SetCursor(CursorSize:Integer);
(*==================================================================*)

VAR
  Regs : RECORD
            AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags : Integer;
         END;

BEGIN
  WITH Regs DO
   BEGIN
     AX:=$0100;
     CX:=CursorSize;
  END;
  Intr($10,Regs);
END;{ SetCursor }


(*==================================================================*)
PROCEDURE CurrentDisk(VAR Drive:Char);
(*==================================================================*)

CONST
  Disk : ARRAY [0..2] OF Char = 'ABC';

VAR
  Regs : RECORD
            AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags : Integer;
         END;

BEGIN
  WITH Regs DO
  BEGIN
    AX := $1900;
    MSDOS(Regs);
    Drive:=Disk[(AX AND $00FF)];
  END;
END; { CurrentDisk }


(*==================================================================*)
PROCEDURE SetDTA(Segment,Offset:Integer);
(*==================================================================*)

VAR
  Regs : RECORD
            AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags : Integer;
         END;
BEGIN
  Regs.AX := $1A00;
  Regs.DS := Segment;
  Regs.DX := Offset;
  MSDOS( Regs );
END; { SetDTA  }


(*==================================================================*)
FUNCTION Datum:Str11;
(*==================================================================*)

TYPE
  Str3       = String [3];
  Str4       = String [4];

CONST
  Maand      : ARRAY [1..12] OF Str3  = ('Jan','Feb','Mrt','Apr','Mei','Jun',
                                         'Jul','Aug','Sep','Okt','Nov','Dec');
VAR
  Regs       : RECORD
                  AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags : Integer;
                END;
  Dag,Jaar   : Str4;

BEGIN
  WITH Regs DO
  BEGIN
    AX:=$2A00;
    MSDOS(Regs);
    Str(Lo(DX),Dag);
    Str(CX,Jaar);
    Datum:=Dag+'-'+Maand[Hi(DX)]+'-'+Jaar;
  END;
END; { Datum }

(*==================================================================*)
PROCEDURE GetDTA(VAR Segment,Offset:Integer);
(*==================================================================*)

VAR
  Regs : RECORD
            AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags : Integer;
          END;
BEGIN
  Regs.AX:=$2F00;
  MSDOS(Regs);
  Segment:=Regs.ES;
  Offset:=Regs.BX;
END; { GetDTA }

(*==================================================================*)
PROCEDURE GetDiskFreeSpace(Drive:Integer; VAR Space:Real; VAR Error:Boolean);
(*==================================================================*)

VAR
  Regs : RECORD
            AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags : Integer;
          END;

BEGIN
  WITH Regs DO
  BEGIN
    AX:=$3600;
    DX:=Drive;
    MSDOS(Regs);
    IF AX=$FFFF THEN Error:=True ELSE
    BEGIN
      Error:=False;
      Space:=AX*CX;
      Space:=Space*BX;
    END;
  END;
END; { GetDiskFreeSpace }


(*==================================================================*)
PROCEDURE FindFirst(Mask:Char80arr; Attribute:Integer; Var Error:Integer);
(*==================================================================*)

VAR
  Regs : RECORD
            AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags : Integer;
          END;
BEGIN
  Error:=0;
  Regs.AX:=$4E00;
  Regs.DS:=Seg( Mask );
  Regs.DX:=Ofs( Mask );
  Regs.CX:=Attribute;
  MSDOS(Regs);
  Error:=Regs.AX AND $FF;
END; { FindFirst }

(*==================================================================*)
PROCEDURE FindNext( VAR Error:Integer);
(*==================================================================*)

VAR
 Regs : RECORD
            AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags : Integer;
         END;
BEGIN
  Error:=0;
  Regs.AX:=$4F00;
  MSDOS(Regs);
  Error:=Regs.AX AND $FF;
END; { FindNext }

(* END ================ DOS-FUNCTIONS LIBRARY  =====================*)
